#!/usr/bin/env python
#
# THIS FILE WAS AUTO-GENERATED. DO NOT EDIT!
#
# Copyright (c) 2011-2015 of the Aqualid project, site: https://github.com/aqualid
#
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
# associated documentation files (the "Software"), to deal in the Software without restriction,
# including without limitation the rights to use, copy, modify, merge, publish, distribute,
# sublicense, and/or sell copies of the Software, and to permit persons to whom
# the Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all copies or
# substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
# INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
# AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
# DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

import binascii
import cProfile
import errno
import fnmatch
import gc
import hashlib
import imp
import inspect
import io
import itertools
import locale
import logging
import marshal
import mmap
import multiprocessing
import operator
import optparse
import os
import os.path
import pstats
import re
import shutil
import site
import sqlite3
import struct
import subprocess
import sys
import tarfile
import tempfile
import threading
import time
import traceback
import types
import weakref
import zipfile
class AqlInfo (object):
  __slots__ = (
    'name',
    'module',
    'description',
    'version',
    'date',
    'url',
    'license',
  )
  def   __init__(self):
    self.name         = "Aqualid"
    self.module       = "aqualid"
    self.description  = "General purpose build system."
    self.version      = "0.6.1"
    self.date         = None
    self.url          = 'https://github.com/aqualid'
    self.license      = "MIT License"
  def dump(self):
    result = "{name} {version}".format( name = self.name, version = self.version )
    if self.date:
      result += ' ({date})'.format( date = self.date )
    result += "\n"
    result += self.description
    result += "\nSite: %s" % self.url
    return result
_AQL_VERSION_INFO = AqlInfo()
def   getAqlInfo():
  return _AQL_VERSION_INFO
def   dumpAqlInfo():
  return _AQL_VERSION_INFO.dump()
class  AqlException (Exception):
  pass
try:
  uStr = unicode
except NameError:
  uStr = str
_try_encodings = []
for enc in [
            sys.stdout.encoding,
            locale.getpreferredencoding(False),
            sys.getfilesystemencoding(),
            sys.getdefaultencoding(),
            'utf-8',
          ]:
  if enc:
    enc = enc.lower()
    if enc not in _try_encodings:
      _try_encodings.append( enc )
def   encodeStr( value, encoding = None ):
  if encoding:
    return value.encode( encoding )
  error = None
  for encoding in _try_encodings:
    try:
      return value.encode( encoding )
    except UnicodeEncodeError as ex:
      if error is None:
        error = ex
  raise error
def   decodeBytes( obj, encoding = None, _try_encodings = _try_encodings ):
  if encoding:
    return uStr( obj, encoding )
  error = None
  for encoding in _try_encodings:
    try:
      return uStr( obj, encoding )
    except UnicodeDecodeError as ex:
      if error is None:
        error = ex
  raise error
def toUnicode( obj, encoding = None ):
  if isinstance( obj, (bytearray, bytes) ):
    return decodeBytes( obj, encoding )
  return uStr( obj )
if uStr is not str:
  def   isUnicode( value, uStr = uStr, isinstance = isinstance ):
    return isinstance(value, uStr)
  def   isString( value, uStr = uStr, str = str, isinstance = isinstance ):
    return isinstance( value, (uStr, str))
  def   toString( value, uStr = uStr, str = str, isinstance = isinstance ):
    if isinstance( value, (uStr, str)):
      return value
    return str( value )
  def castStr( obj, encoding = None, uStr = uStr ):
    if isinstance( obj, uStr ):
      return encodeStr( obj, encoding )
    return str( obj )
else:
  toString = toUnicode
  castStr = str
  def   isString( value, str = str, isinstance = isinstance ):
    return isinstance( value, str)
  isUnicode = isString
class   String (str):
  def     __new__( cls, value = None ):
    if type(value) is cls:
        return value
    if value is None:
        value = ''
    return super(String, cls).__new__(cls, value)
class   IgnoreCaseString (String):
  def   __hash__(self):
    return hash(self.lower())
  def   _cmp(self, other, op ):
    return op( self.lower(), str(other).lower())
  def   __eq__( self, other ):  return self._cmp( other, operator.eq )
  def   __ne__( self, other ):  return self._cmp( other, operator.ne )
  def   __lt__( self, other ):  return self._cmp( other, operator.lt )
  def   __le__( self, other ):  return self._cmp( other, operator.le )
  def   __gt__( self, other ):  return self._cmp( other, operator.gt )
  def   __ge__( self, other ):  return self._cmp( other, operator.ge )
class   LowerCaseString (str):
  def     __new__(cls, value = None ):
    if type(value) is cls:
        return value
    if value is None:
        value = ''
    else:
        value = str(value)
    return super(LowerCaseString, cls).__new__(cls, value.lower())
class   UpperCaseString (str):
  def     __new__(cls, value = None ):
    if type(value) is cls:
        return value
    if value is None:
        value = ''
    else:
        value = str(value)
    return super(UpperCaseString, cls).__new__(cls, value.upper())
class   Version (str):
  __ver_re = re.compile(r'[0-9]+[a-zA-Z]*(\.[0-9]+[a-zA-Z]*)*')
  def     __new__(cls, version = None, _ver_re = __ver_re ):
    if type(version) is cls:
        return version
    if version is None:
        ver_str = ''
    else:
        ver_str = str(version)
    match = _ver_re.search( ver_str )
    if match:
        ver_str = match.group()
        ver_list = re.findall(r'[0-9]+|[a-zA-Z]+', ver_str )
    else:
        ver_str = ''
        ver_list = []
    self = super(Version, cls).__new__(cls, ver_str )
    conv_ver_list = []
    for v in ver_list:
        if v.isdigit():
            v = int(v)
        conv_ver_list.append( v )
    self.__version = tuple(conv_ver_list)
    return self
  @staticmethod
  def   __convert( other ):
    return other if isinstance( other, Version ) else Version( other )
  def   _cmp( self, other, cmp_op ):
    self_ver = self.__version
    other_ver = self.__convert( other ).__version
    len_self = len(self_ver)
    len_other = len(other_ver)
    min_len = min( len_self, len_other )
    if min_len == 0:
      return cmp_op( len_self, len_other )
    self_ver = self_ver[:min_len]
    other_ver = other_ver[:min_len]
    return cmp_op( self_ver, other_ver )
  def   __hash__(self):         return hash(self.__version)
  def   __eq__( self, other ):  return self._cmp( other, operator.eq )
  def   __ne__( self, other ):  return self._cmp( other, operator.ne )
  def   __lt__( self, other ):  return self._cmp( other, operator.lt )
  def   __le__( self, other ):  return self._cmp( other, operator.le )
  def   __gt__( self, other ):  return self._cmp( other, operator.gt )
  def   __ge__( self, other ):  return self._cmp( other, operator.ge )
SIMPLE_TYPES_SET = frozenset( (uStr,str,int,float,complex,bool,bytes,bytearray) )
SIMPLE_TYPES = tuple(SIMPLE_TYPES_SET)
def isSimpleValue( value, _simple_types = SIMPLE_TYPES ):
  return isinstance( value, _simple_types )
def isSimpleType( value_type, _simple_types = SIMPLE_TYPES ):
  return issubclass( value_type, _simple_types )
class Singleton( object ):
  @staticmethod
  def   getInstance( cls ):
    try:
      instance = cls._instance
    except AttributeError:
      instance = cls._instance = __import__('__main__').__dict__.setdefault( (cls.__module__, cls.__name__ ), [None] )
    return instance[0]
  @staticmethod
  def   setInstance( cls, instance ):
    cls._instance[0] = instance
  @classmethod
  def   instance( cls, *args, **kw ):
    instance = Singleton.getInstance( cls )
    if instance is not None:
      return instance
    self = cls( *args, **kw )
    Singleton.setInstance( cls, self )
    return self
LOG_CRITICAL = logging.CRITICAL
LOG_ERROR = logging.ERROR
LOG_WARNING = logging.WARNING
LOG_INFO = logging.INFO
LOG_DEBUG = logging.DEBUG
class LogFormatter( object ):
  __slots__ = ('info', 'other')
  def   __init__(self):
    self.info = logging.Formatter()
    self.other = logging.Formatter("%(levelname)s: %(message)s")
  def formatTime(self, record, datefmt=None):
    if record.levelno == logging.INFO:
      return self.info.formatTime( record, datefmt = datefmt)
    else:
      return self.other.formatTime( record, datefmt = datefmt)
  def format(self, record ):
    if record.levelno == logging.INFO:
      return self.info.format( record )
    else:
      return self.other.format( record )
  def formatException(self, ei):
    return self.other.formatException( ei )
  def usesTime(self):
    return self.other.usesTime()
def   _makeAqlLogger():
  logger = logging.getLogger( "AQL" )
  handler = logging.StreamHandler()
  formatter = LogFormatter()
  handler.setFormatter(formatter)
  logger.addHandler( handler )
  logger.setLevel( logging.DEBUG )
  return logger
_logger = _makeAqlLogger()
setLogLevel   = _logger.setLevel
logCritical   = _logger.critical
logError      = _logger.error
logWarning    = _logger.warning
logInfo       = _logger.info
logDebug      = _logger.debug
addLogHandler = _logger.addHandler
class Tempfile (str):
  def     __new__( cls, prefix = 'tmp', suffix = '', dir = None, mode = 'w+b' ):
    handle = tempfile.NamedTemporaryFile( mode = mode, suffix = suffix, prefix = prefix, dir = dir, delete = False )
    self = super(Tempfile, cls).__new__(cls, handle.name)
    self.__handle = handle
    return self
  def   __enter__(self):
    return self
  def   __exit__(self, exc_type, exc_value, traceback):
    self.remove()
  def write( self, data ):
    self.__handle.write( data )
  def read( self, data ):
    self.__handle.read( data )
  def seek( self, offset ):
    self.__handle.seek( offset )
  def tell( self ):
    return self.__handle.tell()
  def flush( self ):
    if self.__handle is not None:
      self.__handle.flush()
  def close( self ):
    if self.__handle is not None:
      self.__handle.close()
      self.__handle = None
    return self
  def remove( self ):
    self.close()
    try:
      os.remove( self )
    except OSError as ex:
      if ex.errno != errno.ENOENT:
        raise
    return self
class Tempdir( str ):
  def     __new__( cls, prefix = 'tmp', suffix = '', dir = None, name = None ):
    if dir is not None:
      if not os.path.isdir( dir ):
        os.makedirs( dir )
    if name is None:
      path = tempfile.mkdtemp( prefix = prefix, suffix = suffix, dir = dir )
    else:
      if dir is not None:
        name = os.path.join( dir, name )
      path = os.path.abspath( name )
      if not os.path.isdir( path ):
        os.makedirs( path )
    return super(Tempdir, cls).__new__(cls, path)
  def   __enter__(self):
    return self
  def   __exit__(self, exc_type, exc_value, traceback):
    self.remove()
  def remove( self ):
    shutil.rmtree( self, ignore_errors = False )
if os.path.normcase('ABC') == os.path.normcase('abc'):
  FilePathBase = IgnoreCaseString
else:
  FilePathBase = String
try:
  _splitunc = os.path.splitunc
except AttributeError:
  def _splitunc( path ):
    return str(), path
class   FilePath (FilePathBase):
  def   __getnewargs__(self):
    return (str(self), )
  def   __getstate__(self):
    return {}
  def   __setstate__(self,state):
    pass
  def   __add__(self, other):
    return FilePath( super(FilePath,self).__add__( other ) )
  def   __iadd__(self, other):
    return FilePath( super(FilePath,self).__add__( other ) )
  def   __hash__( self ):
    return super(FilePath, self).__hash__()
  def   abspath(self):
    return FilePath( os.path.abspath(self) )
  def   normpath(self):
    return FilePath( os.path.normpath(self) )
  def   filename(self):
    return FilePath( os.path.basename(self) )
  def   dirname(self):
    return FilePath( os.path.dirname(self) )
  def   ext(self):
    return FilePathBase( os.path.splitext(self)[1] )
  def   name(self):
    return FilePathBase( os.path.splitext(self.filename())[0] )
  def   drive(self):
    drive, path = os.path.splitdrive( self )
    if not drive:
      drive, path = _splitunc( path )
    return FilePathBase( drive )
  def   change( self, dirname = None, name = None, ext = None, prefix = None ):
    self_dirname, self_filename = os.path.split( self )
    self_name, self_ext = os.path.splitext( self_filename )
    if dirname is None: dirname = self_dirname
    if name is None: name = self_name
    if ext is None: ext = self_ext
    if prefix: name = prefix + name
    return FilePath( os.path.join( dirname, name + ext ) )
  def   joinPath( self, *paths ):
    return FilePath( os.path.join( self, *paths ) )
class   AbsFilePath (FilePath):
  def     __new__( cls, value = None ):
    if type(value) is cls:
        return value
    if value is None:
        value = ''
    value = os.path.normcase( os.path.abspath( value ) )
    return super(AbsFilePath, cls).__new__(cls, value)
def   toSequence( value, iter = iter, tuple = tuple, isinstance = isinstance, uStr = uStr, bytes = bytes, bytearray = bytearray ):
  try:
    if not isinstance( value, (uStr, bytes, bytearray) ):
      iter( value )
      return value
  except TypeError:
    pass
  if value is None:
    return tuple()
  return ( value, )
def   isSequence( value, iter = iter, isinstance = isinstance, uStr = uStr, bytes = bytes, bytearray = bytearray ):
  try:
    if not isinstance( value, (uStr, bytes, bytearray) ):
      iter( value )
      return True
  except TypeError:
    return False
class   UniqueList (object):
  __slots__ = (
    '__values_list',
    '__values_set',
  )
  def     __init__( self, values = None ):
    self.__values_list = []
    self.__values_set = set()
    self.__addValues( values )
  def   __addValueFront( self, value ):
    values_set = self.__values_set
    values_list = self.__values_list
    if value in values_set:
      values_list.remove( value )
    else:
      values_set.add( value )
    values_list.insert( 0, value )
  def   __addValue( self, value ):
    values_set = self.__values_set
    values_list = self.__values_list
    if value not in values_set:
      values_set.add( value )
      values_list.append( value )
  def   __addValues( self, values ):
    values_set_add = self.__values_set.add
    values_list_append = self.__values_list.append
    values_set_size = self.__values_set.__len__
    values_list_size = self.__values_list.__len__
    for value in toSequence( values ):
      values_set_add( value )
      if values_set_size() > values_list_size():
        values_list_append( value )
  def   __addValuesFront( self, values ):
    values_set = self.__values_set
    values_list = self.__values_list
    values_set_add = values_set.add
    values_list_insert = values_list.insert
    values_set_size = values_set.__len__
    values_list_size = values_list.__len__
    values_list_index = values_list.index
    pos = 0
    for value in toSequence( values ):
      values_set_add( value )
      if values_set_size() == values_list_size():
        i = values_list_index( value )
        if i < pos:
          continue
        del values_list[ i ]
      values_list_insert( pos, value )
      pos += 1
  def   __removeValue( self, value ):
    try:
      self.__values_set.remove( value )
      self.__values_list.remove( value )
    except (KeyError, ValueError):
      pass
  def   __removeValues( self, values ):
    values_set_remove = self.__values_set.remove
    values_list_remove = self.__values_list.remove
    for value in toSequence( values ):
      try:
        values_set_remove( value )
        values_list_remove( value )
      except (KeyError, ValueError):
        pass
  def   __contains__( self, other ):
    return other in self.__values_set
  def   __len__( self ):
    return len(self.__values_list)
  def   __iter__( self ):
    return iter(self.__values_list)
  def   __reversed__( self ):
    return reversed(self.__values_list)
  def   __str__( self ):
      return str(self.__values_list)
  def   __eq__( self, other ):
    if isinstance( other, UniqueList ):
      return self.__values_set == other.__values_set
    return self.__values_set == set( toSequence( other ) )
  def   __ne__( self, other ):
    if isinstance( other, UniqueList ):
      return self.__values_set != other.__values_set
    return self.__values_set != set( toSequence( other ) )
  def   __lt__( self, other ):
    if not isinstance( other, UniqueList ):
      other = UniqueList( other )
    return self.__values_list < other.__values_list
  def   __le__( self, other ):
    if isinstance( other, UniqueList ):
      other = UniqueList( other )
    return self.__values_list <= other.__values_list
  def   __gt__( self, other ):
    if isinstance( other, UniqueList ):
      other = UniqueList( other )
    return self.__values_list > other.__values_list
  def   __ge__( self, other ):
    if isinstance( other, UniqueList ):
      other = UniqueList( other )
    return self.__values_list >= other.__values_list
  def   __getitem__(self, index ):
    return self.__values_list[ index ]
  def   __iadd__(self, values ):
    self.__addValues( values )
    return self
  def   __add__( self, values ):
    other = UniqueList( self )
    other.__addValues( values )
    return other
  def   __radd__( self, values ):
    other = UniqueList( values )
    other.__addValues( self )
    return other
  def   __isub__(self, values ):
    self.__removeValues( values )
    return self
  def   append( self, value ):
    self.__addValue( value )
  def   extend( self, values ):
    self.__addValues( values )
  def   reverse( self ):
    self.__values_list.reverse()
  def   append_front( self, value ):
    self.__addValueFront( value )
  def   extend_front( self, values ):
    self.__addValuesFront( values )
  def   remove( self, value ):
    self.__removeValue( value )
  def   pop( self ):
    value = self.__values_list.pop()
    self.__values_set.remove( value )
    return value
  def   pop_front( self ):
    value = self.__values_list.pop(0)
    self.__values_set.remove( value )
    return value
  def   selfTest( self ):
    size = len(self)
    if size != len(self.__values_list):
      raise AssertionError("size(%s) != len(self.__values_list)(%s)" % (size, len(self.__values_list)) )
    if size != len(self.__values_set):
      raise AssertionError("size(%s) != len(self.__values_set)(%s)" % (size, len(self.__values_set)) )
    if self.__values_set != set(self.__values_list):
      raise AssertionError( "self.__values_set != self.__values_list" )
class   List (list):
  def     __init__( self, values = None ):
    super( List, self).__init__( toSequence( values ) )
  def   __iadd__( self, values ):
    super(List,self).__iadd__( toSequence(values) )
    return self
  def   __add__( self, values ):
    other = List( self )
    other += List( self )
    return other
  def   __radd__( self, values ):
    other = List(values)
    other += self
    return other
  def   __isub__( self, values ):
    for value in toSequence(values):
      while True:
        try:
          self.remove( value )
        except ValueError:
          break
    return self
  @staticmethod
  def   __toList( values ):
    if isinstance( values, List ):
      return values
    return List( values )
  def   __eq__( self, other ):
    return super(List,self).__eq__( self.__toList( other ) )
  def   __ne__( self, other ):
    return super(List,self).__ne__( self.__toList( other ) )
  def   __lt__( self, other ):
    return super(List,self).__lt__( self.__toList( other ) )
  def   __le__( self, other ):
    return super(List,self).__le__( self.__toList( other ) )
  def   __gt__( self, other ):
    return super(List,self).__gt__( self.__toList( other ) )
  def   __ge__( self, other ):
    return super(List,self).__ge__( self.__toList( other ) )
  def   append_front( self, value ):
    self.insert( 0, value )
  def   extend( self, values ):
    super(List, self).extend( toSequence( values ) )
  def   extend_front( self, values ):
    self[:0] = toSequence( values )
  def   pop_front( self ):
    return self.pop(0)
def   SplitListType( list_type, separators ):
  separator = separators[0]
  other_separators = separators[1:]
  class   SplitList (list_type):
    @staticmethod
    def   __toSequence( values, separator = separator, other_separators = other_separators ):
      if not isString( values ):
        return values
      for sep in other_separators:
        values = values.replace( sep, separator )
      return filter( None, values.split( separator ))
    @staticmethod
    def   __toSplitList( values ):
      if isinstance( values, SplitList ):
        return values
      return SplitList( values )
    def     __init__( self, values = None ):
      super(SplitList,self).__init__( self.__toSequence( values ) )
    def   __iadd__( self, values ):
      return super(SplitList,self).__iadd__( self.__toSequence( values ) )
    def   __isub__( self, values ):
      return super(SplitList,self).__isub__( self.__toSequence( values ) )
    def   extend( self, values ):
      super(SplitList,self).extend( self.__toSequence( values ) )
    def   extend_front( self, values ):
      super(SplitList,self).extend_front( self.__toSequence( values ) )
    def   __eq__( self, other ):
      return super(SplitList,self).__eq__( self.__toSplitList( other ) )
    def   __ne__( self, other ):
      return super(SplitList,self).__ne__( self.__toSplitList( other ) )
    def   __lt__( self, other ):
      return super(SplitList,self).__lt__( self.__toSplitList( other ) )
    def   __le__( self, other ):
      return super(SplitList,self).__le__( self.__toSplitList( other ) )
    def   __gt__( self, other ):
      return super(SplitList,self).__gt__( self.__toSplitList( other ) )
    def   __ge__( self, other ):
      return super(SplitList,self).__ge__( self.__toSplitList( other ) )
    def   __str__( self ):
      return separator.join( map( castStr, iter(self) ) )
  return SplitList
def   ValueListType( list_type, value_type ):
  class   _ValueList (list_type):
    @staticmethod
    def   __toSequence( values ):
      if isinstance( values, _ValueList ):
        return values
      return map( value_type, toSequence(values) )
    @staticmethod
    def   __toValueList( values ):
      if isinstance( values, _ValueList):
        return values
      return _ValueList(values)
    def     __init__( self, values = None ):
      super(_ValueList,self).__init__( self.__toSequence( values ) )
    def   __iadd__( self, values ):
      return super(_ValueList,self).__iadd__( self.__toValueList( values ) )
    def   __isub__( self, values ):
      return super(_ValueList,self).__isub__( self.__toValueList( values ) )
    def   extend( self, values ):
      super(_ValueList,self).extend( self.__toValueList( values ) )
    def   extend_front( self, values ):
      super(_ValueList,self).extend_front( self.__toValueList( values ) )
    def   append( self, value ):
      super(_ValueList,self).append( value_type(value) )
    def   count( self, value ):
      return super(_ValueList,self).count( value_type(value) )
    def   index( self, value, i = 0, j = -1 ):
      return super(_ValueList,self).index( value_type(value), i, j )
    def   insert( self, i, value ):
      return super(_ValueList,self).insert( i, value_type(value) )
    def   remove( self, value ):
      return super(_ValueList,self).remove( value_type(value) )
    def   __setitem__( self, index, value ):
      if type(index) is slice:
        value = self.__toValueList( value )
      else:
        value = value_type(value)
      return super(_ValueList,self).__setitem__( index, value )
    def   __eq__( self, other ):
      return super(_ValueList,self).__eq__( self.__toValueList( other ) )
    def   __ne__( self, other ):
      return super(_ValueList,self).__ne__( self.__toValueList( other ) )
    def   __lt__( self, other ):
      return super(_ValueList,self).__lt__( self.__toValueList( other ) )
    def   __le__( self, other ):
      return super(_ValueList,self).__le__( self.__toValueList( other ) )
    def   __gt__( self, other ):
      return super(_ValueList,self).__gt__( self.__toValueList( other ) )
    def   __ge__( self, other ):
      return super(_ValueList,self).__ge__( self.__toValueList( other ) )
    def   __contains__( self, other ):
      return super(_ValueList,self).__contains__( value_type(other) )
  return _ValueList
try:
  import queue
except ImportError:
  import Queue as queue # python 2
class _StopException( Exception ):
  pass
class   _StopTask( object ):
  __slots__ = (
    'task_id',
  )
  def __init__(self):
    self.task_id = None
  def   __lt__(self, other):
    return True
  def   __call__(self):
    raise _StopException()
_stop_task = _StopTask()
class _Task( object ):
  __slots__ = (
    'priority',
    'task_id',
    'func',
    'args',
    'kw'
  )
  def   __init__(self, priority, task_id, func, args, kw ):
    self.priority, self.task_id, self.func, self.args, self.kw = priority, task_id, func, args, kw
  def   __lt__(self, other):
    if isinstance( other, _StopTask ):
      return False
    return self.priority < other.priority
  def   __call__(self):
    return self.func(*self.args, **self.kw)
class TaskResult (object):
  __slots__ = ('task_id', 'error', 'result')
  def   __init__(self, task_id = None, result = None, error = None ):
    self.task_id = task_id
    self.result = result
    self.error = error
  def   __lt__(self, other):
    return (self.task_id, self.result, self.error) < (other.task_id, other.result, other.error)
  def   __eq__(self, other):
    return (self.task_id, self.result, self.error) == (other.task_id, other.result, other.error)
  def   __ne__(self, other):
    return not self.__eq__(other)
  def   __str__(self):
    return "task_id: %s, result: %s, error: %s" % (self.task_id, self.result, self.error)
class _TaskExecutor( threading.Thread ):
  def __init__(self, tasks, finished_tasks, stop_on_error, stop_event, with_backtrace ):
    super(_TaskExecutor,self).__init__()
    self.tasks            = tasks
    self.finished_tasks   = finished_tasks
    self.stop_on_error    = stop_on_error
    self.stop_event       = stop_event
    self.daemon           = True  # let that main thread to exit even if task threads are still active
    self.with_backtrace   = with_backtrace
    self.start()
  def run(self):
    tasks             = self.tasks
    finished_tasks    = self.finished_tasks
    is_stopped        = self.stop_event.is_set
    while not is_stopped():
      task = tasks.get()
      task_id = task.task_id
      task_result = TaskResult( task_id = task_id ) if task_id is not None else None
      try:
        result = task()
        if task_result is not None:
          task_result.result = result
      except _StopException:
        task_result = None
        break
      except (Exception, BaseException) as ex:
        task_result.error = "Internal error"
        if self.with_backtrace:
          err = traceback.format_exc()
        else:
          err = str(ex)
        if task_id is not None:
          task_result.error = err
        else:
          logWarning( "Task failed with error: %s" % (err,) )
        if self.stop_on_error:
          self.stop_event.set()
          break
      finally:
        if task_result is not None:
          finished_tasks.put( task_result )
        tasks.task_done()
class TaskManager (object):
  __slots__ = (
    'lock',
    'threads',
    'tasks',
    'finished_tasks',
    'unfinished_tasks',
    'stop_on_error',
    'stop_event',
    'with_backtrace',
  )
  def   __init__(self, num_threads, stop_on_fail = False, with_backtrace = True ):
    self.tasks            = queue.PriorityQueue()
    self.finished_tasks   = queue.Queue()
    self.lock             = threading.Lock()
    self.unfinished_tasks = 0
    self.threads          = []
    self.stop_on_error    = stop_on_fail
    self.stop_event       = threading.Event()
    self.with_backtrace   = with_backtrace
    self.start( num_threads )
  def   start( self, num_threads ):
    with self.lock:
      if self.stop_event.is_set():
        self.__stop()
      threads = self.threads
      num_threads -= len(threads)
      while num_threads > 0:
        num_threads -= 1
        t = _TaskExecutor( self.tasks, self.finished_tasks, self.stop_on_error, self.stop_event, self.with_backtrace )
        threads.append( t )
  def   __stop( self ):
    threads = self.threads
    if not threads:
      return
    for t in threads:
      self.tasks.put( _stop_task )
    for t in threads:
      t.join()
    self.threads = []
    self.tasks = queue.PriorityQueue()
    self.stop_event.clear()
  def   stop( self ):
    self.stop_event.set()
    with self.lock:
      self.__stop()
  def   addTask( self, priority, task_id, function, *args, **kw ):
    with self.lock:
      task = _Task( priority, task_id, function, args, kw )
      self.tasks.put( task )
      if task_id is not None:
        self.unfinished_tasks += 1
  def   finishedTasks( self, block = True ):
    result = []
    is_stopped = self.stop_event.is_set
    finished_tasks = self.finished_tasks
    with self.lock:
      if is_stopped():
        self.__stop()
      if block:
        block = (self.unfinished_tasks > 0) and self.threads
      while True:
        try:
          task_result = finished_tasks.get( block = block )
          block = False
          result.append( task_result )
          finished_tasks.task_done()
        except queue.Empty:
          if self.tasks.empty() and not self.threads:
            self.unfinished_tasks = 0
            return result
          break
      self.unfinished_tasks -= len( result )
      assert self.unfinished_tasks >= 0
    return result
class   Dict (dict):
  @staticmethod
  def   toItems( items ):
    if not items or (items is NotImplemented):
      return tuple()
    try:
      items = items.items
    except AttributeError:
      return items
    return items()
  def   __init__( self, items = None ):
    super( Dict, self).__init__( self.toItems( items ) )
  def   __iadd__( self, items ):
    for key, value in self.toItems( items ):
      try:
        self[key] += value
      except KeyError:
        self[key] = value
    return self
  def   copy( self, key_type = None, value_type = None ):
    other = Dict()
    for key, value in self.items():
      if key_type:    key = key_type( key )
      if value_type:  value = value_type( value )
      other[ key ] = value
    return other
def   SplitDictType( dict_type, separators ):
  separator = separators[0]
  other_separators = separators[1:]
  class   SplitDict (dict_type):
    @staticmethod
    def   __toItems( items_str, sep = separator, other_seps = other_separators ):
      if not isString( items_str ):
        return items_str
      for s in other_seps:
        items_str = items_str.replace( s, sep )
      items = []
      for v in filter( None, items_str.split( sep ) ):
        key, sep, value = v.partition('=')
        items.append( (key, value) )
      return items
    @staticmethod
    def   __toSplitDict( items ):
      if isinstance( items, SplitDict ):
        return items
      return SplitDict( items )
    def     __init__( self, items = None ):
      super(SplitDict,self).__init__( self.__toItems( items ) )
    def   __iadd__( self, items ):
      return super(SplitDict,self).__iadd__( self.__toItems( items ) )
    def update(self, other = None, **kwargs):
      other = self.__toItems( other )
      super(SplitDict,self).update( other )
      items = self.__toItems( kwargs )
      super(SplitDict,self).update( items )
    def   __eq__( self, other ):
      return super(SplitDict,self).__eq__( self.__toSplitDict( other ) )
    def   __ne__( self, other ):
      return super(SplitDict,self).__ne__( self.__toSplitDict( other ) )
    def   __lt__( self, other ):
      return super(SplitDict,self).__lt__( self.__toSplitDict( other ) )
    def   __le__( self, other ):
      return super(SplitDict,self).__le__( self.__toSplitDict( other ) )
    def   __gt__( self, other ):
      return super(SplitDict,self).__gt__( self.__toSplitDict( other ) )
    def   __ge__( self, other ):
      return super(SplitDict,self).__ge__( self.__toSplitDict( other ) )
    def   __str__( self ):
      return separator.join( sorted( "%s=%s" % (key,value) for key, value in self.items() ) )
  return SplitDict
def   ValueDictType( dict_type, key_type, default_value_type = None ):
  class   _ValueDict (dict_type):
    __VALUE_TYPES = {}
    @staticmethod
    def   getKeyType():
      return key_type
    @staticmethod
    def   getValueType():
      return default_value_type
    @staticmethod
    def   _toValue( key, value, val_types = __VALUE_TYPES, val_type = default_value_type ):
      try:
        if val_type is None:
          val_type = val_types[ key ]
        if isinstance(value, val_type):
          return value
        value = val_type( value )
      except KeyError:
        pass
      _ValueDict.setValueType( key, type(value) )
      return value
    @staticmethod
    def   setValueType( key, value_type, value_types = __VALUE_TYPES, default_type = default_value_type ):
      if default_type is None:
        if value_type is list:
          value_type = List
        if value_type is dict:
          value_type = Dict
        value_types[ key ] = value_type
    @staticmethod
    def   __toItems( items, key_type = key_type ):
      if isinstance( items, _ValueDict ):
        return items
      items_tmp = []
      try:
        for key, value in Dict.toItems( items ):
          key = key_type( key )
          value = _ValueDict._toValue( key, value )
          items_tmp.append( (key, value) )
        return items_tmp
      except ValueError:
        raise
    @staticmethod
    def   __toValueDict( items, key_type = key_type ):
      if isinstance( items, _ValueDict ):
        return items
      return _ValueDict( items )
    def   __init__( self, values = None ):
      super(_ValueDict,self).__init__( self.__toItems( values ) )
    def   __iadd__( self, values ):
      return super(_ValueDict,self).__iadd__( self.__toItems( values ) )
    def   get( self, key, default = None ):
      return super(_ValueDict,self).get( key_type( key ), default )
    def   __getitem__( self, key ):
      return super(_ValueDict,self).__getitem__( key_type( key ) )
    def   __setitem__( self, key, value ):
      key = key_type( key )
      return super(_ValueDict,self).__setitem__( key, _ValueDict._toValue( key, value ) )
    def   __delitem__( self, key ):
      return super(_ValueDict,self).__delitem__( key_type(key) )
    def   pop( self, key, *args ):
      return super(_ValueDict,self).pop( key_type(key), *args )
    def setdefault(self, key, default ):
      key = key_type(key)
      default = _ValueDict._toValue( key, default )
      return super(_ValueDict,self).setdefault( key, default )
    def update(self, other = None, **kwargs):
      other = self.__toItems( other )
      super(_ValueDict,self).update( other )
      items = self.__toItems( kwargs )
      super(_ValueDict,self).update( items )
    def   __eq__( self, other ):
      return super(_ValueDict,self).__eq__( self.__toValueDict( other ) )
    def   __ne__( self, other ):
      return super(_ValueDict,self).__ne__( self.__toValueDict( other ) )
    def   __lt__( self, other ):
      return super(_ValueDict,self).__lt__( self.__toValueDict( other ) )
    def   __le__( self, other ):
      return super(_ValueDict,self).__le__( self.__toValueDict( other ) )
    def   __gt__( self, other ):
      return super(_ValueDict,self).__gt__( self.__toValueDict( other ) )
    def   __ge__( self, other ):
      return super(_ValueDict,self).__ge__( self.__toValueDict( other ) )
    def   __contains__( self, key ):
      return super(_ValueDict,self).__contains__( key_type(key) )
  return _ValueDict
try:
  zip_longest = itertools.zip_longest
except AttributeError:
  zip_longest = itertools.izip_longest
class   ErrorOptionTypeEnumAliasIsAlreadySet( AqlException ):
  def   __init__( self, option, value, current_value, new_value ):
    msg = "Alias '%s' of Enum Option '%s' can't be changed to '%s' from '%s'" % (value, option, new_value, current_value )
    super(type(self), self).__init__( msg )
class   ErrorOptionTypeEnumValueIsAlreadySet( AqlException ):
  def   __init__( self, option, value, new_value ):
    msg = "Value '%s' of Enum Option '%s' can't be changed to alias to '%s'" % (value, option, new_value )
    super(type(self), self).__init__( msg )
class   ErrorOptionTypeUnableConvertValue( TypeError ):
  def   __init__( self, option_help, invalid_value ):
    if isinstance( option_help, OptionType ):
      option_help = option_help.help()
    self.option_help = option_help
    self.invalid_value = invalid_value
    msg = "Unable to convert value '%s (%s)' to option %s" % (invalid_value, type(invalid_value), option_help.errorText())
    super(type(self), self).__init__( msg )
class   ErrorOptionTypeNoEnumValues( TypeError ):
  def   __init__( self, option_type ):
    msg = "Enum option type '%s' doesn't have any values." % (option_type,)
    super(type(self), self).__init__( msg )
class   ErrorOptionTypeCantDeduce( AqlException ):
  def   __init__( self, value ):
    msg = "Unable to deduce option type from value type: '%s." % (type(value),)
    super(type(self), self).__init__( msg )
def   autoOptionType( value ):
  is_seq = False
  unique = False
  if isinstance( value, (UniqueList, list, tuple) ):
    is_seq = True
  elif isinstance( value, (UniqueList, set, frozenset) ):
    is_seq = True
    unique = True
  if is_seq:
    value_type = str
    try:
      value_type = next(iter(value))
    except StopIteration:
      pass
    opt_type = ListOptionType( value_type = value_type, unique = unique )
  elif isinstance( value, dict ):
    opt_type = DictOptionType()
  elif isinstance( value, bool ):
    opt_type = BoolOptionType()
  elif isinstance( value, IgnoreCaseString ):
    opt_type = StrOptionType( ignore_case = True )
  elif isString( value ):
    opt_type = StrOptionType()
  elif isinstance( value, Version ):
    opt_type = VersionOptionType()
  elif isinstance( value, FilePath ):
    opt_type = PathOptionType()
  elif isSimpleValue( value ):
    opt_type = OptionType( value_type = type(value) )
  else:
    raise ErrorOptionTypeCantDeduce( value )
  opt_type.is_auto = True
  return opt_type
def   _getTypeName( value_type ):
  if issubclass( value_type, bool ):
    name = "boolean"
  elif issubclass( value_type, int ):
    name = "integer"
  elif issubclass( value_type, IgnoreCaseString ):
    name = "case insensitive string"
  elif issubclass( value_type, (str, uStr) ):
    name = "string"
  else:
    name = value_type.__name__
  return name.title()
def   _joinToLength( values, max_length = 0, separator = "", prefix = "", suffix = "" ):
  result = []
  current_value = ""
  for value in values:
    value = prefix + value + suffix
    if len(current_value) + len(value) > max_length:
      if current_value:
        current_value += separator
        result.append( current_value )
        current_value = ""
    if current_value:
      current_value += separator
    current_value += value
  if current_value:
    result.append( current_value )
  return result
def   _indentItems( indent_value, values ):
  result = []
  indent_spaces = ' ' * len(indent_value)
  for value in values:
    if value:
      if result:
        value = indent_spaces + value
      else:
        value = indent_value + value
    result.append( value )
  return result
def   _mergeLists( values1, values2, indent_size ):
  result = []
  max_name    = max( values1, key = len)
  indent_size = max( indent_size, len(max_name) ) + 1
  for left, right in zip_longest( values1, values2, fillvalue = "" ):
    if not right:
      right_indent = ""
    else:
      right_indent = ' ' * (indent_size - len(left))
    value = left + right_indent + right
    result.append( value )
  return result
class OptionHelp( object ):
  __slots__ = (
    'option_type',
    '_names',
    'type_name',
    'allowed_values',
    'current_value',
  )
  def   __init__(self, option_type ):
    self.option_type = option_type
    help_type = option_type.helpType()
    self.type_name = help_type if help_type else None
    help_range = option_type.helpRange()
    self.allowed_values = help_range if help_range else None
    self._names = []
    self.current_value = None
  @property
  def   is_key(self):
    return self.option_type.is_tool_key
  @property
  def   group(self):
    return self.option_type.group
  @property
  def   description(self):
    return self.option_type.description
  @property
  def   names(self):
    return self._names
  @names.setter
  def   names(self, names):
    self._names = sorted( names, key = str.lower )
  def   isHidden(self):
    return not bool(self.description) or self.option_type.is_hidden
  def   _currentValue( self, details ):
    if self.current_value is not None:
      if isinstance( self.current_value, (list, tuple, UniqueList)):
        current_value = [ toString(v) for v in self.current_value ]
        if current_value:
          current_value = _joinToLength( current_value, 64, separator = ",", prefix= "'", suffix="'")
          current_value = _indentItems( "[ ", current_value )
          current_value[-1] += " ]"
          details.extend( current_value )
        else:
          details.append( "[]" )
      else:
        current_value = self.option_type.toStr( self.current_value )
        if not current_value:
          current_value = "''"
        details.append( current_value )
    else:
      details.append( "N/A" )
  def   text( self, brief = False, names_indent = 0 ):
    details = []
    self._currentValue( details )
    if not brief:
      if self.description:
        details.append( self.description )
      if self.type_name:
        details.append( "Type: " + self.type_name )
      if self.allowed_values:
        details += _indentItems( "Allowed values: ", self.allowed_values )
    details = _indentItems( ": ", details )
    result = []
    if self.names:
      names = self.names
      key_marker = '* ' if self.is_key else '  '
      names = [ key_marker + name for name in names ]
      details = _mergeLists( names, details, names_indent + 2 )
    result += details
    return result
  def   errorText(self):
    result = []
    if self.names:
      result.append( ', '.join( self.names ) )
    if self.type_name:
      result.append( "Type: " + self.type_name )
    if self.allowed_values:
      result.append( "Allowed values: %s" % ', '.join( self.allowed_values ) )
    return '. '.join( result )
class   OptionHelpGroup( object ):
  __slots__ = (
    'name',
    'max_option_name_length',
    'help_list',
  )
  def   __init__(self, group_name ):
    self.name = group_name
    self.max_option_name_length = 0
    self.help_list = []
  def   append( self, option_help ):
    self.max_option_name_length = max( self.max_option_name_length, len(max( option_help.names, key = len )) )
    self.help_list.append( option_help )
  def   __iter__(self):
    return iter(self.help_list)
  def text( self, brief = False, indent = 0 ):
    result = []
    group_name = self.name
    if group_name:
      group_name = "%s:" % (group_name,)
      group_border_bottom = "-" * len(group_name)
      result.extend( [ group_name, group_border_bottom ] )
    names_indent = self.max_option_name_length
    self.help_list.sort( key = operator.attrgetter('names') ) 
    for option_help in self.help_list:
      opt_text = option_help.text( brief, names_indent )
      if (len(opt_text) > 1) and result and result[-1]:
        result.append("")
      result.extend( opt_text )
      if len(opt_text) > 1:
        result.append("")
    if indent:
      result = _indentItems( ' ' * indent, result )
    return result
class   OptionType (object):
  __slots__ = (
    'value_type',
    'default',
    'description',
    'group',
    'range_help',
    'is_auto',
    'is_tool_key',
    'is_hidden',
  )
  def     __init__( self, value_type = str, description = None, group = None, range_help = None, default = NotImplemented,
                    is_tool_key = False, is_hidden = False ):
    if issubclass( value_type, OptionType ):
      value_type = value_type()
    self.value_type = value_type
    self.is_auto = False
    self.is_tool_key = is_tool_key
    self.is_hidden = is_hidden
    self.description = description
    self.group = group
    self.range_help = range_help
    if default is NotImplemented:
      self.default = NotImplemented
    else:
      self.default = value_type( default )
  def   __call__( self, value = NotImplemented ):
    """
    Converts a value to options' value
    """
    try:
      if value is NotImplemented:
        if self.default is NotImplemented:
          return self.value_type()
        return self.default
      return self.value_type( value )
    except (TypeError, ValueError):
      raise ErrorOptionTypeUnableConvertValue( self, value )
  def   toStr( self, value ):
    """
    Converts a value to options' value string
    """
    return toString( value )
  def   help(self):
    return OptionHelp( self )
  def   helpType(self):
    return _getTypeName( self.value_type )
  def     helpRange( self ):
    """
    Returns a description (list of strings) about range of allowed values
    """
    if self.range_help:
      return list(toSequence( self.range_help ))
    return []
class   StrOptionType (OptionType):
  def     __init__( self, ignore_case = False, description = None, group = None, range_help = None,
                    is_tool_key = False, is_hidden = False ):
    value_type = IgnoreCaseString if ignore_case else String
    super(StrOptionType, self).__init__( value_type, description, group, range_help, is_tool_key = is_tool_key, is_hidden = is_hidden )
class   VersionOptionType (OptionType):
  def     __init__( self, description = None, group = None, range_help = None, is_tool_key = False, is_hidden = False ):
    super(VersionOptionType, self).__init__( Version, description, group, range_help, is_tool_key = is_tool_key, is_hidden = is_hidden )
  def   helpType(self):
    return "Version String"
class   PathOptionType (OptionType):
  def     __init__( self, description = None, group = None, range_help = None, is_tool_key = False, is_hidden = False, default = NotImplemented ):
    super(PathOptionType, self).__init__( FilePath, description, group, range_help,
                                          is_tool_key = is_tool_key, is_hidden = is_hidden, default = default )
  def   helpType(self):
    return "File System Path"
class   AbsPathOptionType (OptionType):
  def     __init__( self, description = None, group = None, range_help = None, is_tool_key = False, is_hidden = False, default = NotImplemented ):
    super(AbsPathOptionType, self).__init__( AbsFilePath, description, group, range_help,
                                             is_tool_key = is_tool_key, is_hidden = is_hidden, default = default )
  def   helpType(self):
    return "File System Path"
class   BoolOptionType (OptionType):
  __slots__ = (
    'true_value',
    'false_value',
    'true_values',
    'false_values',
    'aliases',
  )
  __true_values = ('yes', 'true', 'on', 'enabled', 'y', '1', 't' )
  __false_values = ('no', 'false', 'off', 'disabled', 'n', '0', 'f' )
  def   __init__( self, description = None, group = None, style = None, true_values = None, false_values = None,
                  default = False, is_tool_key = False, is_hidden = False ):
    super(BoolOptionType,self).__init__( bool, description, group, default = default, is_tool_key = is_tool_key, is_hidden = is_hidden )
    if style is None:
      style = ('true', 'false')
    else:
      style = map(IgnoreCaseString, style)
    if true_values is None:
      true_values = self.__true_values
    else:
      true_values = toSequence( true_values )
    if false_values is None:
      false_values = self.__false_values
    else:
      false_values = toSequence( false_values )
    self.true_value, self.false_value = style
    self.true_values  = set()
    self.false_values = set()
    self.addValues( true_values, false_values )
    self.addValues( self.true_value, self.false_value )
  def   __call__( self, value = NotImplemented ):
    if type(value) is bool:
      return value
    if value is NotImplemented:
      value = self.default
    value_str = IgnoreCaseString(value)
    if value_str in self.true_values:
      return True
    if value_str in self.false_values:
      return False
    return True if value else False
  def   toStr( self, value ):
    return self.true_value if value else self.false_value
  def   addValues( self, true_values, false_values ):
    true_values = toSequence( true_values )
    false_values = toSequence( false_values )
    self.true_values.update( map( IgnoreCaseString,  true_values  ) )
    self.false_values.update( map( IgnoreCaseString, false_values  ) )
  def     helpRange( self ):
    def _makeHelp( value, values ):
      values = list(values)
      values.remove( value )
      if values:
        values = ', '.join( sorted( values ) )
        return "%s (or %s)" % (value, values )
      return "%s" % (value,)
    return  [ _makeHelp( self.true_value, self.true_values ),
              _makeHelp( self.false_value, self.false_values ), ]
class   EnumOptionType (OptionType):
  __slots__ = (
    '__values',
    'strict',
  )
  def   __init__( self, values, description = None, group = None, value_type = IgnoreCaseString,
                  default = NotImplemented, strict = True,
                  is_tool_key = False, is_hidden = False ):
    super(EnumOptionType,self).__init__( value_type, description, group, default = default,
                                         is_tool_key = is_tool_key, is_hidden = is_hidden )
    self.__values = {}
    if default is not NotImplemented:
      self.addValues( default )
    self.addValues( values )
    self.strict = strict
  def   addValues( self, values ):
    try:
      values = tuple( values.items() )  # convert dictionary to a sequence
    except AttributeError:
      pass
    set_default_value = self.__values.setdefault
    value_type = self.value_type
    for value in toSequence(values):
      it = iter( toSequence( value ) )
      value = value_type( next( it ) )
      value = set_default_value( value, value )
      for alias in it:
        alias = value_type(alias)
        v = set_default_value( alias, value )
        if v != value:
          if alias == v:
            raise ErrorOptionTypeEnumValueIsAlreadySet( self, alias, value )
          else:
            raise ErrorOptionTypeEnumAliasIsAlreadySet( self, alias, v, value )
  def   __call__( self, value = NotImplemented ):
    if value is NotImplemented:
      value = self.default
      if value is not NotImplemented:
        return value
      try:
        value = next(iter(self.__values.values()))
        return value
      except StopIteration:
        if self.strict:
          raise ErrorOptionTypeNoEnumValues( self )
        else:
          return self.value_type()
    try:
      value = self.value_type( value )
    except (TypeError, ValueError):
      raise ErrorOptionTypeUnableConvertValue( self, value )
    result = self.__values.get( value, None )
    if result is None:
      if self.strict:
        raise ErrorOptionTypeUnableConvertValue( self, value )
      else:
        return value
    return result
  def   helpRange(self):
    values = {}
    for alias, value in self.__values.items():
      if alias is value:
        values.setdefault( alias, [] )
      else:
        values.setdefault( value, [] ).append( alias )
    help_str = []
    for value, aliases in values.items():
      s = toString(value)
      if aliases:
        s += ' (or ' + ', '.join( map( toString, aliases ) ) + ')'
      help_str.append( s )
    return help_str
  def   range( self ):
    values = []
    for alias, value in self.__values.items():
      if alias is value:
        values.append( alias )
    return values
class   RangeOptionType (OptionType):
  __slots__ = (
    'min_value',
    'max_value',
    'coerce',
  )
  def   __init__( self, min_value, max_value, description = None, group = None, value_type = int, coerce = True,
                  default = NotImplemented, is_tool_key = False, is_hidden = False ):
    super(RangeOptionType,self).__init__( value_type, description, group, default = default,
                                          is_tool_key = is_tool_key, is_hidden = is_hidden )
    self.setRange( min_value, max_value, coerce )
    if default is not NotImplemented:
      self.default = self( default )
  def   setRange( self, min_value, max_value, coerce = True ):
    if min_value is not None:
      try:
        min_value = self.value_type( min_value )
      except (TypeError, ValueError):
        raise ErrorOptionTypeUnableConvertValue( self, min_value )
    else:
      min_value = self.value_type()
    if max_value is not None:
      try:
        max_value = self.value_type( max_value )
      except (TypeError, ValueError):
        raise ErrorOptionTypeUnableConvertValue( self, max_value )
    else:
      max_value = self.value_type()
    self.min_value = min_value
    self.max_value = max_value
    if coerce is not None:
      self.coerce = coerce
  def   __call__( self, value = NotImplemented):
    try:
      min_value = self.min_value
      if value is NotImplemented:
        if self.default is NotImplemented:
          return min_value
        value = self.default
      value = self.value_type( value )
      if value < min_value:
        if self.coerce:
          value = min_value
        else:
          raise TypeError()
      max_value = self.max_value
      if value > max_value:
        if self.coerce:
          value = max_value
        else:
          raise TypeError()
      return value
    except TypeError:
      raise ErrorOptionTypeUnableConvertValue( self, value )
  def   helpRange(self):
    return ["%s ... %s" % (self.min_value, self.max_value) ]
  def   range( self ):
    return [self.min_value, self.max_value]
class   ListOptionType (OptionType):
  __slots__ = ('item_type',)
  def   __init__( self, value_type = str, unique = False, separators = ', ', description = None, group = None,
                  range_help = None, is_tool_key = False, is_hidden = False ):
    if isinstance(value_type, OptionType):
      if description is None:
        description = value_type.description
        if description:
          description = "List of: " + description
      if group is None:
        group = value_type.group
      if range_help is None:
        range_help = value_type.range_help
    if unique:
      list_type = UniqueList
    else:
      list_type = List
    list_type = ValueListType( list_type, value_type )
    if separators:
      list_type = SplitListType( list_type, separators )
    super(ListOptionType,self).__init__( list_type, description, group, range_help, is_tool_key = is_tool_key, is_hidden = is_hidden )
    self.item_type = value_type
  def   __call__( self, values = None ):
    try:
      if values is NotImplemented:
        values = []
      return self.value_type( values )
    except (TypeError, ValueError):
      raise ErrorOptionTypeUnableConvertValue( self, values )
  def   helpType(self):
    if isinstance(self.item_type, OptionType):
      item_type = self.item_type.helpType()
    else:
      item_type = _getTypeName( self.item_type )
    return "List of %s" % item_type
  def     helpRange( self ):
    if self.range_help:
      return list(toSequence( self.range_help ))
    if isinstance(self.item_type, OptionType):
      return self.item_type.helpRange()
    return []
class   DictOptionType (OptionType):
  def   __init__( self, key_type = str, value_type = None, separators = ', ', description = None, group = None,
                  range_help = None, is_tool_key = False, is_hidden = False ):
    if isinstance(value_type, OptionType):
      if description is None:
        description = value_type.description
        if description:
          description = "List of: " + description
      if group is None:
        group = value_type.group
      if range_help is None:
        range_help = value_type.range_help
    dict_type = ValueDictType( Dict, key_type, value_type )
    if separators:
      dict_type = SplitDictType( dict_type, separators )
    super(DictOptionType,self).__init__( dict_type, description, group, range_help,
                                         is_tool_key = is_tool_key, is_hidden = is_hidden )
  def   setValueType( self, key, value_type ):
    if isinstance( value_type, OptionType ):
      value_type = value_type.value_type
    self.value_type.setValueType( key, value_type )
  def   __call__( self, values = None ):
    try:
      if values is NotImplemented:
        values = None
      return self.value_type( values )
    except (TypeError, ValueError):
      raise ErrorOptionTypeUnableConvertValue( self, values )
  def   helpType(self):
    value_type = self.value_type.getValueType()
    if value_type is not None:
      if isinstance(value_type, OptionType):
        value_type = value_type.helpType()
      else:
        value_type = _getTypeName( value_type )
      return "Dictionary of %s" % (value_type,)
    return "Dictionary"
  def helpRange( self ):
    if self.range_help:
      return list(toSequence( self.range_help ))
    value_type = self.value_type.getValueType()
    if isinstance(value_type, OptionType):
      return value_type.helpRange()
    return []
try:
  import cPickle as pickle
except ImportError:
  import pickle
_known_type_names = {}
_known_type_ids = {}
class   EntityPickler (object):
  __slots__ = ( 'pickler', 'unpickler', 'buffer' )
  def   __init__( self ):
    membuf = io.BytesIO()
    pickler = pickle.Pickler( membuf, protocol = pickle.HIGHEST_PROTOCOL )
    pickler.fast = True
    unpickler = pickle.Unpickler( membuf )
    pickler.persistent_id = self.persistent_id
    unpickler.persistent_load = self.persistent_load
    self.pickler = pickler
    self.unpickler = unpickler
    self.buffer = membuf
  @staticmethod
  def persistent_id( entity, known_type_names = _known_type_names ):
    entity_type = type(entity)
    type_name = _typeName( entity_type )
    try:
      type_id = known_type_names[ type_name ]
      return type_id, entity.__getnewargs__()
    except KeyError:
      return None
  @staticmethod
  def persistent_load( pid, known_type_ids = _known_type_ids ):
    type_id, new_args = pid
    try:
      entity_type = known_type_ids[ type_id ]
      return entity_type.__new__(entity_type, *new_args )
    except KeyError:
      raise pickle.UnpicklingError("Unsupported persistent object")
  def   dumps( self, entity ):
    buf = self.buffer
    buf.seek(0)
    buf.truncate(0)
    self.pickler.dump( entity )
    return buf.getvalue()
  def   loads( self, bytes_object ):
    buf = self.buffer
    buf.seek(0)
    buf.truncate(0)
    buf.write( bytes_object )
    buf.seek(0)
    return self.unpickler.load()
def   _typeName( entity_type ):
  return entity_type.__module__ + '.' + entity_type.__name__
def  pickleable( entity_type, known_type_names = _known_type_names, known_type_ids = _known_type_ids ):
  if type(entity_type) is type:
    type_name = _typeName( entity_type )
    type_id = binascii.crc32( type_name.encode("utf-8") ) & 0xFFFFFFFF
    other_type = known_type_ids.setdefault( type_id, entity_type )
    if other_type is not entity_type:
      raise AqlException( "Two different type names have identical CRC32 checksum: '%s' and '%s'" % (_typeName( other_type ), type_name ) )
    known_type_names[ type_name ] = type_id
  return entity_type
class   ErrorFileLocked( AqlException ):
  def   __init__( self, filename ):
    msg = 'File "%s" is locked.' % (filename,)
    super(ErrorFileLocked, self).__init__( msg )
class GeneralFileLock (object):
  __slots__ = ('lockfilename', 'filename', 'retries', 'interval')
  def   __init__( self, filename, interval = 0.25, timeout = 5 * 60 ):
    filename = os.path.normcase( os.path.abspath( filename ) )
    self.filename = filename
    self.lockfilename = filename + '.lock'
    self.interval = interval
    self.retries = int(timeout / interval)
  def   __enter__(self):
    return self
  def   __exit__(self, exc_type, exc_value, traceback):
    self.releaseLock()
  def   readLock( self, wait = True, force = False ):
    return self.writeLock( wait = wait, force = force )
  def   writeLock( self, wait = True, force = False ):
    if wait:
      index = self.retries
    else:
      index = 0
    while True:
      try:
        self.__lock( force = force )
        break
      except ErrorFileLocked:
        if index <= 0:
          raise
      index -= 1
      time.sleep( self.interval )
    return self
  def   __lock( self, force = False ):
    try:
      os.mkdir( self.lockfilename )
    except OSError as ex:
      if ex.errno == errno.EEXIST:
        if force:
          return
        raise ErrorFileLocked( self.filename )
      raise
  def   releaseLock( self ):
    try:
      os.rmdir( self.lockfilename )
    except OSError as ex:
      if ex.errno != errno.ENOENT:
        raise
try:
  import fcntl
  class UnixFileLock (object):
    __slots__ = ('fd','filename')
    def   __init__( self, filename ):
      filename = os.path.normcase( os.path.abspath( filename ) )
      self.filename = filename
      self.fd = None
    def   __enter__(self):
      return self
    def   __exit__(self, exc_type, exc_value, traceback):
      self.releaseLock()
    def   __open(self):
      if self.fd is None:
        self.fd = os.open( self.filename, os.O_CREAT | os.O_RDWR )
    def   __close(self):
      os.close( self.fd )
      self.fd = None
    def   readLock( self, wait = True, force = False ):
      self.__lock( write = False, wait = wait )
      return self
    def   writeLock( self, wait = True, force = False ):
      self.__lock( write = True, wait = wait )
      return self
    def   __lock( self, write, wait ):
      self.__open()
      if write:
        flags = fcntl.LOCK_EX
      else:
        flags = fcntl.LOCK_SH
      if not wait:
        flags |= fcntl.LOCK_NB
      try:
        fcntl.lockf( self.fd, flags )
      except IOError as ex:
        if ex.errno in ( errno.EACCES, errno.EAGAIN ):
          raise ErrorFileLocked( self.filename )
        raise
    def   releaseLock( self ):
      fcntl.lockf( self.fd, fcntl.LOCK_UN )
      self.__close()
  FileLock = UnixFileLock
except ImportError:
  try:
    import msvcrt
    import ctypes
    import ctypes.wintypes
    class WindowsFileLock (object):
      def __initWinTypes(self):
        self.LOCKFILE_FAIL_IMMEDIATELY = 0x1
        self.LOCKFILE_EXCLUSIVE_LOCK = 0x2
        if ctypes.sizeof(ctypes.c_ulong) != ctypes.sizeof(ctypes.c_void_p): # is 64 bit
          ULONG_PTR = ctypes.c_int64
        else:
          ULONG_PTR = ctypes.c_ulong
        PVOID = ctypes.c_void_p
        DWORD = ctypes.wintypes.DWORD
        HANDLE = ctypes.wintypes.HANDLE
        class _OFFSET(ctypes.Structure):
          _fields_ = [
            ('Offset', DWORD),
            ('OffsetHigh', DWORD)
          ]
        class _OFFSET_UNION(ctypes.Union):
          _anonymous_ = ['_offset']
          _fields_ = [
            ('_offset', _OFFSET),
            ('Pointer', PVOID)
          ]
        class OVERLAPPED(ctypes.Structure):
          _anonymous_ = ['_offset_union']
          _fields_ = [
            ('Internal', ULONG_PTR),
            ('InternalHigh', ULONG_PTR),
            ('_offset_union', _OFFSET_UNION),
            ('hEvent', HANDLE)
          ]
        LPOVERLAPPED = ctypes.POINTER(OVERLAPPED)
        self.overlapped = OVERLAPPED()
        self.poverlapped = LPOVERLAPPED( self.overlapped )
        self.LockFileEx = ctypes.windll.kernel32.LockFileEx
        self.UnlockFileEx = ctypes.windll.kernel32.UnlockFileEx
      def   __init__( self, filename ):
        self.__initWinTypes()
        filename = os.path.normcase( os.path.abspath( filename ) )
        self.filename = filename
        self.fd = None
        self.handle = None
      def   __enter__(self):
        return self
      def   __exit__(self, exc_type, exc_value, traceback):
        self.releaseLock()
      def   __open(self):
        if self.fd is None:
          lockfilename = self.filename + ".lock"
          self.fd = os.open( lockfilename, os.O_CREAT | os.O_RDWR | os.O_NOINHERIT )
          self.handle = msvcrt.get_osfhandle( self.fd )
      def   __close(self):
        os.close( self.fd )
        self.fd = None
        self.handle = None
      def   __lock( self, write, wait ):
        self.__open()
        if write:
          flags = self.LOCKFILE_EXCLUSIVE_LOCK
        else:
          flags = 0
        if not wait:
          flags |= self.LOCKFILE_FAIL_IMMEDIATELY
        result = self.LockFileEx( self.handle, flags, 0, 0, 4096, self.poverlapped )
        if not result:
          raise ErrorFileLocked( self.filename )
      def   readLock( self, wait = True, force = False ):
        self.__lock( write = False, wait = wait )
        return self
      def   writeLock( self, wait = True, force = False ):
        self.__lock( write = True, wait = wait )
        return self
      def   releaseLock( self ):
        self.UnlockFileEx( self.handle, 0, 0, 4096, self.poverlapped )
        self.__close()
    FileLock = WindowsFileLock
  except ImportError:
    FileLock = GeneralFileLock
try:
  import cPickle as pickle
except ImportError:
  import pickle
class   ErrorInvalidExecCommand( AqlException ):
  def   __init__( self, arg ):
    msg = "Invalid type of command argument: %s(%s)" % (arg,type(arg))
    super(type(self), self).__init__( msg )
class   ErrorFileName( AqlException ):
  def   __init__( self, filename ):
    msg = "Invalid file name: %s(%s)" % (filename,type(filename))
    super(type(self), self).__init__( msg )
class   ErrorUnmarshallableObject( AqlException ):
  def   __init__( self, obj ):
    msg = "Unmarshallable object: '%s'" % (obj, )
    super(type(self), self).__init__( msg )
if hasattr(os, 'O_NOINHERIT'):
  _O_NOINHERIT = os.O_NOINHERIT
else:
  _O_NOINHERIT = 0
if hasattr(os, 'O_SYNC'):
  _O_SYNC = os.O_SYNC
else:
  _O_SYNC = 0
if hasattr(os, 'O_BINARY'):
  _O_BINARY = os.O_BINARY
else:
  _O_BINARY = 0
def   openFile( filename, read = True, write = False, binary = False, sync = False, encoding = None ):
  if not isString( filename ):
    raise ErrorFileName( filename )
  flags = _O_NOINHERIT | _O_BINARY
  mode = 'r'
  if not write:
    flags |= os.O_RDONLY
    sync = False
  else:
    flags |= os.O_CREAT
    mode += '+'
    if read:
      flags |= os.O_RDWR
    else:
      flags |= os.O_WRONLY
    if sync:
      flags |= _O_SYNC
  if binary:
    mode += 'b'
  fd = os.open( filename, flags )
  try:
    if sync:
      return io.open( fd, mode, 0, encoding = encoding )
    else:
      return io.open( fd, mode, encoding = encoding )
  except:
    os.close( fd )
    raise
def readTextFile( filename, encoding = 'utf-8' ):
  with openFile( filename, encoding = encoding ) as f:
    return f.read()
def readBinFile( filename ):
  with openFile( filename, binary = True ) as f:
    return f.read()
def writeTextFile( filename, data, encoding = 'utf-8' ):
  with openFile( filename, write = True, encoding = encoding ) as f:
    f.truncate()
    if isinstance( data, (bytearray, bytes) ):
      data = decodeBytes( data, encoding )
    f.write( data )
def writeBinFile( filename, data, encoding = None ):
  with openFile( filename, write = True, binary = True, encoding = encoding ) as f:
    f.truncate()
    if isUnicode( data ):
      data = encodeStr( data, encoding )
    f.write( data )
def   execFile( filename, file_locals ):
  if not file_locals:
    file_locals = {}
  source = readTextFile( filename )
  code = compile( source, filename, 'exec' )
  file_locals_orig = file_locals.copy()
  exec( code, file_locals )
  result = {}
  for key,value in file_locals.items():
    if key.startswith('_') or isinstance( value, types.ModuleType ):
      continue
    if key not in file_locals_orig:
      result[ key ] = value
  return result
def   dumpSimpleObject( obj ):
  if isinstance( obj, (bytes, bytearray) ):
    data = obj
  elif isinstance( obj, uStr ):
    data = obj.encode('utf-8')
  else:
    try:
      data = marshal.dumps( obj, 0 ) # stick with version 0, we a raw dump
    except ValueError:
      raise ErrorUnmarshallableObject( obj )
  return data
def   dumpObject( obj ):
  return pickle.dumps( obj, protocol = pickle.HIGHEST_PROTOCOL )
def   simpleObjectSignature( obj, common_hash = None ):
  data = dumpSimpleObject( obj )
  return dataSignature( data, common_hash )
def   objectSignature( obj, common_hash = None ):
  data = dumpObject( obj )
  return dataSignature( data, common_hash )
def   newHash( data = b'' ):
  return hashlib.md5( data )
def   dataSignature( data, common_hash = None ):
  if common_hash is None:
    obj_hash = hashlib.md5( data )
  else:
    obj_hash = common_hash.copy()
    obj_hash.update( data )
  return obj_hash.digest()
def   fileSignature( filename ):
  checksum = hashlib.md5()
  chunk_size = checksum.block_size * 4096
  with openFile( filename, binary = True ) as f:
    read = f.read
    checksum_update = checksum.update
    chunk = True
    while chunk:
      chunk = read( chunk_size )
      checksum_update( chunk )
  return checksum.digest()
def   fileTimeSignature( filename ):
  stat = os.stat( filename )
  return simpleObjectSignature( (stat.st_size, stat.st_mtime) )
def   fileChecksum( filename, offset = 0, size = -1, alg = 'md5', chunk_size = 262144 ):
  checksum = hashlib.__dict__[alg]()
  with openFile( filename, binary = True ) as f:
    read = f.read
    f.seek( offset )
    checksum_update = checksum.update
    chunk = True
    while chunk:
      chunk = read( chunk_size )
      checksum_update( chunk )
      if size > 0:
        size -= len(chunk)
        if size <= 0:
          break
      checksum_update( chunk )
  return checksum
def   getFunctionName( currentframe = inspect.currentframe ):
  frame = currentframe()
  if frame:
    return frame.f_back.f_code.co_name
  return "__not_available__"
def   printStacks():
  id2name = dict([(th.ident, th.name) for th in threading.enumerate()])
  for thread_id, stack in sys._current_frames().items():
    print("\n" + ("=" * 64) )
    print("Thread: %s (%s)" % (id2name.get(thread_id,""), thread_id))
    traceback.print_stack(stack)
try:
  _getargspec = inspect.getfullargspec
except AttributeError:
  _getargspec = inspect.getargspec
def   getFunctionArgs( function, getargspec = _getargspec ):
  args = getargspec( function )[:4]
  if type(function) is types.MethodType:
    if function.__self__:
      args = tuple( [ args[0][1:] ] + list(args[1:]) ) 
  return args
def   equalFunctionArgs( function1, function2 ):
  if function1 is function2:
    return True
  return getFunctionArgs( function1 )[0:3] == getFunctionArgs( function2 )[0:3]
def   checkFunctionArgs( function, args, kw, getargspec = _getargspec):
  f_args, f_varargs, f_varkw, f_defaults = getargspec( function )[:4]
  current_args_num = len(args) + len(kw)
  args_num = len(f_args)
  if not f_varargs and not f_varkw:
    if current_args_num > args_num:
      return False
  if f_defaults:
    def_args_num = len(f_defaults)
  else:
    def_args_num = 0
  min_args_num = args_num - def_args_num
  if current_args_num < min_args_num:
    return False
  kw = set(kw)
  unknown_args = kw - set(f_args)
  if unknown_args and not f_varkw:
    return False
  def_args = f_args[args_num - def_args_num:]
  non_def_kw = kw - set(def_args)
  non_def_args_num = len(args) + len(non_def_kw)
  if non_def_args_num < min_args_num:
    return False
  twice_args = set(f_args[:len(args)]) & kw
  if twice_args:
    return False
  return True
def   removeFiles( files ):
  for f in toSequence( files ):
    try:
      os.remove( f )
    except OSError as ex:
      if ex.errno != errno.ENOENT:
        raise
def _decodeData( data ):
  if not data:
    return str()
  data = toUnicode( data )
  data = data.replace('\r\n', '\n')
  data = data.replace('\r', '\n')
  return data
class   ExecCommandException( AqlException ):
  __slots__ = ('exception',)
  def   __init__( self, cmd, exception ):
    msg = ' '.join( toSequence(cmd) )
    msg += '\n%s' % (exception,)
    self.exception = exception
    super(type(self), self).__init__( msg )
  def   failed( self ):
    return True
  def   __bool__( self ):
    return self.failed()
  def   __nonzero__( self ):
    return self.failed()
class   ExecCommandResult( AqlException ):
  __slots__ = ('cmd', 'status', 'output' )
  def   __init__( self, cmd, status = None, stdout = None, stderr = None ):
    self.cmd = tuple(toSequence(cmd))
    self.status = status
    if not stdout:
      stdout = str()
    if stderr:
      stdout += '\n' + stderr
    self.output = stdout
    super(type(self), self).__init__()
  def   __str__(self):
    msg = ' '.join( self.cmd )
    if self.output:
      msg += '\n' + self.output
    if self.status:
      msg += "\nExit status: %s" % (self.status,)
    return msg
  def   failed( self ):
    return self.status != 0
  def   __bool__( self ):
    return self.failed()
  def   __nonzero__( self ):
    return self.failed()
try:
  _MAX_CMD_LENGTH = os.sysconf('SC_ARG_MAX')
except AttributeError:
  _MAX_CMD_LENGTH = 32000  # 32768 default for windows
def executeCommand( cmd, cwd = None, env = None, stdin = None, file_flag = None, max_cmd_length = _MAX_CMD_LENGTH ):
  cmd_file = None
  if isString(cmd):
    shell = True
  else:
    shell = False
    for v in toSequence( cmd ):
      if not isString( v ):
        raise ErrorInvalidExecCommand( v )
    if file_flag:
      cmd_length = sum( map(len, cmd ) ) + len(cmd) - 1
      if cmd_length > max_cmd_length:
        args_str = subprocess.list2cmdline( cmd[1:] ).replace('\\', '\\\\')
        cmd_file = tempfile.NamedTemporaryFile( mode = 'w+', suffix = '.args', delete = False )
        cmd_file.write( args_str )
        cmd_file.close()
        cmd = [cmd[0], file_flag + cmd_file.name]
  try:
    try:
      if env:
        env = dict( (castStr(key), castStr(value)) for key, value in env.items() )
      p = subprocess.Popen( cmd, cwd = cwd, env = env, shell = shell,
                            stdin = stdin, stdout = subprocess.PIPE, stderr = subprocess.PIPE, universal_newlines = False )
      stdout, stderr = p.communicate()
      returncode = p.poll()
    except Exception as ex:
      raise ExecCommandException( cmd, exception = ex )
    stdout = _decodeData( stdout )
    stderr = _decodeData( stderr )
    return ExecCommandResult( cmd, status = returncode, stdout = stdout, stderr = stderr )
  finally:
    if cmd_file is not None:
      cmd_file.close()
      removeFiles( cmd_file.name )
def   getShellScriptEnv( script, args = None, _var_re = re.compile( r'^\w+=' ) ):
  args = toSequence( args )
  script_path = os.path.abspath( os.path.expanduser( os.path.expandvars(script) ) )
  os_env = os.environ
  cwd, script = os.path.split( script_path )
  if os.name == "nt":
    cmd = ['call', script ]
    cmd += args
    cmd += ['&&', 'set']
  else:
    cmd = [ '.', './' + script ]
    cmd += args
    cmd += ['&&', 'printenv']
    cmd = ' '.join( cmd )
  try:
    p = subprocess.Popen( cmd, cwd = cwd, shell = True, env = os_env,
                          stdin = None, stdout = subprocess.PIPE, stderr = subprocess.PIPE, universal_newlines = False )
    stdout, stderr = p.communicate()
    status = p.poll()
  except Exception as ex:
    raise ExecCommandException( cmd, exception = ex )
  stdout = _decodeData( stdout )
  stderr = _decodeData( stderr )
  if status != 0:
    raise ExecCommandResult( cmd, status, stdout, stderr )
  script_env = {}
  for line in stdout.split('\n'):
    match = _var_re.match( line )
    if match:
      name, sep, value = line.partition('=')
      value = value.strip()
      current = os_env.get( name, None )
      if (current is None) or (value != current.strip()):
        script_env[ name ] = value
  return script_env
def   cpuCount():
  try:
    return multiprocessing.cpu_count()
  except NotImplementedError:
    pass
  cpu_count = int(os.environ.get('NUMBER_OF_PROCESSORS', 0))
  if cpu_count:
    return cpu_count
  try:
    if 'SC_NPROCESSORS_ONLN' in os.sysconf_names:
      cpu_count = os.sysconf('SC_NPROCESSORS_ONLN')
    elif 'SC_NPROCESSORS_CONF' in os.sysconf_names:
      cpu_count = os.sysconf('SC_NPROCESSORS_CONF')
    if cpu_count:
      return cpu_count
  except AttributeError:
    pass
  cpu_count = 1 # unable to detect number of CPUs
  return cpu_count
def _memoryUsageSmaps():
  private = 0
  with open("/proc/self/smaps") as smaps:
    for line in smaps:
      if line.startswith("Private"):
        private += int(line.split()[1])
  return private
def _memoryUsageStatm():
  PAGESIZE = os.sysconf("SC_PAGE_SIZE")
  with open('/proc/self/statm') as f: 
    mem_stat = f.readline().split()
    rss = int(mem_stat[1]) * PAGESIZE  
    shared = int(mem_stat[2]) * PAGESIZE  
    private = rss - shared
  return private // 1024
def   memoryUsageLinux():
  try:
    return _memoryUsageSmaps()
  except IOError:
    try:
      return _memoryUsageStatm()
    except IOError:
      return memoryUsageUnix()
def memoryUsageUnix():
  res = resource.getrusage(resource.RUSAGE_SELF)
  return res.ru_maxrss
def memoryUsageWindows():
  process_handle = win32api.GetCurrentProcess()
  memory_info = win32process.GetProcessMemoryInfo( process_handle )
  return memory_info['PeakWorkingSetSize']
try:
  import resource
  if sys.platform[:5] == "linux":
    memoryUsage = memoryUsageLinux
  else:
    memoryUsage = memoryUsageUnix
except ImportError:
  try:
    import win32process
    import win32api
    memoryUsage = memoryUsageWindows
  except ImportError:
    def memoryUsage():
      return 0
def   loadModule( module_file, package_name = None ):
  module_dir, module_file = os.path.split( module_file )
  module_name = os.path.splitext( module_file )[0]
  fp, pathname, description = imp.find_module( module_name, [ module_dir ] )
  if package_name:
    module_name = package_name + '.' + module_name
  module = imp.load_module( module_name, fp, pathname, description )
  return module
def   loadPackage( path, name = None, generate_name = False ):
  find_path, find_name = os.path.split( path )
  fp, pathname, description = imp.find_module( find_name, [ find_path ] )
  if not name:
    if generate_name:
      name = newHash( dumpSimpleObject( path ) ).hexdigest()
    else:
      name = find_name
  package = imp.load_module( name, fp, pathname, description )
  return package
def   flattenList( seq ):
  out_list = list( toSequence( seq ) )
  i = 0
  while i < len(out_list):
    value = out_list[i]
    if isSequence( value ):
      if value:
        out_list[i: i + 1] = value
      else:
        del out_list[i]
      continue
    i += 1
  return out_list
_SIMPLE_SEQUENCES = (list, tuple, UniqueList, set, frozenset)
def  simplifyValue( value, simple_types = SIMPLE_TYPES_SET, simple_lists = _SIMPLE_SEQUENCES ):
  if value is None:
    return None
  value_type = type(value)
  if value_type in simple_types:
    return value
  for simple_type in simple_types:
    if isinstance( value, simple_type ):
      return simple_type(value)
  if isinstance( value, simple_lists ):
    return [ simplifyValue( v ) for v in value ]
  if isinstance( value, dict ):
    return dict( (key, simplifyValue( v )) for key,v in value.items() )
  try:
    return simplifyValue( value.get() )
  except Exception:
    pass
  return value
class   Chrono (object):
  __slots__ = ('elapsed', )
  def   __init__(self):
    self.elapsed = 0
  def   __enter__(self):
    self.elapsed = time.time()
    return self
  def   __exit__(self, exc_type, exc_val, exc_tb):
    self.elapsed = time.time() - self.elapsed
    return False
  def   get(self):
    return self.elapsed
  def   __str__(self):
    elapsed = self.elapsed
    minutes = int(elapsed / 60)
    seconds = int(elapsed - minutes * 60)
    milisecs = int((elapsed - int(elapsed)) * 1000)
    result = []
    if minutes:
      result.append("%s min" % minutes)
      milisecs = 0
    if seconds:   result.append("%s sec" % seconds)
    if milisecs:  result.append("%s ms" % milisecs)
    if not minutes and not seconds and not milisecs:
      result.append("0 ms")
    return ' '.join( result )
class   ItemsGroups( object ):
  __slots__ = (
    'wish_groups',
    'max_group_size',
    'group_size',
    'tail_size',
    'groups',
  )
  def   __init__(self, size, wish_groups, max_group_size ):
    wish_groups = max( 1, wish_groups )
    group_size = size // wish_groups
    if max_group_size < 0:
      max_group_size = size
    elif max_group_size == 0:
      max_group_size = group_size + 1
    group_size = max( 1, group_size )
    self.wish_groups = wish_groups
    self.group_size = min( max_group_size, group_size )
    self.max_group_size = max_group_size
    self.tail_size = size
    self.groups = [[]]
  def   addGroup( self ):
    groups = self.groups
    if not groups[0]:
      return
    group_size = max( 1, self.tail_size // max(1, self.wish_groups - len(self.groups) ) )
    self.group_size = min( self.max_group_size, group_size )
    group_files = []
    self.groups.append( group_files )
    return group_files
  def   add(self, item ):
    group_files = self.groups[-1]
    if len(group_files) >= self.group_size:
      group_files = self.addGroup()
    group_files.append( item )
    self.tail_size -= 1
  def   get(self):
    groups = self.groups
    if not groups[-1]:
      del groups[-1]
    return groups
def   groupItems( items, wish_groups = 1, max_group_size = -1 ):
  groups = ItemsGroups( len(items), wish_groups, max_group_size )
  for item in items:
    groups.add( item )
  return groups.get()
class   ErrorOptionValueMergeNonOptionValue( TypeError ):
  def   __init__( self, value ):
    msg = "Unable to merge option value with non option value: '%s'" % (type(value),)
    super(type(self), self).__init__( msg )
class   ErrorOptionValueOperationFailed( TypeError ):
  def   __init__( self, op, args, kw, err ):
    args_str = ""
    if args:
      args_str += ', '.join( map( str, args ) )
    if kw:
      if args_str:
        args_str += ","
      args_str += str( kw )
    msg = "Operation %s( %s ) failed with error: %s" % (op, args_str, err)
    super(type(self), self).__init__( msg )
def   _setOperator( dest_value, value ):
  return value
def   _iAddKeyOperator( dest_value, key, value ):
  dest_value[key] += value
  return dest_value
def   _iSubKeyOperator( dest_value, key, value ):
  dest_value[key] -= value
  return dest_value
def   _updateOperator( dest_value, value ):
  if isinstance( dest_value, (UniqueList, list) ):
    dest_value += value
    return dest_value
  elif isinstance( dest_value, Dict ):
    dest_value.update( value )
    return dest_value
  else:
    return value
def   SetValue( value ):
  return SimpleInplaceOperation( _setOperator, value )
def   SetKey( key, value ):
  return SimpleInplaceOperation( operator.setitem, key, value )
def   GetKey( value, key ):
  return SimpleOperation( operator.getitem, value, key )
def   iAddValue( value ):
  return SimpleInplaceOperation( operator.iadd, value )
def   iAddKey( key, value ):
  return SimpleInplaceOperation( _iAddKeyOperator, key, value )
def   iSubKey( key, value ):
  return SimpleInplaceOperation( _iSubKeyOperator, key, value )
def   iSubValue( value ):
  return SimpleInplaceOperation( operator.isub, value )
def   iUpdateValue( value ):
  return SimpleInplaceOperation( _updateOperator, value )
def   _convertArgs( args, kw, options, converter ):
  tmp_args = []
  for arg in args:
    if isinstance( arg, Operation ):
      arg.convert( options, converter )
    else:
      arg = converter( options, arg )
    tmp_args.append( arg )
  tmp_kw = {}
  for key,arg in kw.items():
    if isinstance( arg, Operation ):
      arg.convert( options, converter )
    elif converter is not None:
      arg = converter( options, arg )
    tmp_kw[ key ] = arg
  return tmp_args, tmp_kw
def   _unconvertArgs( args, kw, options, context, unconverter ):
  tmp_args = []
  for arg in args:
    if isinstance( arg, Operation ):
      arg = arg( options, context, unconverter )
    elif unconverter is not None:
      arg = unconverter( options, context, arg )
    tmp_args.append( arg )
  tmp_kw = {}
  for key,arg in kw.items():
    if isinstance( arg, Operation ):
      arg = arg( options, context, unconverter )
    elif unconverter is not None:
      arg = unconverter( options, context, arg )
    tmp_kw[ key ] = arg
  return tmp_args, tmp_kw
class   Condition(object):
  __slots__ = (
    'condition',
    'predicate',
    'args',
    'kw',
  )
  def   __init__( self, condition, predicate, *args, **kw ):
    self.condition = condition
    self.predicate = predicate
    self.args = args
    self.kw = kw
  def   convert(self, options, converter ):
    self.args, self.kw = _convertArgs( self.args, self.kw, options, converter )
    cond = self.condition
    if cond is not None:
      cond.convert( options, converter )
  def   __call__( self, options, context, unconverter ):
    if self.condition is not None:
      if not self.condition( options, context, unconverter ):
        return False
    args, kw = _unconvertArgs( self.args, self.kw, options, context, unconverter )
    return self.predicate( options, context, *args, **kw )
class   Operation( object ):
  __slots__ = (
    'action',
    'kw',
    'args',
  )
  def   __init__( self, action, *args, **kw ):
    self.action = action
    self.args = args
    self.kw = kw
  def   convert( self, options, converter ):
    self.args, self.kw = _convertArgs( self.args, self.kw, options, converter )
  def   _callAction(self, options, context, args, kw ):
    return self.action( options, context, *args, **kw )
  def   __call__( self, options, context, unconverter ):
    args, kw = _unconvertArgs( self.args, self.kw, options, context, unconverter )
    try:
      result = self._callAction( options, context, args, kw )
    except Exception as ex:
      raise ErrorOptionValueOperationFailed( self.action, args, kw, ex )
    return result
  def   __add__( self, other ):
    return SimpleOperation( operator.add, self, other )
  def   __radd__( self, other ):
    return SimpleOperation( operator.add, other, self )
  def   __sub__( self, other ):
    return SimpleOperation( operator.sub, self, other )
  def   __rsub__( self, other ):
    return SimpleOperation( operator.sub, other, self )
class SimpleOperation( Operation ):
  def   _callAction(self, options, context, args, kw ):
    return self.action( *args, **kw )
class   InplaceOperation( object ):
  __slots__ = (
    'action',
    'kw',
    'args',
  )
  def   __init__( self, action, *args, **kw ):
    self.action = action
    self.args = args
    self.kw = kw
  def   convert(self, options, converter ):
    self.args, self.kw = _convertArgs( self.args, self.kw, options, converter )
  def   _callAction(self, options, context, dest_value, args, kw ):
    return self.action( options, context, dest_value, *args, **kw )
  def   __call__( self, options, context, dest_value, value_type, unconverter ):
    if self.action is None:
      return dest_value
    args, kw = _unconvertArgs( self.args, self.kw, options, context, unconverter )
    try:
      result = self._callAction( options, context, dest_value, args, kw )
    except Exception as ex:
      raise ErrorOptionValueOperationFailed( self.action, args, kw, ex )
    if result is None:
      result = dest_value
    dest_value = value_type( result )
    return dest_value
class SimpleInplaceOperation( InplaceOperation ):
  def   _callAction(self, options, context, dest_value, args, kw ):
    return self.action( dest_value, *args, **kw )
class   ConditionalValue (object):
  __slots__ = (
    'ioperation',
    'condition',
  )
  def   __init__( self, ioperation, condition = None ):
    self.ioperation  = ioperation
    self.condition  = condition
  def   convert(self, options, converter ):
    condition = self.condition
    if isinstance( condition, Condition ):
      condition.convert( options, converter )
    ioperation = self.ioperation
    if isinstance( ioperation, InplaceOperation ):
      ioperation.convert( options, converter )
  def   evaluate( self, value, value_type, options, context, unconverter ):
    condition = self.condition
    if (condition is None) or condition( options, context, unconverter ):
      if self.ioperation is not None:
        value = self.ioperation( options, context, value, value_type, unconverter )
    return value
class OptionValue (object):
  __slots__ = (
    'option_type',
    'conditional_values',
  )
  def   __init__( self, option_type, conditional_values = None ):
    self.option_type = option_type
    self.conditional_values = list( toSequence(conditional_values) )
  def   isSet( self ):
    return bool(self.conditional_values)
  def   isToolKey( self ):
    return self.option_type.is_tool_key
  def   appendValue( self, conditional_value ):
    self.conditional_values.append( conditional_value )
  def   prependValue( self, conditional_value ):
    self.conditional_values[:0] = [ conditional_value ]
  def   merge( self, other ):
    if self is other:
      return
    if not isinstance( other, OptionValue ):
      raise ErrorOptionValueMergeNonOptionValue( other )
    values = self.conditional_values
    other_values = other.conditional_values
    diff_index = 0
    for value1, value2 in zip( values, other_values ):
      if value1 is not value2:
        break
      diff_index += 1
    if self.option_type.is_auto and not other.option_type.is_auto:
      self.option_type = other.option_type
    self.conditional_values += other_values[ diff_index: ]
  def   reset( self ):
    self.conditional_values = []
  def   copy( self ):
    return OptionValue( self.option_type, self.conditional_values )
  def   __copy__( self ):
    return self.copy()
  def   get( self, options, context, evaluator = None ):
    if context is None:
      context = {}
    else:
      try:
        return context[ self ]
      except KeyError:
        pass
    value_type = self.option_type
    value = value_type()
    context[ self ] = value
    for conditional_value in self.conditional_values:
      value = conditional_value.evaluate( value, value_type, options, context, evaluator )
      context[ self ] = value
    return value
class   CLIOption( object ):
  __slots__ = (
    'cli_name', 'cli_long_name', 'opt_name', 'value_type', 'default', 'description', 'metavar'
  )
  def   __init__( self, cli_name, cli_long_name, opt_name, value_type, default, description, metavar = None ):
    self.cli_name = cli_name
    self.cli_long_name = cli_long_name
    self.opt_name = opt_name
    self.value_type = value_type
    self.default = None if default is None else value_type(default)
    self.description = description
    self.metavar = metavar
  def   addToParser( self, parser ):
    args = []
    if self.cli_name is not None:
      args.append( self.cli_name )
    if self.cli_long_name is not None:
      args.append( self.cli_long_name )
    if self.value_type is bool:
      action = 'store_false' if self.default else 'store_true'
    elif issubclass( self.value_type, (list, UniqueList)):
      action = 'append'
    else:
      action = 'store'
    kw = { 'dest': self.opt_name, 'help': self.description, 'action': action }
    if self.metavar:
      kw['metavar'] = self.metavar
    parser.add_option( *args, **kw )
class   CLIConfig( object ):
  def   __init__( self, cli_usage, cli_options, args = None ):
    super(CLIConfig, self).__setattr__( 'targets', tuple() )
    super(CLIConfig, self).__setattr__( '_set_options', set() )
    super(CLIConfig, self).__setattr__( '_defaults', {} )
    self.__parseArguments( cli_usage, cli_options, args )
  @staticmethod
  def   __getArgsParser( cli_usage, cli_options ):
    parser = optparse.OptionParser( usage = cli_usage )
    for opt in cli_options:
      opt.addToParser( parser )
    return parser
  def   __setDefaults( self, cli_options ):
    defaults = self._defaults
    for opt in cli_options:
      defaults[ opt.opt_name ] = (opt.default, opt.value_type)
    targets_type = SplitListType( ValueListType( UniqueList, str ), ', ' )
    defaults[ 'targets' ] = (tuple(), targets_type )
    return defaults
  def   __parseValues( self, args ):
    targets = []
    for arg in args:
      name, sep, value = arg.partition('=')
      name = name.strip()
      if sep:
        setattr( self, name, value.strip() )
      else:
        targets.append( name )
    if targets:
      self.targets = tuple( targets )
  def   __parseOptions( self, cli_options, args ):
    defaults = self.__setDefaults( cli_options )
    for opt in cli_options:
      name = opt.opt_name
      value = getattr( args, name )
      default, value_type = defaults[ name ]
      if value is None:
        value = default
      else:
        self._set_options.add( name )
        value = value_type( value )
      super(CLIConfig, self).__setattr__( name, value )
  def   __parseArguments( self, cli_usage, cli_options, cli_args ):
    parser = self.__getArgsParser( cli_usage, cli_options )
    args, values = parser.parse_args( cli_args )
    self.__parseOptions( cli_options, args )
    self.__parseValues( values )
  def   readConfig( self, config_file, config_locals = None ):
    if config_locals is None:
      config_locals = {}
    exec_locals = execFile( config_file, config_locals )
    for name, value in exec_locals.items():
      self.setDefault( name, value )
  def   __set( self, name, value ):
    defaults = self._defaults
    try:
      default_value, value_type = defaults[ name ]
    except KeyError:
      if value is not None:
        defaults[ name ] = (value, type(value))
    else:
      if value is None:
        value = default_value
      elif type(value) is not value_type:
        value = value_type( value )
    super(CLIConfig, self).__setattr__( name, value )
  def   getDefault( self, name ):
    try:
      return self._defaults[ name ][0]
    except KeyError:
      return None
  def   setDefault( self, name, value ):
    if name.startswith("_"):
      super(CLIConfig, self).__setattr__( name, value )
    else:
      if name not in self._set_options:
        self.__set( name, value )
  def   __setattr__( self, name, value ):
    if name.startswith("_"):
      super(CLIConfig, self).__setattr__( name, value )
    else:
      self.__set( name, value )
      if value is None:
        self._set_options.discard( name )
      else:
        self._set_options.add( name )
  def   items( self ):
    for name, value in self.__dict__.items():
      if not name.startswith("_") and (name != "targets"):
        yield (name, value)
EVENT_ERROR, EVENT_WARNING, EVENT_STATUS, EVENT_DEBUG,   = EVENT_ALL = tuple(range(4))
class   ErrorEventUserHandlerWrongArgs ( AqlException ):
  def   __init__( self, event, handler ):
    msg = "Invalid arguments of event '%s' handler method: '%s'" % (event, handler)
    super(type(self), self).__init__( msg )
class   ErrorEventHandlerAlreadyDefined ( AqlException ):
  def   __init__( self, event, handler, other_handler ):
    msg = "Duplicate event '%s' definition to default handlers: '%s', '%s'" % (event, handler, other_handler )
    super(type(self), self).__init__( msg )
class   ErrorEventHandlerUnknownEvent ( AqlException ):
  def   __init__( self, event ):
    msg = "Unknown event: '%s'" % (event,)
    super(type(self), self).__init__( msg )
class EventSettings( object ):
  __slots__ = (
    'brief',
    'with_output',
    'trace_exec'
  )
  def   __init__(self, brief = True, with_output = True, trace_exec = False ):
    self.brief = brief
    self.with_output = with_output
    self.trace_exec = trace_exec
class EventManager( object ):
  __slots__ = (
    'default_handlers',
    'user_handlers',
    'ignored_events',
    'disable_defaults',
    'settings',
  )
  def   __init__( self ):
    self.default_handlers = {}
    self.user_handlers = {}
    self.ignored_events = set()
    self.disable_defaults = False
    self.settings = EventSettings()
  def   addDefaultHandler( self, handler, importance_level, event = None ):
    if not event:
      event = handler.__name__
    pair = (handler, importance_level)
    other = self.default_handlers.setdefault( event, pair )
    if other != pair:
      raise ErrorEventHandlerAlreadyDefined( event, other[0], handler )
  def   addUserHandler( self, user_handler, event = None ):
    if not event:
      event = user_handler.__name__
    try:
      default_handler = self.default_handlers[ event ][0]
    except KeyError:
      raise ErrorEventHandlerUnknownEvent( event )
    if not equalFunctionArgs( default_handler, user_handler ):
      raise ErrorEventUserHandlerWrongArgs( event, user_handler )
    self.user_handlers.setdefault( event, [] ).append( user_handler )
  def   removeUserHandler( self, user_handlers ):
    for event, handlers in self.user_handlers.items():
      for user_handler in toSequence( user_handlers ):
        try:
          handlers.remove( user_handler )
        except ValueError:
          pass
  def   sendEvent( self, event, *args, **kw ):
    if event in self.ignored_events:
      return
    if self.disable_defaults:
      default_handlers = []
    else:
      default_handlers = [ self.default_handlers[ event ][0] ]
    user_handlers = self.user_handlers.get( event, [] )
    args = ( self.settings,) + args
    for handler in itertools.chain( user_handlers, default_handlers ):
      handler( *args, **kw )
  def   __getEvents( self, event_filters ):
    events = set()
    for event_filter in toSequence(event_filters):
      if event_filter not in EVENT_ALL:
        events.add( event_filter )
      else:
        for event, pair in self.default_handlers.items():
          handler, level = pair
          if event_filter == level:
            events.add( event )
    return events
  def   enableEvents( self, event_filters, enable ):
      events = self.__getEvents( event_filters )
      if enable:
        self.ignored_events.difference_update( events )
      else:
        self.ignored_events.update( events )
  def   enableDefaultHandlers( self, enable ):
    self.disable_defaults = not enable
  def   setSettings(self, settings ):
    self.settings = settings
_event_manager = EventManager()
def   _eventImpl( handler, importance_level, event = None ):
  if not event:
    event = handler.__name__
  _event_manager.addDefaultHandler( handler, importance_level )
  def   _sendEvent( *args, **kw ):
    _event_manager.sendEvent( event, *args, **kw )
  return _sendEvent
def   eventError( handler ):    return _eventImpl( handler, EVENT_ERROR )
def   eventWarning( handler ):  return _eventImpl( handler, EVENT_WARNING )
def   eventStatus( handler ):   return _eventImpl( handler, EVENT_STATUS )
def   eventDebug( handler ):    return _eventImpl( handler, EVENT_DEBUG )
def   eventHandler( event = None ):
  if isinstance( event, (types.FunctionType, types.MethodType)):
    _event_manager.addUserHandler( event )
    return event
  def   _eventHandlerImpl( handler ):
    _event_manager.addUserHandler( handler, event )
    return handler
  return _eventHandlerImpl
def   setEventSettings( settings ):
  _event_manager.setSettings( settings )
def   enableEvents( event_filters ):
  _event_manager.enableEvents( event_filters, True )
def   disableEvents( event_filters ):
  _event_manager.enableEvents( event_filters, False )
def   disableDefaultHandlers( ):
  _event_manager.enableDefaultHandlers( False )
def   enableDefaultHandlers():
  _event_manager.enableDefaultHandlers( True )
def   addUserHandler( handler, event = None ):
    _event_manager.addUserHandler( handler, event )
def   removeUserHandler( handler ):
    _event_manager.removeUserHandler( handler )
class   ErrorDataFileFormatInvalid( Exception ):
  def   __init__( self ):
    msg = "Data file format is not valid."
    super(ErrorDataFileFormatInvalid, self).__init__( msg )
class   ErrorDataFileChunkInvalid( Exception ):
  def   __init__( self ):
    msg = "Data file chunk format is not valid."
    super(ErrorDataFileChunkInvalid, self).__init__( msg )
class   ErrorDataFileVersionInvalid( Exception ):
  def   __init__( self ):
    msg = "Data file version is changed."
    super(ErrorDataFileVersionInvalid, self).__init__( msg )
class   ErrorDataFileCorrupted( Exception ):
  def   __init__( self ):
    msg = "Data file is corrupted"
    super(ErrorDataFileCorrupted, self).__init__( msg )
class _MmapFile( object ):
  def   __init__(self, filename ):
    stream = openFile( filename, write = True, binary = True, sync = False )
    try:
      memmap = mmap.mmap( stream.fileno(), 0, access = mmap.ACCESS_WRITE )
    except ValueError:
      stream.seek( 0 )
      stream.write( b'\0' )
      stream.flush()
      memmap = mmap.mmap( stream.fileno(), 0, access = mmap.ACCESS_WRITE )
    self.stream = stream
    self.memmap = memmap
    self.size = memmap.size
    self.resize = memmap.resize
    self.flush = memmap.flush
  def   close(self):
    self.memmap.flush()
    self.memmap.close()
    self.stream.close()
  def   read( self, offset, size ):
    return self.memmap[ offset : offset + size ]
  def   write( self, offset, data ):
    memmap = self.memmap
    end_offset = offset + len(data)
    if end_offset > memmap.size():
      page_size = mmap.ALLOCATIONGRANULARITY
      size = ((end_offset + (page_size -1 )) // page_size) * page_size
      if size == 0:
        size = page_size
      self.resize( size )
    memmap[ offset : end_offset ] = data
  def   move( self, dest, src, size ):
    memmap = self.memmap
    end_offset = dest + size
    if end_offset > memmap.size():
      self.resize( end_offset )
    memmap.move( dest, src, size )
class _IOFile( object ):
  def   __init__(self, filename ):
    stream = openFile( filename, write = True, binary = True, sync = False )
    self.stream = stream
    self.resize = stream.truncate
    self.flush = stream.flush
  def   close(self):
    self.stream.close()
  def   read( self, offset, size ):
    stream = self.stream
    stream.seek( offset )
    return stream.read( size )
  def   write( self, offset, data ):
    stream = self.stream
    stream.seek( offset )
    stream.write( data )
  def   move( self, dest, src, size ):
    stream = self.stream
    stream.seek( src )
    data = stream.read( size )
    stream.seek( dest )
    stream.write( data )
  def   size( self, io_SEEK_END = io.SEEK_END ):
    return self.stream.seek( 0, io_SEEK_END )
class   MetaData (object):
  __slots__ = (
    'offset',
    'key',
    'id',
    'data_offset',
    'data_size',
    'data_capacity',
  )
  _META_STRUCT = struct.Struct(">Q16sLL")   # big-endian, 8 bytes (key), 16 bytes (id), 4 bytes (size), 4 bytes (capacity)
  size = _META_STRUCT.size
  def   __init__( self, meta_offset, key, data_id, data_offset, data_size ):
    self.offset         = meta_offset
    self.key            = key
    self.id             = data_id
    self.data_offset    = data_offset
    self.data_size      = data_size
    self.data_capacity  = data_size + 4
  def   dump( self, meta_struct = _META_STRUCT ):
    return meta_struct.pack( self.key, self.id, self.data_size, self.data_capacity )
  @classmethod
  def  load( cls, dump, meta_struct = _META_STRUCT ):
    self = cls.__new__(cls)
    try:
      self.key, self.id, data_size, data_capacity = meta_struct.unpack( dump )
    except struct.error:
      raise ErrorDataFileChunkInvalid()
    if data_capacity < data_size:
      raise ErrorDataFileChunkInvalid()
    self.data_size      = data_size
    self.data_capacity  = data_capacity
    return self
  def   resize( self, data_size ):
    self.data_size = data_size
    capacity = self.data_capacity
    if capacity >= data_size:
      return 0
    self.data_capacity = data_size + min( data_size // 4, 128 )
    return self.data_capacity - capacity
  def   __repr__(self):
    return self.__str__()
  def   __str__(self):
    s = []
    for v in self.__slots__:
      s.append( "%s: %s" % (v, getattr( self, v )) ) 
    return ", ".join( s )
class DataFile (object):
  __slots__ = (
    'next_key',
    'id2data',
    'key2id',
    'meta_end',
    'data_begin',
    'data_end',
    'handle',
  )
  MAGIC_TAG = b".AQL.DB."
  VERSION = 1
  _HEADER_STRUCT = struct.Struct(">8sL") # big-endian, 8 bytes(MAGIC TAG), 4 bytes (file version)
  _HEADER_SIZE = _HEADER_STRUCT.size
  _KEY_STRUCT = struct.Struct(">Q") # 8 bytes (next unique key)
  _KEY_OFFSET = _HEADER_SIZE
  _KEY_SIZE = _KEY_STRUCT.size
  _META_TABLE_HEADER_STRUCT = struct.Struct(">L") # 4 bytes (offset of data area)
  _META_TABLE_HEADER_SIZE = _META_TABLE_HEADER_STRUCT.size
  _META_TABLE_HEADER_OFFSET = _KEY_OFFSET + _KEY_SIZE
  _META_TABLE_OFFSET = _META_TABLE_HEADER_OFFSET + _META_TABLE_HEADER_SIZE
  def   __init__( self, filename, force = False ):
    self.id2data = {}
    self.key2id = {}
    self.meta_end = 0
    self.data_begin = 0
    self.data_end = 0
    self.handle = None
    self.open( filename, force = force )
  def  open( self, filename, force = False ):
    self.close()
    try:
      self.handle = _MmapFile( filename )
    except Exception:
      self.handle = _IOFile( filename )
    self._init_header( force )
    self.next_key = self._key_generator()
    self._init_meta_table()
  def   close(self):
    if self.handle is not None:
      self.handle.close()
      self.handle = None
      self.id2data.clear()
      self.key2id.clear()
      self.meta_end = 0
      self.data_begin = 0
      self.data_end = 0
      self.next_key = None
  def   clear( self ):
    self._reset_meta_table()
    self.next_key = self._key_generator()
    self.id2data.clear()
    self.key2id.clear()
  def   __enter__(self):
    return self
  def   __exit__(self, exc_type, exc_value, traceback):
    self.close()
  def   _init_header( self, force, header_struct = _HEADER_STRUCT ):
    header = self.handle.read( 0, header_struct.size )
    try:
      tag, version = header_struct.unpack( header )
      if tag != self.MAGIC_TAG:
        if not force:
          raise ErrorDataFileFormatInvalid()
      elif version == self.VERSION:
        return
    except struct.error:
      if (header and header != b'\0') and not force:
        raise ErrorDataFileFormatInvalid()
    header = header_struct.pack( self.MAGIC_TAG, self.VERSION )
    self.handle.resize( len(header) )
    self.handle.write( 0, header )
  def   _key_generator( self, key_offset = _KEY_OFFSET, key_struct = _KEY_STRUCT, MAX_KEY = (2 ** 64) - 1 ):
    key_dump = self.handle.read( key_offset, key_struct.size )
    try:
      next_key, = key_struct.unpack( key_dump )
    except struct.error:
      next_key = 0
    key_pack = key_struct.pack
    write_file = self.handle.write
    while True:
      if next_key < MAX_KEY:
        next_key += 1
      else:
        next_key = 1    # this should never happen
      write_file( key_offset, key_pack( next_key ) )
      yield next_key
  def   _reset_meta_table( self,
                      meta_size     = MetaData.size,
                      table_offset  = _META_TABLE_OFFSET ):
    self.meta_end = table_offset
    self.data_begin = table_offset + meta_size * 1024
    self.data_end = self.data_begin
    self._truncate_file()
  def   _truncate_file( self,
                        table_header_struct = _META_TABLE_HEADER_STRUCT,
                        table_header_offset = _META_TABLE_HEADER_OFFSET ):
    header_dump = table_header_struct.pack( self.data_begin )
    handle = self.handle
    handle.resize( self.data_end )
    handle.write( table_header_offset, header_dump )
    handle.write( self.meta_end, b'\0' * (self.data_begin - self.meta_end) )
    handle.flush()
  def   _init_meta_table( self,
                         table_header_struct = _META_TABLE_HEADER_STRUCT,
                         table_header_offset = _META_TABLE_HEADER_OFFSET,
                         table_header_size = _META_TABLE_HEADER_SIZE,
                         table_begin = _META_TABLE_OFFSET,
                         meta_size = MetaData.size ):
    handle = self.handle
    header_dump = handle.read( table_header_offset, table_header_size )
    try:
      data_begin, = table_header_struct.unpack( header_dump )
    except struct.error:
      self._reset_meta_table()
      return
    if (data_begin <= table_begin) or (data_begin > handle.size()):
      self._reset_meta_table()
      return
    table_size = data_begin - table_begin
    if (table_size % meta_size) != 0:
      self._reset_meta_table()
      return
    dump = handle.read( table_begin, table_size )
    if len(dump) < table_size:
      self._reset_meta_table()
      return
    self._load_meta_table( data_begin, dump )
  def   _load_meta_table( self, data_offset, metas_dump,
                          meta_size = MetaData.size,
                          table_begin = _META_TABLE_OFFSET ):
    self.data_begin = data_offset
    file_size = self.handle.size()
    load_meta = MetaData.load
    pos = 0
    dump_size = len(metas_dump)
    while pos < dump_size:
      meta_dump = metas_dump[ pos : pos + meta_size ]
      try:
        meta = load_meta( meta_dump )
        data_capacity = meta.data_capacity
        if data_capacity == 0:
          break
        meta.offset = pos + table_begin
        meta.data_offset = data_offset
        if (data_offset + meta.data_size) > file_size:
          raise ErrorDataFileChunkInvalid()
        data_offset += data_capacity
      except Exception:
        self.data_end = data_offset
        self.meta_end = pos + table_begin
        self._truncate_file()
        return
      self.id2data[ meta.id ] = meta
      if meta.key:
        self.key2id[ meta.key ] = meta.id
      pos += meta_size
    self.meta_end = pos + table_begin
    self.data_end = data_offset
  def   _extend_meta_table( self,
                            table_header_struct = _META_TABLE_HEADER_STRUCT,
                            table_header_offset = _META_TABLE_HEADER_OFFSET,
                            table_begin = _META_TABLE_OFFSET ):
    data_begin = self.data_begin
    data_end = self.data_end
    table_capacity = data_begin - table_begin
    new_data_begin = data_begin + table_capacity
    handle = self.handle
    handle.move( new_data_begin, data_begin, data_end - data_begin )
    handle.write( data_begin, b'\0' * table_capacity )
    header_dump = table_header_struct.pack( new_data_begin )
    handle.write( table_header_offset, header_dump )
    self.data_begin = new_data_begin
    self.data_end += table_capacity
    for meta in self.id2data.values():
      meta.data_offset += table_capacity
  def   _extend_data( self, meta, oversize ):
    new_next_data = meta.data_offset + meta.data_capacity
    next_data = new_next_data - oversize
    rest_size = self.data_end - next_data
    if rest_size > 0:
      self.handle.move( new_next_data, next_data, rest_size )
      for meta in self.id2data.values():
        if meta.data_offset >= next_data:
          meta.data_offset += oversize
    self.data_end += oversize
  def   _append( self, key, data_id, data,
                 meta_size = MetaData.size ):
    meta_offset = self.meta_end
    if meta_offset == self.data_begin:
      self._extend_meta_table()
    data_offset = self.data_end
    meta = MetaData( meta_offset, key, data_id, data_offset, len(data) )
    write = self.handle.write
    write( data_offset, data )
    write( meta_offset, meta.dump() )
    self.data_end += meta.data_capacity
    self.meta_end += meta_size
    self.id2data[ data_id ] = meta
  def   _update( self, meta, data, update_meta ):
    data_size = len(data)
    if meta.data_size != data_size:
      update_meta = True
      oversize = meta.resize( data_size )
      if oversize > 0:
        self._extend_data( meta, oversize )
    write = self.handle.write
    if update_meta:
      write( meta.offset, meta.dump() )
    write( meta.data_offset, data )
  def   read( self, data_id ):
    try:
      meta = self.id2data[ data_id ]
    except KeyError:
      return None
    return self.handle.read( meta.data_offset, meta.data_size )
  def   write( self, data_id, data ):
    try:
      meta = self.id2data[ data_id ]
      self._update( meta, data, update_meta = False)
    except KeyError:
      self._append( 0, data_id, data )
  def   write_with_key( self, data_id, data ):
    meta = self.id2data.get( data_id )
    key = next(self.next_key)
    if meta is None:
      self._append( key, data_id, data )
    else:
      try:
        del self.key2id[ meta.key ]
      except KeyError:
        pass
      meta.key = key
      self._update( meta, data, update_meta = True )
    self.key2id[ key ] = data_id
    return key
  def   get_ids(self, keys):
    try:
      return tuple( map( self.key2id.__getitem__, keys ) )
    except KeyError:
      return None
  def   get_keys( self, data_ids ):
    return map( operator.attrgetter('key'), map( self.id2data.__getitem__, data_ids ) )
  def   remove( self, data_ids ):
    move = self.handle.move
    meta_size = MetaData.size
    remove_data_ids = frozenset( data_ids )
    metas = sorted( self.id2data.values(), key = operator.attrgetter('data_offset') )
    meta_shift = 0
    data_shift = 0
    meta_offset = 0
    data_offset = 0
    last_meta_end = 0
    last_data_end = 0
    remove_data_begin = None
    remove_meta_begin = None
    move_meta_begin = None
    move_data_begin = None
    for meta in metas:
      meta_offset = meta.offset
      last_meta_end = meta_offset + meta_size
      data_offset = meta.data_offset
      last_data_end = data_offset + meta.data_capacity
      if meta.id in remove_data_ids:
        del self.id2data[ meta.id ]
        if meta.key:
          del self.key2id[ meta.key ]
        if move_meta_begin is not None:
          move( remove_meta_begin, move_meta_begin, meta_offset - move_meta_begin )
          move( remove_data_begin, move_data_begin, data_offset - move_data_begin )
          remove_meta_begin = None
          move_meta_begin = None
        if remove_meta_begin is None:
          remove_meta_begin = meta_offset - meta_shift
          remove_data_begin = data_offset - data_shift
      else:
        if remove_meta_begin is not None:
          if move_meta_begin is None:
            move_meta_begin = meta_offset
            move_data_begin = data_offset
            meta_shift = move_meta_begin - remove_meta_begin
            data_shift = move_data_begin - remove_data_begin
        if meta_shift:
          meta.offset -= meta_shift
          meta.data_offset -= data_shift
    if remove_data_begin is not None:
      if move_meta_begin is None:
        meta_shift = last_meta_end - remove_meta_begin
        data_shift = last_data_end - remove_data_begin
      else:
        move( remove_meta_begin, move_meta_begin, last_meta_end - move_meta_begin )
        move( remove_data_begin, move_data_begin, last_data_end - move_data_begin )
    self.meta_end -= meta_shift
    self.data_end -= data_shift
    self.handle.write( self.meta_end, b'\0' * meta_shift )
    self.handle.resize( self.data_end )
  def   selfTest( self ):
    if self.handle is None:
      return
    file_size = self.handle.size()
    if self.data_begin > file_size:
      raise AssertionError("data_begin(%s) > file_size(%s)" % (self.data_begin, file_size))
    if self.data_begin > self.data_end:
      raise AssertionError("data_end(%s) > data_end(%s)" % (self.data_begin, self.data_end))
    if self.meta_end > self.data_begin:
      raise AssertionError("meta_end(%s) > data_begin(%s)" % (self.meta_end, self.data_begin))
    header_dump = self.handle.read( self._META_TABLE_HEADER_OFFSET, self._META_TABLE_HEADER_SIZE )
    try:
      data_begin, = self._META_TABLE_HEADER_STRUCT.unpack( header_dump )
    except struct.error:
      self._reset_meta_table()
      return
    if self.data_begin != data_begin:
      raise AssertionError("self.data_begin(%s) != data_begin(%s)" % (self.data_begin, data_begin))
    items = sorted( self.id2data.items(), key = lambda item: item[1].offset )
    last_meta_offset = self._META_TABLE_OFFSET
    last_data_offset = self.data_begin
    for data_id, meta in items:
      if meta.id != data_id:
        raise AssertionError("meta.id(%s) != data_id(%s)" % (meta.id, data_id))
      if meta.key != 0:
        if self.key2id[ meta.key ] != data_id:
          raise AssertionError("self.key2id[ meta.key ](%s) != data_id(%s)" % (self.key2id[ meta.key ], data_id))
      if meta.data_capacity < meta.data_size:
        raise AssertionError("meta.data_capacity(%s) < meta.data_size (%s)" % (meta.data_capacity, meta.data_size))
      if meta.offset >= self.meta_end:
        raise AssertionError("meta.offset(%s) >= self.meta_end(%s)" % (meta.offset, self.meta_end))
      if meta.offset != last_meta_offset:
        raise AssertionError("meta.offset(%s) != last_meta_offset(%s)" % (meta.offset, last_meta_offset))
      if meta.data_offset != last_data_offset:
        raise AssertionError("meta.data_offset(%s) != last_data_offset(%s)" % (meta.data_offset, last_data_offset))
      if meta.data_offset >= self.data_end:
        raise AssertionError("meta.data_offset(%s) >= self.data_end(%s)" % (meta.data_offset, self.data_end))
      if (meta.data_offset + meta.data_size) > file_size:
        raise AssertionError("(meta.data_offset + meta.data_size)(%s) > file_size(%s)" % ((meta.data_offset + meta.data_size), file_size))
      last_data_offset += meta.data_capacity
      last_meta_offset += MetaData.size
    if last_meta_offset != self.meta_end:
      raise AssertionError("last_meta_offset(%s) != self.meta_end(%s)" % (last_meta_offset, self.meta_end))
    if last_data_offset != self.data_end:
      raise AssertionError("last_data_offset(%s) != self.data_end(%s)" % (last_data_offset, self.data_end))
    for key, data_id in self.key2id.items():
      if key != self.id2data[ data_id ].key:
        raise AssertionError("key(%s) != self.id2data[ data_id ].key(%s)" % (key, self.id2data[ data_id ].key))
    for data_id, meta in self.id2data.items():
      meta_dump = self.handle.read( meta.offset, MetaData.size )
      stored_meta = MetaData.load( meta_dump )
      if meta.key != stored_meta.key:
        raise AssertionError("meta.key(%s) != stored_meta.key(%s)" % (meta.key, stored_meta.key))
      if meta.id != stored_meta.id:
        raise AssertionError("meta.id(%s) != stored_meta.id(%s)" % (meta.id, stored_meta.id))
      if meta.data_size != stored_meta.data_size:
        raise AssertionError("meta.data_size(%s) != stored_meta.data_size(%s)" % (meta.data_size, stored_meta.data_size))
      if meta.data_capacity != stored_meta.data_capacity:
        raise AssertionError("meta.data_capacity(%s) != stored_meta.data_capacity(%s)" % (meta.data_capacity, stored_meta.data_capacity))
class   ErrorDataFileFormatInvalid( Exception ):
  def   __init__( self ):
    msg = "Data file format is not valid."
    super(ErrorDataFileFormatInvalid, self).__init__( msg )
class SqlDataFile (object):
  __slots__ = (
    'id2key',
    'key2id',
    'connection',
  )
  def   __init__( self, filename, force = False ):
    self.id2key = {}
    self.key2id = {}
    self.connection = None
    self.open( filename, force = force )
  def   clear(self):
    with self.connection as conn:
      conn.execute("DELETE FROM items")
    self.id2key.clear()
    self.key2id.clear()
  def   __enter__(self):
    return self
  def   __exit__(self, exc_type, exc_value, traceback):
    self.close()
  def   _load_ids(self, conn):
    set_key = self.key2id.__setitem__
    set_id = self.id2key.__setitem__
    for key, data_id in conn.execute("SELECT key,id FROM items"):
      set_key( key, data_id )
      set_id( data_id, key )
  def   open( self, filename, force = False ):
    self.close()
    try:
      conn = self._open_connection( filename )
    except (sqlite3.DataError, sqlite3.IntegrityError):
      os.remove( filename )
      try:
        conn = self._open_connection( filename )
      except Exception:
        raise ErrorDataFileFormatInvalid()
    except sqlite3.DatabaseError:
      if not force and not self._is_aql_db( filename ):
        raise ErrorDataFileFormatInvalid()
      os.remove( filename )
      try:
        conn = self._open_connection( filename )
      except Exception:
        raise ErrorDataFileFormatInvalid()
    self._load_ids( conn )
    self.connection = conn
  def   close(self):
    if self.connection is not None:
      self.connection.close()
      self.connection = None
    self.id2key.clear()
    self.key2id.clear()
  @staticmethod
  def   _is_aql_db( filename ):
    MAGIC_TAG = b".AQL.DB."
    with openFile( filename, read = True, binary = True ) as f:
      tag = f.read( len(MAGIC_TAG) )
      return tag == MAGIC_TAG
  @staticmethod
  def   _open_connection(filename):
    conn = None
    try:
      conn = sqlite3.connect( filename )
      with conn:
        conn.execute("CREATE TABLE IF NOT EXISTS items( key INTEGER PRIMARY KEY AUTOINCREMENT, id blob UNIQUE, data blob NOT NULL)")
    except Exception:
      if conn is not None:
        conn.close()
      raise
    conn.text_factory = str
    conn.execute("PRAGMA synchronous=OFF")
    conn.execute("PRAGMA mmap_size=10000000")
    return conn
  def   read( self, data_id ):
    result = self.connection.execute("SELECT data FROM items where id=?", (data_id,) )
    data = result.fetchone()
    if not data:
      return None
    return data[0]
  def   write_with_key( self, data_id, data ):
    key = self.id2key.pop( data_id, None )
    if key is not None:
      del self.key2id[key]
    with self.connection as conn:
      cur = conn.execute("INSERT OR REPLACE INTO items(id, data) VALUES (?,?)", (data_id, data))
    key = cur.lastrowid
    self.key2id[key] = data_id
    self.id2key[data_id] = key
    return key
  write = write_with_key
  def   get_ids(self, keys):
    try:
      return tuple( map( self.key2id.__getitem__, keys ) )
    except KeyError:
      return None
  def   get_keys( self, data_ids ):
    return map( self.id2key.__getitem__, data_ids )
  def   remove( self, data_ids ):
    with self.connection as conn:
      conn.executemany("DELETE FROM items WHERE id=?", zip(data_ids) )
    get_key = self.id2key.__getitem__
    del_key = self.key2id.__delitem__
    del_id = self.id2key.__delitem__
    for data_id in data_ids:
      key = get_key( data_id )
      del_key( key )
      del_id( data_id )
  def   selfTest( self ):
    if self.connection is None:
      if self.id2key:
        raise AssertionError("id2key is not empty")
      if self.key2id:
        raise AssertionError("key2id is not empty")
      return
    key2id = self.key2id.copy()
    id2key = self.id2key.copy()
    for key, data_id in self.connection.execute("SELECT key,id FROM items"):
      if key2id.pop( key, None ) is None:
        raise AssertionError("key(%s) not in self.key2id" % (key,))
      if id2key.pop( data_id, None ) is None:
        raise AssertionError("data_id(%s) not in self.id2key" % (data_id,))
    if key2id:
      raise AssertionError("unknown keys: %s" % (key2id,))
    if id2key:
      raise AssertionError("unknown data_ids: %s" % (id2key,))
class   ErrorNoPrograms( AqlException ):
  def   __init__( self, prog ):
    msg = "No programs were specified: %s(%s)" % (prog,type(prog))
    super(type(self), self).__init__( msg )
def   absFilePath( file_path, path_sep = os.path.sep,
                              seps = (os.path.sep, os.path.altsep),
                              _abspath = os.path.abspath,
                              _normcase = os.path.normcase):
  if not file_path:
    file_path = '.'
  if file_path[-1] in seps:
    last_sep = path_sep
  else:
    last_sep = ''
  return _normcase( _abspath( file_path ) ) + last_sep
def   expandFilePath( path, _normpath = os.path.normpath, _expanduser = os.path.expanduser, _expandvars = os.path.expandvars ):
  return _normpath( _expanduser( _expandvars(path) ) )
def   excludeFilesFromDirs( files, dirs ):
  result = []
  folders = tuple( os.path.normcase( os.path.abspath( folder ) ) + os.path.sep for folder in toSequence( dirs ) )
  for file in toSequence( files ):
    file = os.path.normcase( os.path.abspath( file ) )
    if not file.startswith( folders ):
      result.append( file )
  return result
def   _masksToMatch( masks, _null_match = lambda name: False ):
  if not masks:
    return _null_match
  if isString( masks ):
    masks = masks.split('|')
  re_list = []
  for mask in toSequence( masks ):
    re_list.append( "(%s)" % fnmatch.translate( os.path.normcase( mask ).strip() ) )
  re_str = '|'.join(re_list)
  return re.compile(re_str).match
def  findFiles( paths = ".", mask = ("*", ), exclude_mask = tuple(), exclude_subdir_mask = ('__*', '.*') ):
  found_files = []
  paths = toSequence(paths)
  match_mask = _masksToMatch( mask )
  match_exclude_mask = _masksToMatch( exclude_mask )
  match_exclude_subdir_mask = _masksToMatch( exclude_subdir_mask )
  for path in paths:
    for root, folders, files in os.walk( os.path.abspath( path ) ):
      for file_name in files:
        file_name_nocase = os.path.normcase( file_name )
        if (not match_exclude_mask(file_name_nocase)) and match_mask( file_name_nocase ):
          found_files.append( os.path.join(root, file_name) )
      folders[:] = ( folder for folder in folders if not match_exclude_subdir_mask( folder ) )
  found_files.sort()
  return found_files
def   findFileInPaths( paths, filename ):
  for path in paths:
    file_path = os.path.join( path, filename )
    if os.access( file_path, os.R_OK ):
      return os.path.normpath( file_path )
  return None
def   _getEnvPath( env, hint_prog = None ):
  paths = env.get('PATH', tuple() )
  if isString( paths ):
    paths = paths.split( os.pathsep )
  paths = [ os.path.expanduser( path ) for path in paths ] 
  if hint_prog:
    hint_dir = os.path.dirname( hint_prog )
    paths.insert(0, hint_dir )
  return paths
def   _getEnvPathExt( env, hint_prog = None, is_windows = (os.name == 'nt'), is_cygwin = (sys.platform == 'cygwin') ):
  if not is_windows and not is_cygwin:
    return tuple()
  if hint_prog:
    hint_ext = os.path.splitext( hint_prog )[1]
    return (hint_ext,)
  path_exts = env.get('PATHEXT', None )
  if path_exts is None:
    path_exts = os.environ.get('PATHEXT', None )
  if isString( path_exts ):
    path_sep = ';' if is_cygwin else os.pathsep
    path_exts = path_exts.split( path_sep )
  if not path_exts:
    path_exts = ['.exe','.cmd','.bat','.com']
  if is_cygwin:
    if '' not in path_exts:
      path_exts = [''] + path_exts
  return path_exts
def   _addProgramExts( progs, exts ):
  progs = toSequence( progs )
  if not exts:
    return tuple(progs)
  result = []
  for prog in progs:
    prog_ext = os.path.splitext(prog)[1]
    if prog_ext or (prog_ext in exts):
      result.append( prog )
    else:
      result += ( prog + ext for ext in exts )
  return result
def   _findProgram( progs, paths ):
  for path in paths:
    for prog in progs:
      prog_path = os.path.join( path, prog )
      if os.access( prog_path, os.X_OK ):
        return os.path.normcase( prog_path )
  return None
def   findProgram( prog, env, hint_prog = None ):
  paths = _getEnvPath( env, hint_prog )
  path_ext = _getEnvPathExt( env, hint_prog )
  progs = _addProgramExts( prog, path_ext )
  return _findProgram( progs, paths )
def   findPrograms( progs, env, hint_prog = None ):
  paths = _getEnvPath( env, hint_prog )
  path_ext = _getEnvPathExt( env, hint_prog )
  result = []
  for prog in progs:
    progs = _addProgramExts( prog, path_ext )
    prog = _findProgram( progs, paths )
    result.append( prog )
  return result
def   findOptionalProgram( prog, env, hint_prog = None ):
  paths = _getEnvPath( env, hint_prog )
  path_ext = _getEnvPathExt( env, hint_prog )
  progs = _addProgramExts( prog, path_ext )
  return _OptionalProgramFinder( progs, paths )
def   findOptionalPrograms( progs, env, hint_prog = None ):
  paths = _getEnvPath( env, hint_prog )
  path_ext = _getEnvPathExt( env, hint_prog )
  result = []
  for prog in progs:
    progs = _addProgramExts( prog, path_ext )
    prog = _OptionalProgramFinder( progs, paths )
    result.append( prog )
  return result
class _OptionalProgramFinder( object ):
  __slots__ = (
    'progs',
    'paths',
    'result',
  )
  def   __init__(self, progs, paths ):
    if not progs:
      raise ErrorNoPrograms( progs )
    self.progs  = progs
    self.paths  = paths
    self.result = None
  def   __nonzero__(self):
    return bool(self.get())
  def   __bool__(self):
    return bool(self.get())
  def   __call__(self):
    return self.get()
  def   __str__(self):
    return self.get()
  def   get(self):
    progpath = self.result
    if progpath:
      return progpath
    prog_full_path = _findProgram( self.progs, self.paths )
    if prog_full_path is not None:
      self.result = prog_full_path
      return prog_full_path
    self.result = self.progs[0]
    return self.result
def  _normLocalPath( path ):
  if not path:
    return '.'
  path_sep = os.path.sep
  if path[-1] in (path_sep, os.path.altsep):
    last_sep = path_sep
  else:
    last_sep = ''
  path = os.path.normcase( os.path.normpath( path ) )
  return path + last_sep
try:
  _splitunc = os.path.splitunc
except AttributeError:
  def _splitunc( path ):
    return str(), path
def   splitDrive( path ):
  drive, path = os.path.splitdrive( path )
  if not drive:
    drive, path = _splitunc( path )
  return drive, path
def _splitPath( path ):
  drive, path = splitDrive( path )
  path = path.split( os.path.sep )
  path.insert( 0, drive )
  return path
def   splitPath( path ):
  path = os.path.normcase( os.path.normpath( path ) )
  path = _splitPath( path )
  path = [p for p in path if p]
  return path
def   _commonPrefixSize( *paths ):
  min_path = min( paths )
  max_path = max( paths )
  i = 0
  for i, path in enumerate( min_path[:-1] ):
    if path != max_path[i]:
      return i
  return i + 1
def   _relativeJoin( base_path, base_path_seq, path, sep = os.path.sep ):
  path = _splitPath( _normLocalPath( path ) )
  prefix_index = _commonPrefixSize( base_path_seq, path )
  if prefix_index == 0:
    drive = path[0]
    if drive:
      drive = drive.replace(':','').split( sep )
      del path[0]
      path[0:0] = drive
  else:
    path = path[prefix_index:]
  path.insert( 0, base_path )
  path = filter( None, path )
  return sep.join( path )
def   relativeJoinList( base_path, paths ):
  base_path = _normLocalPath( base_path )
  base_path_seq = _splitPath( base_path )
  return [ _relativeJoin( base_path, base_path_seq, path ) for path in toSequence( paths ) ]
def   relativeJoin( base_path, path ):
  base_path = _normLocalPath( base_path )
  base_path_seq = _splitPath( base_path )
  return _relativeJoin( base_path, base_path_seq, path )
def   changePath( path, dirname = None, name = None, ext = None, prefix = None ):
  path_dirname, path_filename = os.path.split( path )
  path_name, path_ext = os.path.splitext( path_filename )
  if dirname is None: dirname = path_dirname
  if name is None: name = path_name
  if ext is None: ext = path_ext
  if prefix: name = prefix + name
  path = dirname
  if path:
    path += os.path.sep
  return path + name + ext
def   groupPathsByDir( file_paths, wish_groups = 1, max_group_size = -1, pathGetter = None ):
  groups = ItemsGroups( len(file_paths), wish_groups, max_group_size )
  if pathGetter is None:
    pathGetter = lambda path: path
  files = []
  for file_path in file_paths:
    path = pathGetter( file_path )
    dir_path, file_name = os.path.split( path )
    dir_path = os.path.normcase( dir_path )
    files.append( (dir_path, file_path) )
  files.sort( key = operator.itemgetter(0) )
  last_dir = None
  for dir_path, file_path in files:
    if last_dir != dir_path:
      last_dir = dir_path
      groups.addGroup()
    groups.add( file_path )
  return groups.get()
class   Chdir (object):
  __slots__ = ('previous_path', )
  def   __init__(self, path = None ):
    self.previous_path = os.getcwd()
    if path:
      os.chdir( path )
  def   __enter__(self):
    return self
  def   __exit__(self, exc_type, exc_val, exc_tb):
    os.chdir( self.previous_path )
    return False
class   ErrorEntitiesFileUnknownEntity( AqlException ):
  def   __init__( self, entity ):
    msg = "Unknown entity: %s" % (entity, )
    super(type(self), self).__init__( msg )
class EntitiesFile (object):
  __slots__ = (
    'data_file',
    'file_lock',
    'cache',
    'pickler',
  )
  def   __init__( self, filename, use_sqlite = False, force = False ):
    self.cache = {}
    self.data_file = None
    self.pickler = EntityPickler()
    self.open( filename, use_sqlite = use_sqlite, force = force )
  def   __enter__(self):
    return self
  def   __exit__(self, exc_type, exc_entity, traceback):
    self.close()
  def   open( self, filename, use_sqlite = False, force = False ):
    self.file_lock = FileLock( filename )
    self.file_lock.writeLock( wait = False, force = force )
    if use_sqlite:
      self.data_file = SqlDataFile( filename, force = force )
    else:
      self.data_file = DataFile( filename, force = force )
  def   close( self ):
    self.cache.clear()
    if self.data_file is not None:
      self.data_file.close()
      self.data_file = None
    self.file_lock.releaseLock()
  def   clear(self):
    if self.data_file is not None:
      self.data_file.clear()
    self.cache.clear()
  def   findNodeEntity( self, entity ):
    entity_id = entity.id
    dump = self.data_file.read( entity_id )
    if dump is None:
      return None
    try:
      entity = self.pickler.loads( dump )
      entity.id = entity_id
    except Exception:
      self.data_file.remove( (entity_id,) )
      return None
    return entity
  def   addNodeEntity( self, entity ):
    dump = self.pickler.dumps( entity )
    self.data_file.write( entity.id, dump )
  def   removeNodeEntities( self, entities ):
    entity_ids = map( operator.attrgetter('id'), entities )
    self.data_file.remove( entity_ids )
  def   _findEntityById( self, entity_id ):
    try:
      return self.cache[ entity_id ]
    except KeyError:
      pass
    data = self.data_file.read( entity_id )
    if data is None:
      raise ValueError()
    try:
      entity = self.pickler.loads( data )
      entity.id = entity_id
    except Exception:
      self.data_file.remove( (entity_id,) )
      raise ValueError()
    self.cache[ entity_id ] = entity
    return entity
  def   findEntitiesByKey( self, keys ):
    entity_ids = self.data_file.get_ids( keys )
    if entity_ids is None:
      return None
    try:
      return list( map( self._findEntityById, entity_ids ) )
    except Exception:
      return None
  def   findEntities( self, entities ):
    try:
      return list( map( self._findEntityById, map( operator.attrgetter('id'), entities ) ) )
    except Exception:
      return None
  def   addEntities( self, entities ):
    keys = []
    entity_ids = []
    key_append = keys.append
    entity_append = entity_ids.append
    for entity in entities:
      entity_id = entity.id
      try:
        stored_entity = self._findEntityById( entity_id )
        if stored_entity == entity:
          entity_append( entity_id )
          continue
      except Exception:
        pass
      key = self.updateEntity( entity )
      key_append( key )
    keys.extend( self.data_file.get_keys( entity_ids ) )
    return keys
  def   updateEntity( self, entity ):
    entity_id = entity.id
    self.cache[ entity_id ] = entity
    data = self.pickler.dumps( entity )
    key = self.data_file.write_with_key( entity_id, data )
    return key
  def   removeEntities( self, entities ):
    remove_ids = tuple( map( operator.attrgetter('id'), entities ) )
    for entity_id in remove_ids:
      try:
        del self.cache[ entity_id ]
      except KeyError:
        pass
    self.data_file.remove( remove_ids )
  def   selfTest(self):
    if self.data_file is None:
      if self.cache:
        raise AssertionError("cache is not empty")
      return
    self.data_file.selfTest()
    for entity_id, entity in self.cache.items():
      if entity_id != entity.id:
        raise AssertionError("entity_id(%s) != entity.id(%s)" % (entity_id, entity.id))
      dump = self.data_file.read( entity_id )
      stored_entity = self.pickler.loads( dump )
      if stored_entity != entity:
        raise AssertionError("stored_entity(%s) != entity(%s)" % (stored_entity.id, entity.id) )
class   ErrorEntityNameEmpty( AqlException ):
  def   __init__( self ):
    msg = "Entity name is empty"
    super(type(self), self).__init__( msg )
class   ErrorSignatureEntityInvalidDataType( AqlException ):
  def   __init__( self, data ):
    msg = "Signature data type must be bytes or bytearray, actual type: '%s'" % (type(data),)
    super(type(self), self).__init__( msg )
class   ErrorTextEntityInvalidDataType( AqlException ):
  def   __init__( self, text ):
    msg = "Text data type must be string, actual type: '%s'" % (type(text),)
    super(type(self), self).__init__( msg )
class   EntityBase (object):
  __slots__ = ( 'id', 'name', 'signature', 'tags' )
  def   __new__( cls, name, signature, tags = None ):
    self = super(EntityBase,cls).__new__(cls)
    if name is not NotImplemented:
      if not name:
        raise ErrorEntityNameEmpty()
      self.name = name
    if signature is not NotImplemented:
      self.signature = signature
    self.tags = frozenset( toSequence(tags) ) if tags else None
    return self
  def   __hash__(self):
    return hash( self.id )
  def   get(self):
    """
    Returns value of the entity
    """
    raise NotImplementedError( "Abstract method. It should be implemented in a child class." )
  def   getId(self):
    cls = self.__class__
    return simpleObjectSignature( (self.name, cls.__name__, cls.__module__) )
  def   getName(self):
    raise NotImplementedError( "Abstract method. It should be implemented in a child class." )
  def   getSignature(self):
    raise NotImplementedError( "Abstract method. It should be implemented in a child class." )
  def   __getattr__(self, attr):
    if attr == 'signature':
      self.signature = signature = self.getSignature()
      return signature
    elif attr == 'name':
      self.name = name = self.getName()
      return name
    elif attr == 'id':
      self.id = id = self.getId()
      return id
    raise AttributeError("Unknown attribute: '%s'" % (attr,))
  def     __getnewargs__(self):
    raise NotImplementedError( "Abstract method. It should be implemented in a child class." )
  def   isActual( self ):
    """
    Checks whether the entity is actual or not
    """
    return bool(self.signature)
  def   getActual( self ):
    """
    Returns an actual entity. If the current entity is actual then it will be simply returned 
    """
    return self
  def   __getstate__(self):
    return {}
  def   __setstate__(self, state):
    pass
  def   __eq__( self, other):
    return (self.id == other.id) and            (self.signature == other.signature)
  def   __ne__( self, other ):
    return not self.__eq__( other )
  def   __str__(self):
    return castStr(self.get())
  def   remove( self ):
    pass
@pickleable
class   SimpleEntity ( EntityBase ):
  __slots__ = ('data', )
  def   __new__(cls, data = None, name = None, signature = None, tags = None ):
    if data is None:
      signature = None
    else:
      if signature is None:
        signature = simpleObjectSignature( data )
    if not name:
      name = signature
    self = super(SimpleEntity, cls).__new__( cls, name, signature, tags )
    self.data = data
    return self
  def   get(self):
    return self.data
  def     __getnewargs__(self):
    tags = self.tags
    if not tags:
      tags = None
    name = self.name
    if name == self.signature:
      name = None
    return self.data, name, self.signature, tags
@pickleable
class   NullEntity ( EntityBase ):
  def   __new__(cls):
    name = 'N'
    signature = None
    return super(NullEntity, cls).__new__( cls, name, signature )
  def   get(self):
    return None
  def     __getnewargs__(self):
    return tuple()
  def   isActual( self ):
    return False
@pickleable
class   SignatureEntity (EntityBase):
  def   __new__( cls, data = None, name = None, tags = None ):
    if data is not None:
      if not isinstance( data, (bytes, bytearray) ):
        raise ErrorSignatureEntityInvalidDataType( data )
    if not name:
      name = data
    return super(SignatureEntity, cls).__new__( cls, name, data, tags )
  def   get(self):
    return self.signature
  def     __getnewargs__(self):
    tags = self.tags
    if not tags:
      tags = None
    name = self.name
    if name == self.signature:
      name = None
    return self.signature, name, tags
@eventWarning
def   eventToolsUnableLoadModule( settings, module, err ):
  logWarning( "Unable to load module: %s, error: %s" % (module, err) )
@eventWarning
def   eventToolsToolFailed( settings, ex, tool_info ):
  tool_class = tool_info.tool_class
  module = tool_class.__module__
  try:
    file = sys.modules[ module ].__file__
  except Exception:
    file = module[module.rfind('.') + 1:] + '.py'
  names = ','.join( tool_info.names )
  logError( "Failed to initialize tool: name: %s, class: %s, file: %s" % (names, tool_class.__name__, file ))
  logError( ex )
def   _toolSetupStub( options ):
  pass
class   ErrorToolInvalid( AqlException ):
  def   __init__( self, tool_class ):
    msg = "Invalid tool type: '%s'" % (tool_class,)
    super(type(self), self).__init__( msg )
class   ErrorToolInvalidSetupMethod( AqlException ):
  def   __init__( self, method ):
    msg = "Invalid tool setup method: '%s'" % (method,)
    super(type(self), self).__init__( msg )
class   ErrorToolNotFound( AqlException ):
  def   __init__( self, tool_name, loaded_paths ):
    loaded_paths = ', '.join( loaded_paths )
    msg = "Tool '%s' has not been found in the following paths: %s" % (tool_name, loaded_paths)
    super(type(self), self).__init__( msg )
class   ToolInfo( object ):
  __slots__ = (
    'tool_class',
    'names',
    'options',
    'setup_methods',
  )
  def   __getattr__( self, attr ):
    if attr == 'options':
      self.options = self.tool_class.options()
      return self.options
    raise AttributeError( "%s instance has no attribute '%s'" % (type(self), attr) )
class ToolsManager( object ):
  __slots__ = (
    'tool_classes',
    'tool_names',
    'tool_info',
    'all_setup_methods',
    'loaded_paths'
  )
  def   __init__( self ):
    self.tool_classes = {}
    self.tool_names = {}
    self.all_setup_methods = {}
    self.tool_info = {}
    self.loaded_paths = []
  @staticmethod
  def   __addToMap( values_map, names, value ):
    for name in names:
      try:
        value_list = values_map[ name ]
        if value in value_list:
          continue
      except KeyError:
        value_list = []
        values_map[ name ] = value_list
      value_list.insert( 0, value )
  def   addTool( self, tool_class, names ):
    if not issubclass( tool_class, Tool ):
      raise ErrorToolInvalid( tool_class )
    if names:
      names = tuple( toSequence( names ) )
      self.tool_names.setdefault( tool_class, set() ).update( names )
      self.__addToMap( self.tool_classes, names, tool_class )
  def   addSetup( self, setup_method, names ):
    if not hasattr(setup_method, '__call__'):
      raise ErrorToolInvalidSetupMethod( setup_method )
    names = toSequence( names )
    self.__addToMap( self.all_setup_methods, names, setup_method )
  def   loadTools( self, paths ):
    for path in toSequence( paths ):
      path = expandFilePath( path )
      if path in self.loaded_paths:
        continue
      self.loaded_paths.append( path )
      module_files = findFiles( path, mask = "*.py" )
      if not module_files:
        continue
      try:
        package = loadPackage( path, generate_name = True )
        package_name = package.__name__
      except ImportError:
        package_name = None
      for module_file in module_files:
        try:
          loadModule( module_file, package_name )
        except Exception as ex:
          eventToolsUnableLoadModule( module_file, ex )
  def   __getToolInfoList( self, name ):
    tools_info = []
    if (type(name) is type) and issubclass( name, Tool ):
      tool_classes = ( name, )
    else:
      tool_classes = self.tool_classes.get( name, tuple() )
    for tool_class in tool_classes:
      tool_info = self.tool_info.get( tool_class, None )
      if tool_info is None:
        names = self.tool_names.get( tool_class, [] )
        tool_info = ToolInfo()
        tool_info.tool_class = tool_class
        tool_info.names = names
        self.tool_info[ tool_class ] = tool_info
        setup_methods = set()
        tool_info.setup_methods = setup_methods
        for name in names:
          setup_methods.update( self.all_setup_methods.get( name, [] ) )
        if not setup_methods:
          setup_methods.add( _toolSetupStub )
      tools_info.append( tool_info )
    return tools_info
  def   getTool( self, tool_name, options, no_errors = False ):
    tool_info_list = self.__getToolInfoList( tool_name )
    for tool_info in tool_info_list:
      for setup in tool_info.setup_methods:
        tool_options = options.override()
        try:
          tool_options.merge( tool_info.options )
          setup( tool_options )
          tool_info.tool_class.setup( tool_options )
          if tool_options.hasChangedKeyOptions():
            raise NotImplementedError()
          tool_obj = tool_info.tool_class( tool_options )
        except NotImplementedError:
          tool_options.clear()
        except Exception as ex:
            tool_options.clear()
            eventToolsToolFailed( ex, tool_info )
            if no_errors:
              raise
        else:
          tool_names = self.tool_names.get( tool_info.tool_class, tuple() )
          return tool_obj, tool_names, tool_options
    raise ErrorToolNotFound( tool_name, self.loaded_paths )
  def   hasTool( self, tool_name ):
    return tool_name in self.tool_classes
_tools_manager = ToolsManager()
def   getToolsManager():
  return _tools_manager
def   tool( *tool_names ):
  def   _tool( tool_class ):
    _tools_manager.addTool( tool_class, tool_names )
    return tool_class
  return _tool
def   toolSetup( *tool_names ):
  def   _tool_setup( setup_method ):
    _tools_manager.addSetup( setup_method, tool_names )
    return setup_method
  return _tool_setup
class Tool( object ):
  def   __init__( self, options ):
    pass
  @classmethod
  def   setup( cls, options ):
    pass
  @classmethod
  def   options( cls ):
    return None
  @classmethod
  def   findProgram( cls, options, prog, hint_prog = None ):
    env = options.env.get()
    prog = findProgram( prog, env, hint_prog )
    if prog is None:
      raise NotImplementedError()
    return prog
  @classmethod
  def   findPrograms( cls, options, progs, hint_prog = None ):
    env = options.env.get()
    progs = findPrograms( progs, env, hint_prog )
    for prog in progs:
      if prog is None:
        raise NotImplementedError()
    return progs
  @classmethod
  def   findOptionalProgram( cls, options, prog, hint_prog = None ):
    env = options.env.get()
    return findOptionalProgram( prog, env, hint_prog )
  @classmethod
  def   findOptionalPrograms( cls, options, progs, hint_prog = None ):
    env = options.env.get()
    return findOptionalPrograms( progs, env, hint_prog )
class   ErrorOptionsCyclicallyDependent( TypeError ):
  def   __init__( self ):
    msg = "Options cyclically depend from each other."
    super(type(self), self).__init__( msg )
class   ErrorOptionsMergeNonOptions( TypeError ):
  def   __init__( self, value ):
    msg = "Type '%s' can't be merged with Options." % (type(value),)
    super(type(self), self).__init__( msg )
class   ErrorOptionsMergeDifferentOptions( TypeError ):
  def   __init__( self, name1, name2):
    msg = "Can't merge one an optional value into two different options '%s' and '%s' " % ( name1, name2 )
    super(type(self), self).__init__( msg )
class   ErrorOptionsMergeChild( TypeError ):
  def   __init__( self ):
    msg = "Can't merge child options into the parent options. Use join() to move child options into its parent."
    super(type(self), self).__init__( msg )
class   ErrorOptionsJoinNoParent( TypeError ):
  def   __init__( self, options ):
    msg = "Can't join options without parent: %s" % ( options, )
    super(type(self), self).__init__( msg )
class   ErrorOptionsJoinParent( TypeError ):
  def   __init__( self, options ):
    msg = "Can't join options with children: %s" % ( options, )
    super(type(self), self).__init__( msg )
class   ErrorOptionsNoIteration( TypeError ):
  def   __init__( self ):
    msg = "Options doesn't support iteration"
    super(type(self), self).__init__( msg )
class   ErrorOptionsUnableEvaluate( TypeError ):
  def   __init__( self, name, err ):
    msg = "Unable to evaluate option '%s', error: %s" % (name, err)
    super(type(self), self).__init__( msg )
class   _OpValueRef( tuple ):
  def   __new__( cls, value ):
    return super(_OpValueRef, cls).__new__( cls, (value.name, value.key ) )
  def   get( self, options, context ):
    name, key = self
    value = getattr( options, name ).get( context )
    if key is not NotImplemented:
      value = value[ key ]
    return value
class   _OpValueExRef( tuple ):
  def   __new__( cls, value ):
    return super(_OpValueExRef, cls).__new__( cls, (value.name, value.key, value.options ) )
  def   get( self ):
    name, key, options = self
    value = getattr( options, name ).get()
    if key is not NotImplemented:
      value = value[ key ]
    return value
def   _storeOpValue( options, value ):
  if isinstance( value, OptionValueProxy ):
    value_options = value.options
    if (options is value_options) or options._isParent( value_options ):
      value = _OpValueRef( value )
    else:
      value_options._addDependency( options )
      value = _OpValueExRef( value )
  elif isinstance( value, dict ):
    value = dict( (k,_storeOpValue( options, v )) for k, v in value.items() )
  elif isinstance( value, (list, tuple, UniqueList, set, frozenset) ):
    value = [ _storeOpValue( options, v ) for v in value ]
  return value
def   _loadOpValue( options, context, value ):
  if isinstance( value, _OpValueRef ):
    value = value.get( options, context )
    value = simplifyValue( value )
  elif isinstance( value, _OpValueExRef ):
    value = value.get()
    value = simplifyValue( value )
  elif isinstance( value, dict ):
    value = dict( (k, _loadOpValue( options, context, v )) for k, v in value.items() )
  elif isinstance( value, (list, tuple, UniqueList, set, frozenset) ):
    value = [ _loadOpValue( options, context, v ) for v in value ]
  else:
    value = simplifyValue( value )
  return value
def   _evalCmpValue( value ):
  if isinstance( value, OptionValueProxy ):
    value = value.get()
  value = simplifyValue( value )  
  return value
class OptionValueProxy (object):
  def   __init__( self, option_value, from_parent, name, options, key = NotImplemented ):
    self.option_value = option_value
    self.from_parent = from_parent
    self.name = name
    self.options = options
    self.key = key
    self.child_ref = None
  def   isSet( self ):
    return self.option_value.isSet()
  def   isSetNotTo( self, value ):
    return self.option_value.isSet() and (self != value )
  def   get( self, context = None ):
    self.child_ref = None
    v = self.options.evaluate( self.option_value, context, self.name )
    return v if self.key is NotImplemented else v[self.key]
  def   __iadd__( self, other ):
    self.child_ref = None
    if self.key is not NotImplemented:
      other = iAddKey(self.key, other)
    self.options._appendValue( self.option_value, self.from_parent, other, iAddValue )
    return self
  def   __add__( self, other ):
    return SimpleOperation( operator.add, self, other )
  def   __radd__( self, other ):
    return SimpleOperation( operator.add, other, self )
  def   __sub__( self, other ):
    return SimpleOperation( operator.sub, self, other )
  def   __rsub__( self, other ):
    return SimpleOperation( operator.sub, other, self )
  def   __isub__( self, other ):
    self.child_ref = None
    if self.key is not NotImplemented:
      other = iSubKey(self.key, other)
    self.options._appendValue( self.option_value, self.from_parent, other, iSubValue )
    return self
  def   set( self, value ):
    self.child_ref = None
    if self.key is not NotImplemented:
      value = SetKey(self.key, value)
    self.options._appendValue( self.option_value, self.from_parent, value, SetValue )
  def   __setitem__( self, key, value ):
    child_ref = self.child_ref
    if (child_ref is not None) and (child_ref() is value):
      return
    if self.key is not NotImplemented:
      raise KeyError( key )
    option_type = self.option_value.option_type
    if isinstance( option_type, DictOptionType ):
      if isinstance( value, OptionType ) or (type(value) is type):
        option_type.setValueType( key, value )
        return
    value = SetKey( key, value )
    self.child_ref = None
    self.options._appendValue( self.option_value, self.from_parent, value, SetValue )
  def   __getitem__( self, key ):
    if self.key is not NotImplemented:
      raise KeyError( key )
    child = OptionValueProxy( self.option_value, self.from_parent, self.name, self.options, key )
    self.child_ref = weakref.ref( child )
    return child
  def   update( self, value ):
    self.child_ref = None
    self.options._appendValue( self.option_value, self.from_parent, value, iUpdateValue )
  def   __iter__(self):
    raise TypeError()
  def   __bool__(self):
    return bool( self.get( context = None ) )
  def   __nonzero__(self):
    return bool( self.get( context = None ) )
  def   __str__(self):
    return str( self.get( context = None ) )
  def   isTrue( self, context ):
    return bool( self.get( context ) )
  def   isFalse( self, context ):
    return not bool( self.get( context ) )
  def   eq( self, context, other ):   return self.cmp( context, operator.eq, other )
  def   ne( self, context, other ):   return self.cmp( context, operator.ne, other )
  def   lt( self, context, other ):   return self.cmp( context, operator.lt, other )
  def   le( self, context, other ):   return self.cmp( context, operator.le, other )
  def   gt( self, context, other ):   return self.cmp( context, operator.gt, other )
  def   ge( self, context, other ):   return self.cmp( context, operator.ge, other )
  def   __eq__( self, other ):        return self.eq( None,   _evalCmpValue( other ) )
  def   __ne__( self, other ):        return self.ne( None,   _evalCmpValue( other ) )
  def   __lt__( self, other ):        return self.lt( None,   _evalCmpValue( other ) )
  def   __le__( self, other ):        return self.le( None,   _evalCmpValue( other ) )
  def   __gt__( self, other ):        return self.gt( None,   _evalCmpValue( other ) )
  def   __ge__( self, other ):        return self.ge( None,   _evalCmpValue( other ) )
  def   __contains__( self, other ):  return self.has( None,  _evalCmpValue( other ) )
  def   cmp( self, context, cmp_operator, other ):
    self.child_ref = None
    value = self.get( context )
    if not isinstance( value, (Dict, List)) and (self.key is NotImplemented):
      other = self.option_value.option_type( other )
    return cmp_operator( value, other )
  def   has( self, context, other ):
    value = self.get( context )
    return other in value
  def   hasAny( self, context, others ):
    value = self.get( context )
    for other in toSequence( others ):
      if other in value:
        return True
    return False
  def   hasAll( self, context, others ):
    value = self.get( context )
    for other in toSequence( others ):
      if other not in value:
        return False
    return True
  def   oneOf( self, context, others ):
    value = self.get( context )
    for other in others:
      other = self.option_value.option_type( other )
      if value == other:
        return True
    return False
  def   notIn( self, context, others ):
    return not self.oneOf( context, others )
  def   optionType( self ):
    self.child_ref = None
    return self.option_value.option_type
class ConditionGeneratorHelper( object ):
  __slots__ = ('name', 'options', 'condition', 'key')
  def     __init__( self, name, options, condition, key = NotImplemented ):
    self.name = name
    self.options = options
    self.condition = condition
    self.key = key
  @staticmethod
  def   __cmpValue( options, context, cmp_method, name, key, *args ):
    opt = getattr( options, name )
    if key is not NotImplemented:
      opt = opt[key]
    return getattr( opt, cmp_method )( context, *args )
  @staticmethod
  def __makeCmpCondition( condition, cmp_method, name, key, *args ):
    return Condition( condition, ConditionGeneratorHelper.__cmpValue, cmp_method, name, key, *args )
  def   cmp( self, cmp_method, *args ):
    condition = self.__makeCmpCondition( self.condition, cmp_method, self.name, self.key, *args )
    return ConditionGenerator( self.options, condition )
  def   __iter__(self):
    raise TypeError()
  def   __getitem__( self, key ):
    if self.key is not NotImplemented:
      raise KeyError( key )
    return ConditionGeneratorHelper( self.name, self.options, self.condition, key )
  def   __setitem__( self, key, value ):
    if not isinstance(value, ConditionGeneratorHelper):
      value = SetKey( key, value )
      self.options.appendValue( self.name, value, SetValue, self.condition )
  def   eq( self, other ):      return self.cmp( 'eq',      other )
  def   ne( self, other ):      return self.cmp( 'ne',      other )
  def   gt( self, other ):      return self.cmp( 'gt',      other )
  def   ge( self, other ):      return self.cmp( 'ge',      other )
  def   lt( self, other ):      return self.cmp( 'lt',      other )
  def   le( self, other ):      return self.cmp( 'le',      other )
  def   has( self, value ):     return self.cmp( 'has',     value )
  def   hasAny( self, values ): return self.cmp( 'hasAny',  values )
  def   hasAll( self, values ): return self.cmp( 'hasAll',  values )
  def   oneOf( self, values ):  return self.cmp( 'oneOf',   values )
  def   notIn( self, values ):  return self.cmp( 'notIn',   values )
  def   isTrue( self ):         return self.cmp( 'isTrue' )
  def   isFalse( self ):        return self.cmp( 'isFalse' )
  def   __iadd__( self, value ):
    if self.key is not NotImplemented:
      value = iAddKey( self.key, value )
    self.options.appendValue( self.name, value, iAddValue, self.condition )
    return self
  def   __isub__( self, value ):
    if self.key is not NotImplemented:
      value = iSubKey( self.key, value )
    self.options.appendValue( self.name, value, iSubValue, self.condition )
    return self
class ConditionGenerator( object ):
  def     __init__( self, options, condition = None ):
    self.__dict__['__options']  = options
    self.__dict__['__condition']  = condition
  def   __getattr__( self, name ):
    return ConditionGeneratorHelper( name, self.__dict__['__options'], self.__dict__['__condition'])
  def     __setattr__(self, name, value):
    if not isinstance(value, ConditionGeneratorHelper):
      condition  = self.__dict__['__condition']
      self.__dict__['__options'].appendValue( name, value, SetValue, condition )
def   _itemsByValue( items ):
  values = {}
  for name, value in items:
    try:
      values[ value ].add( name )
    except KeyError:
      values[ value ] = set( (name,) )
  return values
class Options (object):
  def     __init__( self, parent = None ):
    self.__dict__['__parent']       = parent
    self.__dict__['__cache']        = {}
    self.__dict__['__opt_values']   = {}
    self.__dict__['__children']     = []
    if parent is not None:
      parent.__dict__['__children'].append( weakref.ref( self ) )
  def   _addDependency(self, child ):
    children = self.__dict__['__children']
    for child_ref in children:
      if child_ref() is child:
        return
    if child._isDependency( self ):
      raise ErrorOptionsCyclicallyDependent()
    children.append( weakref.ref( child ) )
  def   _isDependency(self, other ):
    children = list(self.__dict__['__children'])
    while children:
      child_ref = children.pop()
      child = child_ref()
      if child is None:
        continue
      if child is other:
        return True
      children += child.__dict__['__children']
    return False
  def   _isParent( self, other ):
    if other is None:
      return False
    parent = self.__dict__['__parent']
    while parent is not None:
      if parent is other:
        return True
      parent = parent.__dict__['__parent']
    return False
  def   __copyParentOption(self, opt_value ):
    parent = self.__dict__['__parent']
    items = parent._valuesMapByName().items()
    names = [ name for name, value in items if value is opt_value ]
    opt_value = opt_value.copy()
    self.__set_opt_value( opt_value, names )
    return opt_value
  def   getHashRef( self ):
    if self.__dict__['__opt_values']:
      return weakref.ref( self )
    parent = self.__dict__['__parent']
    if parent is None:
      return weakref.ref( self )
    return parent.getHashRef()
  def   hasChangedKeyOptions(self):
    parent = self.__dict__['__parent']
    for name, opt_value in self.__dict__['__opt_values'].items():
      if not opt_value.isToolKey() or not opt_value.isSet():
        continue
      parent_opt_value, from_parent = parent._get_value( name, raise_ex = False )
      if parent_opt_value is None:
        continue
      if parent_opt_value.isSet():
        value = self.evaluate( opt_value, None, name )
        parent_value = parent.evaluate( parent_opt_value, None, name )
        if value != parent_value:
          return True
    return False
  def   __set_value( self, name, value, operation_type = SetValue ):
    opt_value, from_parent = self._get_value( name, raise_ex = False )
    if opt_value is None:
      self.clearCache()
      if isinstance( value, OptionType ):
        opt_value = OptionValue( value )
      elif isinstance( value, OptionValueProxy ):
        if value.options is self:
          if not value.from_parent:
            opt_value = value.option_value
          else:
            opt_value = self.__copyParentOption( value.option_value )
        elif self._isParent( value.options ):
          opt_value = self.__copyParentOption( value.option_value )
        else:
          opt_value = value.option_value.copy()
          opt_value.reset()
          value = self._makeCondValue( value, SetValue )
          opt_value.appendValue( value )
      elif not isinstance( value, OptionValue ):
        opt_value = OptionValue( autoOptionType( value ) )
        value = self._makeCondValue( value, SetValue )
        opt_value.appendValue( value )
      self.__dict__['__opt_values'][ name ] = opt_value
    else:
      if isinstance( value, OptionType ):
        opt_value.option_type = value
        return
      elif isinstance( value, OptionValueProxy ):
        if value.option_value is opt_value:
          return
      elif value is opt_value:
        return
      self._appendValue( opt_value, from_parent, value, operation_type )
  def   __set_opt_value( self, opt_value, names ):
    opt_values = self.__dict__['__opt_values']
    for name in names:
      opt_values[ name ] = opt_value
  def   __setattr__( self, name, value ):
    self.__set_value( name, value )
  def   __setitem__( self, name, value ):
    self.__set_value( name, value )
  def   _get_value( self, name, raise_ex ):
    try:
      return self.__dict__['__opt_values'][ name ], False
    except KeyError:
      parent = self.__dict__['__parent']
      if parent is not None:
        value, from_parent = parent._get_value( name, False )
        if value is not None:
          return value, True
      if raise_ex:
        raise AttributeError( "Options '%s' instance has no option '%s'" % (type(self), name) )
      return None, False
  def   __getitem__( self, name ):
    return self.__getattr__( name )
  def   __getattr__( self, name ):
    opt_value, from_parent = self._get_value( name, raise_ex = True )
    return OptionValueProxy( opt_value, from_parent, name, self )
  def   __contains__( self, name ):
    return self._get_value( name, raise_ex = False )[0] is not None
  def   __iter__( self ):
    raise ErrorOptionsNoIteration()
  def   _valuesMapByName( self, result = None ):
    if result is None:
      result = {}
    parent = self.__dict__['__parent']
    if parent is not None:
      parent._valuesMapByName( result = result )
    result.update( self.__dict__['__opt_values'] )
    return result
  def   _valuesMapByValue( self ):
    items = self._valuesMapByName().items()
    return _itemsByValue( items )
  def   help( self, with_parent = False, hidden = False ):
    if with_parent:
      options_map = self._valuesMapByName()
    else:
      options_map = self.__dict__['__opt_values']
    options2names = _itemsByValue( options_map.items() )
    result = {}
    for option, names in options2names.items():
      option_help = option.option_type.help()
      if option_help.isHidden() and not hidden:
        continue
      option_help.names = names
      try:
        option_help.current_value = self.evaluate( option, {}, names )
      except Exception:
        pass
      group_name = option_help.group if option_help.group else ""
      try:
        group = result[ group_name ]
      except KeyError:
        group = result[ group_name ] = OptionHelpGroup( group_name )
      group.append( option_help )
    return sorted( result.values(), key = operator.attrgetter('name') )
  def   helpText( self, title, with_parent = False, hidden = False, brief = False ):
    border = "=" * len(title)
    result = ["", title, border, ""]
    for group in self.help( with_parent = with_parent, hidden = hidden ):
      text = group.text( brief = brief, indent = 2 )
      if result[-1]:
        result.append("")
      result.extend( text )
    return result
  def   setGroup( self, group ):
    opt_values = self._valuesMapByName().values()
    for opt_value in opt_values:
      if isinstance( opt_value, OptionValueProxy ):
        opt_value = opt_value.option_value
      opt_value.option_type.group = group
  def   __nonzero__( self ):
    return bool(self.__dict__['__opt_values']) or bool(self.__dict__['__parent'])
  def   __bool__( self ):
    return bool(self.__dict__['__opt_values']) or bool(self.__dict__['__parent'])
  def   update( self, other ):
    if not other:
      return
    if self is other:
      return
    if isinstance( other, Options ):
      self.merge( other )
    else:
      for name, value in other.items():
        if isinstance( value, (ConditionGeneratorHelper, ConditionGenerator, Options) ):
          continue
        try:
          self.__set_value( name, value, iUpdateValue )
        except ErrorOptionTypeCantDeduce:
          pass
  def   __merge( self, self_names, other_names, move_values = False ):
    self.clearCache()
    other_values = _itemsByValue( other_names.items() )
    self_names_set = set(self_names)
    self_values = _itemsByValue( self_names.items() )
    for value, names in other_values.items():
      same_names = names & self_names_set
      if same_names:
        self_value_name   = next(iter(same_names))
        self_value        = self_names[ self_value_name ]
        self_values_names = self_values[ self_value ]
        self_other_names  = same_names - self_values_names
        if self_other_names:
          raise ErrorOptionsMergeDifferentOptions( self_value_name, self_other_names.pop() )
        else:
          new_names = names - self_values_names
          self_value.merge( value )
      else:
        if move_values:
          self_value = value
        else:
          self_value = value.copy()
        new_names = names
      self.__set_opt_value( self_value, new_names )
  def   merge( self, other ):
    if not other:
      return
    if self is other:
      return
    if not isinstance( other, Options ):
      raise ErrorOptionsMergeNonOptions( other )
    if other._isParent( self ):
      raise ErrorOptionsMergeChild()
    self.__merge( self._valuesMapByName(), other._valuesMapByName() )
  def   join( self ):
    parent = self.__dict__['__parent']
    if parent is None:
      raise ErrorOptionsJoinNoParent( self )
    if self.__dict__['__children']:
      raise ErrorOptionsJoinParent( self )
    parent.__merge( parent.__dict__['__opt_values'],
                    self.__dict__['__opt_values'],
                    move_values = True )
    self.clear()
  def   unjoin( self ):
    parent = self.__dict__['__parent']
    if parent is None:
      return
    self.__merge( self.__dict__['__opt_values'], parent._valuesMapByName() )
    self.__dict__['__parent'] = None
  def   __unjoinChildren( self ):
    children = self.__dict__['__children']
    for child_ref in children:
      child = child_ref()
      if child is not None:
        child.unjoin()
    del children[:]
  def   __clearChildrenCache( self ):
    def   _clearChildCache( ref ):
      child = ref()
      if child is not None:
        child.clearCache()
        return True
      return False
    self.__dict__['__children'] = list( filter( _clearChildCache, self.__dict__['__children'] ) )
  def   __removeChild( self, child ):
    def   _filterChild( child_ref, removed_child = child ):
      filter_child = child_ref()
      return (filter_child is not None) and (filter_child is not removed_child)
    self.__dict__['__children'] = list( filter( _filterChild, self.__dict__['__children'] ) )
  def   clear( self ):
    parent = self.__dict__['__parent']
    self.__unjoinChildren()
    if parent is not None:
      parent.__removeChild( self )
    self.__dict__['__parent'] = None
    self.__dict__['__cache'].clear()
    self.__dict__['__opt_values'].clear()
  def   override( self, **kw ):
    other = Options( self )
    other.update( kw )
    return other
  def     copy( self ):
    other = Options()
    for opt_value, names in self._valuesMapByValue().items():
      other.__set_opt_value( opt_value.copy(), names )
    return other
  def   _evaluate( self, option_value, context ):
    try:
      if context is not None:
        return context[ option_value ]
    except KeyError:
      pass
    attrs = self.__dict__
    if attrs['__opt_values']:
      cache = attrs['__cache']
    else:
      cache = attrs['__parent'].__dict__['__cache']
    try:
      return cache[ option_value ]
    except KeyError:
      pass
    value = option_value.get( self, context, _loadOpValue )
    cache[ option_value ] = value
    return value
  def   evaluate( self, option_value, context, name ):
    try:
      return self._evaluate( option_value, context )
    except ErrorOptionTypeUnableConvertValue as ex:
      if not name:
        raise
      option_help = ex.option_help
      if option_help.names:
        raise
      option_help.names = tuple( toSequence( name ) )
      raise ErrorOptionTypeUnableConvertValue( option_help, ex.invalid_value )
    except Exception as ex:
      raise ErrorOptionsUnableEvaluate( name, ex )
  def   _storeValue( self, value ):
    if isinstance( value, Operation ):
      value.convert( self, _storeOpValue )
    else:
      value = _storeOpValue( self, value )
    return value
  def   _loadValue( self, value ):
    if isinstance( value, Operation ):
      return value( self, {}, _loadOpValue )
    else:
      value = _loadOpValue( self, {}, value )
    return value
  def   _makeCondValue( self, value, operation_type, condition = None ):
    if isinstance(value, ConditionalValue ):
      return value
    if not isinstance( value, InplaceOperation ):
      value = operation_type( value )
    value = ConditionalValue( value, condition )
    value.convert( self, _storeOpValue )
    return value
  def   appendValue( self, name, value, operation_type, condition = None ):
    opt_value, from_parent = self._get_value( name, raise_ex = True )
    self._appendValue( opt_value, from_parent, value, operation_type, condition )
  def   _appendValue( self, opt_value, from_parent, value, operation_type, condition = None ):
    value = self._makeCondValue( value, operation_type, condition )
    self.clearCache()
    if from_parent:
      opt_value = self.__copyParentOption( opt_value )
    opt_value.appendValue( value )
  def   clearCache( self ):
    self.__dict__['__cache'].clear()
    self.__clearChildrenCache()
  def   If( self ):
    return ConditionGenerator( self )
class   ErrorFileEntityNoName( AqlException ):
  def   __init__( self ):
    msg = "Filename is not specified"
    super(type(self), self).__init__( msg )
class   FileEntityBase (EntityBase):
  def   __new__( cls, name, signature = NotImplemented, tags = None ):
    if isinstance(name, FileEntityBase):
      name = name.name
    else:
      if isinstance(name, EntityBase):
        name = name.get()
    if not name:
      raise ErrorFileEntityNoName()
    name = os.path.normcase( os.path.abspath( name ) )
    self = super(FileEntityBase, cls).__new__( cls, name, signature, tags = tags )
    return self
  def   get(self):
    return self.name
  def     __getnewargs__(self):
    tags = self.tags
    if not tags:
      tags = None 
    return self.name, self.signature, tags
  def   remove( self ):
    try:
      os.remove( self.name )
    except OSError:
      pass
  def   getActual(self):
    signature = self.getSignature()
    if self.signature == signature:
      return self
    other = super(FileEntityBase, self).__new__( self.__class__, self.name, signature, self.tags )
    return other
  def   isActual( self ):
    if not self.signature:
      return False
    if self.signature == self.getSignature():
      return True
    return False
def   _getFileChecksum( path ):
  try:
    signature = fileSignature( path )
  except (OSError, IOError) as err:
    if err.errno != errno.EISDIR:
      return None
    try:
      signature = fileTimeSignature( path )
    except (OSError, IOError):
      return None
  return signature
def   _getFileTimestamp( path ):
  try:
    signature = fileTimeSignature( path )
  except (OSError, IOError):
    return None
  return signature
@pickleable
class FileChecksumEntity( FileEntityBase ):
  def   getSignature(self):
    return _getFileChecksum( self.name )
@pickleable
class FileTimestampEntity( FileEntityBase ):
  def   getSignature(self):
    return _getFileTimestamp( self.name )
@pickleable
class   DirEntity (FileTimestampEntity):
  def   remove( self ):
    try:
      os.rmdir( self.name )
    except OSError:
      pass
def   _build_options():
  options = Options()
  options.build_path            = PathOptionType( description = "The building directory full path." )
  options.build_dir             = PathOptionType( description = "The building directory.", default = 'build_output' )
  options.relative_build_paths  = BoolOptionType( description = "The building directory suffix.", default = True )
  options.build_dir_name        = StrOptionType( description  = "The building directory name." )
  options.prefix                = StrOptionType( description  = "Output files prefix." )
  options.suffix                = StrOptionType( description  = "Output files suffix." )
  options.target                = StrOptionType( description  = "Output file name." )
  build_variant = EnumOptionType( values =  [
                                              ('debug', 'dbg', 'd' ),
                                              ('release_speed', 'release', 'rel', 'rs', 'speed'),
                                              ('release_size', 'rz', 'rel_size', 'size'),
                                              ('final', 'f'),
                                            ],
                                  default = 'debug',
                                  description = "Current build variant" )
  options.build_variant = build_variant
  options.bv = options.build_variant
  options.build_variants = ListOptionType( value_type = build_variant, unique = True,
                                           description = "Active build variants" )
  options.bvs = options.build_variants
  file_signature = EnumOptionType(  values =  [('checksum', 'md5', 'sign'), ('timestamp', 'time')],
                                    default = 'checksum',
                                    description = "Type used to detect changes in dependency files" )
  options.file_signature = file_signature
  options.signature = options.file_signature
  options.batch_build = BoolOptionType( description = "Prefer batch build." )
  options.batch_groups = OptionType( value_type = int, default = 1, description = "Preferred number of batching groups." )
  options.batch_size = OptionType( value_type = int, default = 0, description = "Preferred size of a batching group." )
  options.setGroup( "Build" )
  return options
def   _target_options():
  options = Options()
  options.target_os = EnumOptionType( values = ['native', 'unknown',
                                                ('windows', 'win32', 'win64'),
                                                ('linux', 'linux-gnu'),
                                                'uclinux',
                                                'cygwin',
                                                'interix',
                                                'freebsd',
                                                'openbsd',
                                                'netbsd',
                                                ('OS-X', 'osx', 'darwin'),
                                                'java',
                                                'sunos',
                                                'hpux',
                                                'vxworks',
                                                'solaris',
                                                'elf'],
                                      default = 'native',
                                      strict = False,
                                      is_tool_key = True,
                                      description = "The target system/OS name, e.g. 'Linux', 'Windows', or 'Java'." )
  options.os = options.target_os
  options.target_arch = EnumOptionType( values = [ 'native', 'unknown',
                                                   ('x86-32', 'x86_32', 'x86', '80x86', 'i386', 'i486', 'i586', 'i686'),
                                                   ('x86-64','x86_64', 'amd64', 'x64'),
                                                   'arm', 'arm64',
                                                   'alpha',
                                                   'mips',
                                                   'ia64',
                                                   'm68k',
                                                   'sparc',
                                                   'sparc64',
                                                   'sparcv9',
                                                   'powerpc',
                                                  ],
                                        default = 'native',
                                        strict = False,
                                        is_tool_key = True,
                                        description = "The target machine type, e.g. 'i386'" )
  options.arch = options.target_arch
  options.target_subsystem = EnumOptionType(  values = [ 'console', 'windows' ],
                                              default = 'console',
                                              description = "The target subsystem." )
  options.target_platform = StrOptionType(  ignore_case = True,
                                            description = "The target system's distribution, e.g. 'win32', 'Linux'" )
  options.target_os_release = StrOptionType(  ignore_case = True,
                                              description = "The target system's release, e.g. '2.2.0' or 'XP'" )
  options.target_os_version = VersionOptionType( description = "The target system's release version, e.g. '2.2.0' or '5.1.2600'" )
  options.target_cpu = StrOptionType( ignore_case = True,
                                      description = "The target real processor name, e.g. 'amdk6'." )
  options.target_cpu_flags = ListOptionType( value_type = IgnoreCaseString,
                                             description = "The target CPU flags, e.g. 'mmx', 'sse2'." )
  options.setGroup( "Target system" )
  return options
def   _optimization_options():
  options = Options()
  options.optimization = EnumOptionType( values = [ ('off', 0), ('size', 1), ('speed', 2) ],
                                         default = 'off',
                                         description = 'Optimization level' )
  options.optlevel = options.optimization
  options.opt = options.optimization
  options.inlining = EnumOptionType( values = ['off', 'on', 'full'],
                                     default = 'off',
                                     description = 'Inline function expansion' )
  options.whole_optimization = BoolOptionType( description = 'Whole program optimization' )
  options.whole_opt = options.whole_optimization
  options.setGroup("Optimization")
  return options
def   _code_gen_options():
  options = Options()
  options.debug_symbols = BoolOptionType( description = 'Include debug symbols', style = ('on', 'off')  )
  options.profile = BoolOptionType( description = 'Enable compiler profiling', style = ('on', 'off')  )
  options.keep_asm = BoolOptionType( description = 'Keep generated assemblers files' )
  options.runtime_link = EnumOptionType( values = ['default', 'static', ('shared', 'dynamic') ],
                                         default = 'default',
                                         description = 'Linkage type of runtime library' )
  options.rt_link = options.runtime_link
  options.runtime_debug = BoolOptionType( description = 'Use debug version of runtime library', style = ('on', 'off')  )
  options.rt_debug = options.runtime_debug
  options.rtti = BoolOptionType( description = 'Enable Run Time Type Information', default = True )
  options.exceptions = BoolOptionType( description = 'Allow to throw exceptions', default = True )
  options.runtime_thread = EnumOptionType( values = ['default', 'single', 'multi' ],
                                           default = 'default',
                                           description = 'Threading mode of runtime library' )
  options.rt_thread = options.runtime_thread
  options.setGroup( "Code generation" )
  return options
def     _diagnostic_options():
  options = Options()
  options.warning_level = RangeOptionType( 0, 4, description = 'Warning level', default = 4 )
  options.warn_level = options.warning_level
  options.warning_as_error = BoolOptionType( description = 'Treat warnings as errors' )
  options.werror = options.warning_as_error
  options.warnings_as_errors = options.warning_as_error
  options.lint = EnumOptionType( values = [('off', 0), ('on', 1), ('global',2)],
                                 default = 'off',
                                 description = 'Lint source code.',
                                 is_hidden = True)
  options.lint_flags = ListOptionType( description = "Lint tool options", is_hidden = True )
  options.setGroup( "Diagnostic" )
  return options
def   _env_options():
  if os.path.normcase('ABC') == os.path.normcase('abc'):
    env_key_type = UpperCaseString
  else:
    env_key_type = String
  options = Options()
  options.env = DictOptionType( key_type = env_key_type )
  options.env['PATH'] = ListOptionType( value_type = PathOptionType(), separators = os.pathsep )
  options.env['PATHEXT'] = ListOptionType( value_type = PathOptionType(), separators = os.pathsep )
  options.env['TEMP'] = PathOptionType()
  options.env['TMP'] = PathOptionType()
  options.env['HOME'] = PathOptionType()
  options.env['HOMEPATH'] = PathOptionType()
  options.env = os.environ.copy()
  return options
def   _init_defaults( options ):
    if_ = options.If()
    if_.target_os.ne('native').build_dir_name    += options.target_os + '_'
    if_.target_arch.ne('native').build_dir_name  += options.target_arch + '_'
    options.build_dir_name += options.build_variant
    options.build_path = SimpleOperation( os.path.join, options.build_dir, options.build_dir_name )
    bv = if_.build_variant
    debug_build_variant = bv.eq('debug')
    debug_build_variant.optimization        = 'off'
    debug_build_variant.inlining            = 'off'
    debug_build_variant.whole_optimization  = 'off'
    debug_build_variant.debug_symbols       = 'on'
    debug_build_variant.runtime_debug       = 'on'
    speed_build_variant = bv.oneOf( ['release_speed', 'final'] )
    speed_build_variant.optimization          = 'speed'
    speed_build_variant.inlining              = 'full'
    speed_build_variant.whole_optimization    = 'on'
    speed_build_variant.debug_symbols         = 'off'
    speed_build_variant.runtime_debug         = 'off'
    size_build_variant = bv.eq('release_size')
    size_build_variant.optimization       = 'size'
    size_build_variant.inlining           = 'on'
    size_build_variant.whole_optimization = 'on'
    size_build_variant.debug_symbols      = 'off'
    size_build_variant.runtime_debug      = 'off'
def     builtinOptions():
    options = Options()
    options.merge( _build_options() )
    options.merge( _target_options() )
    options.merge( _optimization_options() )
    options.merge( _code_gen_options() )
    options.merge( _diagnostic_options() )
    options.merge( _env_options() )
    _init_defaults( options )
    return options
class   ErrorNodeDependencyInvalid( AqlException ):
  def   __init__( self, dep ):
    msg = "Invalid node dependency: %s" % (dep,)
    super(ErrorNodeDependencyInvalid, self).__init__( msg )
class   ErrorNodeSplitUnknownSource( AqlException ):
  def   __init__( self, node, entity ):
    msg = "Node '%s' can't be split to unknown source entity: %s" % (node.getBuildStr( brief = False ), entity )
    super(ErrorNodeSplitUnknownSource, self).__init__( msg )
class   ErrorNoTargets( AttributeError ):
  def   __init__( self, node ):
    msg = "Node targets are not built or set yet: %s" % (node,)
    super(ErrorNoTargets, self).__init__( msg )
class   ErrorNoSrcTargets( AqlException ):
  def   __init__( self, node, src_entity ):
    msg = "Source '%s' targets are not built or set yet: %s" % (src_entity.get(), node)
    super(ErrorNoSrcTargets, self).__init__( msg )
class   ErrorUnactualEntity( AqlException ):
  def   __init__( self, entity ):
    msg = "Target entity is not actual: %s (%s)" % (entity.name, type(entity))
    super(ErrorUnactualEntity, self).__init__( msg )
class   ErrorNodeUnknownSource( AqlException ):
  def   __init__( self, src_entity ):
    msg = "Unknown source entity: %s (%s)" % (src_entity, type(src_entity))
    super(ErrorNodeUnknownSource, self).__init__( msg )
@eventStatus
def   eventNodeStaleReason( brief, reason ):
  msg = reason.getDescription( brief )
  logDebug( msg )
class NodeStaleReason (object):
  __slots__ = (
      'code',
      'entity',
      'builder',
      'sources',
      'targets',
  )
  ACTUAL,   NO_SIGNATURE,   NEW,   SIGNATURE_CHANGED,   IMPLICIT_DEP_CHANGED,   NO_TARGETS,   TARGET_CHANGED,   FORCE_REBUILD,     = range(8)
  def   __init__( self, builder, sources, targets ):
    self.builder = builder
    self.sources = sources
    self.targets = targets
    self.code = self.ACTUAL
    self.entity = None
  def   _set(self, code, entity = None ):
    self.code = code
    self.entity = entity
    eventNodeStaleReason( self )
  def   setNoSignature( self, NO_SIGNATURE = NO_SIGNATURE ):
    self._set( NO_SIGNATURE )
  def   setNew( self, NEW = NEW ):
    self._set( NEW )
  def   setSignatureChanged( self, SIGNATURE_CHANGED = SIGNATURE_CHANGED ):
    self._set( SIGNATURE_CHANGED )
  def   setImplicitDepChanged( self, entity = None, IMPLICIT_DEP_CHANGED = IMPLICIT_DEP_CHANGED ):
    self._set( IMPLICIT_DEP_CHANGED, entity )
  def   setNoTargets( self, NO_TARGETS = NO_TARGETS):
    self._set( NO_TARGETS )
  def   setTargetChanged( self, entity, TARGET_CHANGED = TARGET_CHANGED ):
    self._set( TARGET_CHANGED, entity )
  def   setForceRebuild( self, FORCE_REBUILD = FORCE_REBUILD ):
    self._set( FORCE_REBUILD )
  def   getNodeName( self, brief ):
    return self.builder.getTrace( self.sources, self.targets, brief )
  def   getDescription( self, brief = True ):
    node_name = self.getNodeName( brief )
    code = self.code
    if code == NodeStaleReason.NO_SIGNATURE:
      msg = "Node`s is marked to rebuild always, rebuilding the node: %s" % node_name
    elif code == NodeStaleReason.SIGNATURE_CHANGED:
      msg = "Node`s signature has been changed (sources, builder parameters or dependencies were changed), rebuilding the node: %s" % node_name
    elif code == NodeStaleReason.NEW:
      msg = "Node's previous state has not been found, building the new node: %s" % node_name
    elif code == NodeStaleReason.IMPLICIT_DEP_CHANGED:
      dep = (" '%s'" % self.entity) if self.entity is not None else ""
      msg = "Node's implicit dependency%s has changed, rebuilding the node: %s" % (dep, node_name)
    elif code == NodeStaleReason.NO_TARGETS:
      msg = "Node's targets were not previously stored, rebuilding the node: %s" % (node_name,)
    elif code == NodeStaleReason.TARGET_CHANGED:
      msg = "Node's target '%s' has changed, rebuilding the node: %s" % (self.entity, node_name)
    elif code == NodeStaleReason.FORCE_REBUILD:
      msg = "Forced rebuild, rebuilding the node: %s" % (node_name,)
    else:
      msg = "Node's state is outdated, rebuilding the node: %s" % node_name
    return msg
@pickleable
class   NodeEntity (EntityBase):
  __slots__ = (
    'name',
    'signature',
    'builder',
    'source_entities',
    'dep_entities',
    'target_entities',
    'itarget_entities',
    'idep_entities',
    'idep_keys',
  )
  def   __new__( cls, name = NotImplemented, signature = NotImplemented, targets = None, itargets = None, idep_keys = None,
                 builder = None, source_entities = None, dep_entities = None ):
    self = super(NodeEntity,cls).__new__( cls, name, signature )
    if targets is not None:
      self.target_entities    = targets
      self.itarget_entities   = itargets
      self.idep_keys          = idep_keys
    else:
      self.builder          = builder
      self.source_entities  = source_entities
      self.dep_entities     = dep_entities
    return self
  def   get( self ):
    return self.name
  def   __getnewargs__( self ):
    return self.name, self.signature, self.target_entities, self.itarget_entities, self.idep_keys
  def   getTargets( self ):
    builder = self.builder
    targets = builder.getTargetEntities( self.source_entities )
    if not targets:
      return ()
    return builder.makeEntities( targets )
  def   getName( self ):
    hash_sum = newHash( self.builder.name )
    name_entities = self.target_entities
    if not name_entities:
      name_entities = self.source_entities
    names = sorted( entity.id for entity in name_entities )
    for name in names:
      hash_sum.update( name )
    return hash_sum.digest()
  def   getSignature( self ):
    builder_signature = self.builder.signature
    if builder_signature is None:
      return None
    hash_sum = newHash( builder_signature )
    for entity in self.dep_entities:
      ent_sign = entity.signature
      if not ent_sign:
        return None
      hash_sum.update( entity.id )
      hash_sum.update( ent_sign )
    for entity in self.source_entities:
      entity_signature = entity.signature
      if entity_signature is None:
        return None
      hash_sum.update( entity_signature )
    return hash_sum.digest()
  def   __getattr__(self, attr):
    if attr == 'target_entities':
      self.target_entities = targets = self.getTargets() 
      return targets
    return super(NodeEntity, self).__getattr__( attr )
  _ACTUAL_IDEPS_CACHE = {}
  def   _getIdeps( vfile, idep_keys, reason, ideps_cache_get = _ACTUAL_IDEPS_CACHE.__getitem__, ideps_cache_set = _ACTUAL_IDEPS_CACHE.__setitem__ ):
    entities = vfile.findEntitiesByKey( idep_keys )
    if entities is None:
      if reason is not None:
        reason.setImplicitDepChanged()
      return None
    for i, entity in enumerate( entities ):
      entity_id = entity.id
      try:
        entities[i] = ideps_cache_get( entity_id )
      except KeyError:
        actual_entity = entity.getActual()
        ideps_cache_set( entity_id, actual_entity )
        if entity is not actual_entity:
          vfile.updateEntity( actual_entity )
          if reason is not None:
            reason.setImplicitDepChanged( entity )
          return None
    return entities
  def   _saveIdeps( self, vfile, _actual_ideps_cache = _ACTUAL_IDEPS_CACHE ):
    entities = []
    for entity in self.idep_entities:
      entity_id = entity.id
      cached_entity = _actual_ideps_cache.setdefault( entity_id, entity )
      if cached_entity is entity:
        if entity.signature is None:
          raise ErrorUnactualEntity( entity )
      entities.append( cached_entity )
    keys = vfile.addEntities( entities )
    self.idep_entities  = entities
    self.idep_keys      = keys
  @staticmethod
  def   _checkTargets( entities, reason ):
    if entities is None:
      if reason is not None:
        reason.setNoTargets()
      return False
    for entity in entities:
      if not entity.isActual():
        if reason is not None:
          reason.setTargetChanged( entity )
        return False
    return True
  def   checkActual( self, vfile, explain = False, _getIdeps = _getIdeps ):
    if explain:
      reason = NodeStaleReason( self.builder, self.source_entities, self.target_entities )
    else:
      reason = None
    self.target_entities = []
    self.itarget_entities = []
    self.idep_entities = []
    other = vfile.findNodeEntity( self )
    if other is None:
      if reason is not None:
        reason.setNew()
      return False
    if not self.signature:
      if reason is not None:
        reason.setNoSignature()
      return False
    if self.signature != other.signature:
      if reason is not None:
        reason.setSignatureChanged()
      return False
    ideps = _getIdeps( vfile, other.idep_keys, reason )
    if ideps is None:
      return False
    target_entities = other.target_entities
    if not self._checkTargets( target_entities, reason ):
      return False
    if not self.builder.isActual( target_entities ):
      return False
    self.target_entities = target_entities
    self.itarget_entities = other.itarget_entities
    self.idep_entities = ideps
    return True
  def   save( self, vfile ):
    for entity in self.target_entities:
      if entity.signature is None:
        raise ErrorUnactualEntity( entity )
    self._saveIdeps( vfile )
    vfile.addNodeEntity( self )
  def   clear(self, vfile ):
    """
    Clear produced target entities
    """
    self.idep_entities = tuple()
    node_entity = vfile.findNodeEntity( self )
    if node_entity is None:
      self.itarget_entities = tuple()
    else:
      targets = node_entity.target_entities
      itargets = node_entity.itarget_entities
      if targets:
        self.target_entities  = targets
      else:
        self.target_entities  = tuple()
      if itargets:
        self.itarget_entities = itargets
      else:
        self.itarget_entities = tuple()
    try:
      self.builder.clear( self.target_entities, self.itarget_entities )
    except Exception:
      pass
  def   addTargets( self, entities, tags = None ):
    self.target_entities.extend( self.builder.makeEntities( toSequence(entities), tags ) )
  def   addTargetFiles( self, entities, tags = None ):
    self.target_entities.extend( self.builder.makeFileEntities( toSequence(entities), tags ) )
  add = addTargets
  addFiles = addTargetFiles
  def   addSideEffects( self, entities, tags = None ):
    self.itarget_entities.extend( self.builder.makeEntities( toSequence(entities), tags ) )
  def   addSideEffectFiles( self, entities, tags = None ):
    self.itarget_entities.extend( self.builder.makeFileEntities( toSequence(entities), tags ) )
  def   addImplicitDeps( self, entities, tags = None ):
    self.idep_entities.extend( self.builder.makeEntities( toSequence(entities), tags ) )
  def   addImplicitDepFiles( self, entities, tags = None ):
    self.idep_entities.extend( self.builder.makeFileEntities( toSequence(entities), tags ) )
class _NodeBatchTargets ( object ):
  def   __init__( self, node_entities_map ):
    self.node_entities_map = node_entities_map
  def   __getitem__( self, source ):
    try:
      return self.node_entities_map[ source ]
    except KeyError:
      raise ErrorNodeUnknownSource( source )
class NodeFilter (object):
  __slots__ = (
    'node',
    'node_attribute',
  )
  def   __init__( self, node, node_attribute = 'target_entities' ):
    self.node = node
    self.node_attribute = node_attribute
  def   getNode(self):
    node = self.node
    while isinstance( node, NodeFilter ):
      node = node.node
    return node
  def   __iter__(self):
    raise TypeError()
  def   __getitem__(self, item ):
    return NodeIndexFilter( self, item )
  def   get(self):
    entities = self.getEntities()
    if len(entities) == 1:
      return entities[0]
    return entities
  def   getEntities(self):
    node = self.node
    if isinstance( node, NodeFilter ):
      entities = node.getEntities()
    else:
      entities = getattr( node, self.node_attribute )
    return entities
class   NodeTagsFilter( NodeFilter ):
  __slots__ = (
      'tags',
    )
  def   __init__( self, node, tags, node_attribute = 'target_entities' ):
    super(NodeTagsFilter, self).__init__( node, node_attribute )
    self.tags = frozenset( toSequence( tags ) )
  def   getEntities(self):
    entities = super(NodeTagsFilter, self).getEntities()
    tags = self.tags
    return tuple( entity for entity in entities if entity.tags and (entity.tags & tags) )
class NodeIndexFilter( NodeFilter ):
  __slots__ = (
      'index',
    )
  def   __init__( self, node, index, node_attribute = 'target_entities' ):
    super(NodeIndexFilter, self).__init__( node, node_attribute )
    self.index = index
  def   getEntities(self):
    entities = super(NodeIndexFilter, self).getEntities()
    try:
      return toSequence( entities[ self.index ] )
    except IndexError:
      return tuple()
class NodeDirNameFilter( NodeFilter ):
  def   getEntities(self):
    entities = super(NodeDirNameFilter, self).getEntities()
    return tuple( SimpleEntity( os.path.dirname( entity.get() ) ) for entity in entities )
class NodeBaseNameFilter( NodeFilter ):
  def   getEntities(self):
    entities = super(NodeBaseNameFilter, self).getEntities()
    return tuple( SimpleEntity( os.path.basename( entity.get() ) ) for entity in entities )
class Node (object):
  __slots__ = (
    'builder',
    'options',
    'cwd',
    'initiated',
    'depends_called',
    'replace_called',
    'split_called',
    'is_actual',
    'node_entities',
    'node_entities_map',
    'sources',
    'source_entities',
    'dep_nodes',
    'dep_entities',
    'target_entities',
    'itarget_entities',
    'idep_entities',
  )
  def   __init__( self, builder, sources, cwd = None ):
    self.builder = builder
    self.options = getattr( builder, 'options', None )
    if cwd is None:
      self.cwd = os.path.abspath( os.getcwd() )
    else:
      self.cwd = cwd
    self.initiated      = False
    self.depends_called = False
    self.replace_called = False
    self.split_called   = False
    self.is_actual      = False
    self.sources = tuple(toSequence( sources ))
    self.dep_nodes = set()
    self.dep_entities = []
  def   shrink(self):
    self.cwd = None
    self.dep_nodes = None
    self.sources = None
    self.node_entities = None
    self.node_entities_map = None
    self.builder = None
    self.options = None
  def   depends( self, dependencies ):
    dep_nodes = self.dep_nodes
    dep_entities = self.dep_entities
    for entity in toSequence( dependencies ):
      if isinstance( entity, Node ):
        dep_nodes.add( entity )
      elif isinstance( entity, NodeFilter ):
        dep_nodes.add( entity.getNode() )
      elif isinstance( entity, EntityBase ):
        dep_entities.append( entity )
      else:
        raise ErrorNodeDependencyInvalid( entity )
  def   __getattr__(self, attr):
    if attr in [ 'target_entities', 'itarget_entities', 'idep_entities' ]:
      raise ErrorNoTargets( self )
    raise AttributeError( "Node has not attribute '%s'" % (attr,) )
  def   _setSourceEntities(self):
    entities = []
    makeEntity = self.builder.makeEntity
    for src in self.sources:
      if isinstance( src, Node ):
        entities += src.target_entities
      elif isinstance( src, NodeFilter ):
        entities += src.getEntities()
      elif isinstance( src, EntityBase ):
        entities.append( src )
      else:
        entity = makeEntity( src )
        entities.append( entity )
    self.sources = None
    self.source_entities = tuple(entities)
  def   _updateDepEntities(self):
    dep_nodes = self.dep_nodes
    if not dep_nodes:
      return
    dep_entities = self.dep_entities
    for node in dep_nodes:
      target_entities = node.target_entities
      if target_entities:
        dep_entities.extend( target_entities )
    dep_nodes.clear()
    dep_entities.sort( key = operator.attrgetter('id') )
  def   initiate(self):
    if self.initiated:
      if self.sources:            # reinitialize the replaced source entities
        self._setSourceEntities()
    else:
      with Chdir(self.cwd):
        self.builder = self.builder.initiate()
        self._setSourceEntities()
        self._updateDepEntities()
      self.initiated = True
  def   buildDepends( self ):
    if self.depends_called:
      return None
    self.depends_called = True
    nodes = self.builder.depends( self.cwd, self.source_entities )
    return nodes
  def   buildReplace( self ):
    if self.replace_called:
      return None
    self.replace_called = True
    sources = self.builder.replace( self.cwd, self.source_entities )
    if sources is None:
      return False
    self.sources = tuple( toSequence( sources ) )   # source_entities will be reinitialized later
    return self.getSourceNodes()
  def   _splitBatch( self, vfile, explain ):
    builder = self.builder
    dep_entities = self.dep_entities
    node_entities = []
    not_actual_nodes = {}
    not_actual_sources = []
    for src in self.source_entities:
      node_entity = NodeEntity( builder = builder, source_entities = (src,), dep_entities = dep_entities )
      if not node_entity.checkActual( vfile, explain ):
        not_actual_nodes[ src ] = node_entity
        not_actual_sources.append( src )
      node_entities.append( node_entity )
    self.node_entities  = node_entities
    self.is_actual      = True       # we don't need to check actual status anymore
    if not not_actual_nodes:
      return None
    groups = builder.splitBatch( not_actual_sources )
    if not groups:
      groups = not_actual_sources   # this should never happen, looks like a bug in the builder or Aqualid
    split_nodes = []
    for group in groups:
      group = tuple(toSequence( group ))
      node_entities = tuple( not_actual_nodes[src] for src in group )
      node = self._split( group, node_entities )
      node.node_entities_map = not_actual_nodes
      split_nodes.append( node )
    return split_nodes
  def   buildSplit( self, vfile, explain = False ):
    if self.split_called:
      return None
    self.split_called = True
    builder = self.builder
    dep_entities = self.dep_entities
    if builder.isBatch():
      return self._splitBatch( vfile, explain )
    sources = self.source_entities
    groups = self.builder.split( sources )
    if (not groups) or (len(groups) < 2):                 # No source groups, just build the sources
      node_entity = NodeEntity( builder = builder,
                                source_entities = sources,
                                dep_entities = dep_entities )
      self.is_actual = node_entity.checkActual( vfile, explain )
      self.node_entities = (node_entity,)
      return None
    node_entities = []
    split_nodes = []
    for group in groups:
      group = toSequence( group )
      node_entity = NodeEntity( builder = builder,
                                source_entities = group,
                                dep_entities = dep_entities )
      if not node_entity.checkActual( vfile, explain ):
        node = self._split( group, (node_entity,) )
        split_nodes.append( node )
      node_entities.append( node_entity )
    self.node_entities = node_entities
    self.is_actual = True       # we don't need to check actual status anymore
    return split_nodes
  def   _split( self, source_entities, node_entities ):
    other = object.__new__( self.__class__ )
    other.builder         = self.builder
    other.dep_nodes       = ()
    other.sources         = ()
    other.source_entities = source_entities
    other.node_entities   = node_entities
    other.initiated       = True
    other.depends_called  = True
    other.replace_called  = True
    other.split_called    = True
    other.is_actual       = False
    return other
  def   prebuild( self ):
    dep_nodes = self.buildDepends()
    if dep_nodes:
      return dep_nodes
    source_nodes = self.buildReplace()
    return source_nodes
  def   _populateTargets( self ):
    node_entities = self.node_entities
    if len(node_entities) == 1:
      node_entity = node_entities[0]
      self.target_entities  = node_entity.target_entities
      self.itarget_entities = node_entity.itarget_entities
      self.idep_entities    = node_entity.idep_entities
    else:
      targets   = []
      itargets  = []
      ideps  = []
      for node_entity in self.node_entities:
        targets   += node_entity.target_entities
        itargets  += node_entity.itarget_entities
        ideps     += node_entity.idep_entities
      self.target_entities = targets
      self.itarget_entities = itargets
      self.idep_entities = ideps
  def   checkActual( self, vfile, explain = False ):
    if self.is_actual is None:
      for node_entity in self.node_entities:
        if not node_entity.checkActual( vfile, explain ):
          return False
      self.is_actual = True
    elif not self.is_actual:
      return False
    self._populateTargets()
    return True
  def   recheckActual( self ):
    self.is_actual = None
  def   build( self ):
    builder = self.builder
    if builder.isBatch():
      targets = _NodeBatchTargets( self.node_entities_map )
      output = builder.buildBatch( self.source_entities, targets )
    else:
      targets = self.node_entities
      output = builder.build( self.source_entities, targets[0] )
    self._populateTargets()
    return output
  def   save( self, vfile ):
    for node_entity in self.node_entities:
      node_entity.save( vfile )
  def   saveFailed( self, vfile ):
    node_entities = self.node_entities
    if len(node_entities) < 2:            # do not save if only one node regardless targets
      return
    for node_entity in node_entities:
      if node_entity.target_entities:   # only nodes with targets should be saved
        node_entity.save( vfile )
  def   _clearSplit( self ):
    builder = self.builder
    source_entities = self.source_entities
    if builder.isBatch():
      groups = source_entities
    else:
      groups = self.builder.split( source_entities )
      if not groups:
        groups = source_entities
    node_entities = []
    for group in groups:
      group = toSequence( group )
      node_entity = NodeEntity( builder = builder,
                                source_entities = group,
                                dep_entities = () )
      node_entities.append( node_entity )
    self.node_entities = node_entities
  def   clear( self, vfile ):
    self._clearSplit()
    node_entities = []
    for node_entity in self.node_entities:
      node_entity.clear( vfile )
      node_entities.append( node_entity )
    self._populateTargets()
    return node_entities
  def   getWeight( self ):
    return self.builder.getWeight( self.source_entities )
  def   getNames(self):
    return (entity.name for entity in self.node_entities)
  def   getNamesAndSignatures(self):
    return ((entity.name, entity.signature) for entity in self.node_entities)
  def   getDepNodes(self):
    return self.dep_nodes
  def   getSources(self):
    return tuple( src.get() for src in self.getSourceEntities() )
  def   getSourceEntities(self):
    return self.source_entities
  def   getSourceNodes(self):
    nodes = []
    for src in self.sources:
      if isinstance(src, Node):
        nodes.append( src )
      elif isinstance(src, NodeFilter):
        nodes.append( src.getNode() )
    return nodes
  def   isBuilt(self):
    return self.builder is None
  def   at(self, tags ):
    return NodeTagsFilter( self, tags )
  def   __iter__(self):
    raise TypeError()
  def   __getitem__(self, item ):
    return NodeIndexFilter( self, item )
  def   __filter( self, node_attribute, tags ):
    if tags is None:
      return NodeFilter( self, node_attribute )
    return NodeTagsFilter( self, tags, node_attribute )
  def   filterSources( self, tags = None ):
    return self.__filter( 'source_entities', tags )
  def   filterSideEffects( self, tags = None ):
    return self.__filter( 'itarget_entities', tags )
  def   filterImplicitDependencies( self, tags = None ):
    return self.__filter( 'idep_entities', tags )
  def   filterDependencies( self, tags = None ):
    return self.__filter( 'dep_entities', tags )
  def   get(self):
    targets = self.getTargetEntities()
    if len(targets) == 1:
      return targets[0].get()
    return tuple( target.get() for target in targets )
  def   getTargetEntities(self):
    return self.target_entities
  def   getSideEffectEntities(self):
    return self.itarget_entities
  def   getBuildStr( self, brief = True ):
    try:
      targets = getattr( self, 'target_entities', None )
      return self.builder.getTrace( self.source_entities, targets, brief )
    except Exception as ex:
      if 'BuilderInitiator' not in str(ex):
        raise
    return str(self)  # TODO: return raw data
  def   printSources(self):
    result = []
    sources = self.sources
    if not sources:
      sources = self.source_entities
    for src in sources:
      if isinstance(src, EntityBase):
        result.append( src.get() )
      elif isinstance( src, Node ):
        targets = getattr(src, 'target_entities', None)
        if targets is not None:
          result += ( target.get() for target in targets )
        else:
          result.append( src ) 
      elif isinstance( src, NodeFilter ):
        try:
          targets = src.getEntities()
        except AttributeError:
          continue
        if targets is not None:
          result += ( target.get() for target in targets )
        else:
          result.append( src ) 
      else:
        result.append( src )
    sources_str = ', '.join( map( str, result ) )
    logInfo("node '%s' sources: %s" % (self, sources_str))
  def   printTargets(self):
    targets = [ t.get() for t in getattr(self, 'target_entities', []) ]
    logInfo("node '%s' targets: %s" % (self, targets))
@eventDebug
def   eventExecCmd( settings, cmd, cwd, env ):
  if settings.trace_exec:
    cmd = ' '.join( cmd )
    logDebug("CWD: '%s', CMD: '%s'" % (cwd, cmd,) )
def   _getTraceArg( entity, brief ):
  value = None
  if isinstance( entity, FileEntityBase ):
    value = entity.get()
    if brief:
      value = os.path.basename( value )
  else:
    if isinstance( entity, EntityBase ):
      value = entity.get()
    elif isinstance( entity, FilePath ):
      if brief:
        value = os.path.basename( entity )
    elif isString( entity ):
      value = entity.strip()
      npos = value.find('\n')
      if npos != -1:
        value = value[:npos]
      max_len = 64 if brief else 256
      src_len = len(value)
      if src_len > max_len:
        value = "%s...%s" % (value[:max_len//2], value[src_len - (max_len//2):])
  return value
def   _joinArgs( entities, brief ):
  args = []
  for arg in toSequence(entities):
    arg = _getTraceArg(arg, brief )
    if arg and isString( arg ):
      args.append( arg )
  if not brief or (len(args) < 3):
    return ' '.join( args )
  wish_size = 128
  args_str = [ args.pop(0) ]
  last = args.pop()
  size = len(args_str[0]) + len(last)
  for arg in args:
    size += len(arg)
    if size > wish_size:
      args_str.append('...')
      break
    args_str.append( arg )
  args_str.append( last )
  return ' '.join( args_str )
def   _getTraceStr( name, sources, targets, brief ):
    name    = _joinArgs( name,    brief )
    sources = _joinArgs( sources, brief )
    targets = _joinArgs( targets, brief )
    build_str  = name
    if sources:
      build_str += " << " + sources
    if targets:
      build_str += " >> " + targets
    return build_str
def   _makeBuildPath( path_dir, _path_cache = set() ):
  if path_dir not in _path_cache:
    if not os.path.isdir( path_dir ):
      try:
        os.makedirs( path_dir )
      except OSError as e:
        if e.errno != errno.EEXIST:
          raise
    _path_cache.add( path_dir )
def   _makeBuildPaths( dirnames ):
  for dirname in dirnames:
    _makeBuildPath( dirname )
def   _splitFileName( file_path, ext = None, prefix = None, suffix = None, replace_ext = False ):
  if isinstance( file_path, EntityBase ):
    file_path = file_path.get()
  dirname, filename = os.path.split( file_path )
  if ext:
    if filename.endswith( ext ):
      filename = filename[:-len(ext)]
    elif replace_ext:
      ext_pos = filename.rfind( os.path.extsep )
      if ext_pos > 0:
        filename = filename[:ext_pos]
  else:
    ext_pos = filename.rfind( os.path.extsep )
    if ext_pos > 0:
      ext = filename[ext_pos:]
      filename = filename[:ext_pos]
  if prefix:
    filename = prefix + filename
  if suffix:
    filename += suffix
  if ext:
    filename += ext
  return dirname, filename
def   _splitFileNames( file_paths, ext = None, prefix = None, suffix = None, replace_ext = False ):
  dirnames = []
  filenames = []
  for file_path in file_paths:
    dirname, filename = _splitFileName( file_path, ext = ext, prefix = prefix, suffix = suffix, replace_ext = replace_ext )
    dirnames.append( dirname )
    filenames.append( filename )
  return dirnames, filenames
def   _fileSinature2Type( file_signature_type ):
  return FileTimestampEntity if file_signature_type == 'timestamp' else FileChecksumEntity
class BuilderInitiator( object ):
  __slots__ = ( 'is_initiated', 'builder', 'options', 'args', 'kw' )
  def   __init__( self, builder, options, args, kw ):
    self.is_initiated   = False
    self.builder        = builder
    self.options        = options
    self.args           = self.__storeArgs( args )
    self.kw             = self.__storeKw( kw )
  def   __storeArgs( self, args ):
    return tuple( map( self.options._storeValue, args ) )
  def   __loadArgs( self ):
    return tuple( map( self.options._loadValue, self.args ) )
  def   __storeKw( self, kw ):
    storeValue = self.options._storeValue
    return dict( (name, storeValue( value )) for name, value in kw.items() )
  def   __loadKw( self ):
    loadValue = self.options._loadValue
    return dict( (name, loadValue( value )) for name, value in self.kw.items() )
  def   initiate( self ):
    if self.is_initiated:
      return self.builder
    builder = self.builder
    kw = self.__loadKw()
    args = self.__loadArgs()
    options = self.options
    builder._initAttrs( options )
    builder.__init__( options, *args, **kw )
    if not hasattr( builder, 'name' ):
      builder.setName()
    if not hasattr( builder, 'signature' ):
      builder.setSignature()
    self.is_initiated = True
    return builder
  def   canBuildBatch(self):
    return self.builder.canBuildBatch()
  def   canBuild(self):
    return self.builder.canBuild()
  def   isBatch(self):
    return self.builder.isBatch()
class Builder (object):
  """
  Base class for all builders
  'name' - uniquely identifies builder
  'signature' - uniquely identifies builder's parameters
  """
  NAME_ATTRS = None
  SIGNATURE_ATTRS = None
  def   __new__(cls, options, *args, **kw):
    self = super(Builder, cls).__new__(cls)
    return BuilderInitiator( self, options, args, kw )
  def   _initAttrs( self, options ):
    self.build_dir = options.build_dir.get()
    self.build_path = options.build_path.get()
    self.relative_build_paths = options.relative_build_paths.get()
    self.file_entity_type = _fileSinature2Type( options.file_signature.get() )
    self.env = options.env.get()
    is_batch = (options.batch_build.get() or not self.canBuild()) and self.canBuildBatch()
    self.__is_batch = is_batch
    if is_batch:
      self.batch_groups = options.batch_groups.get()
      self.batch_size = options.batch_size.get()
  def   canBuildBatch(self):
    return self.__class__.buildBatch != Builder.buildBatch
  def   canBuild(self):
    return self.__class__.build != Builder.build
  def   isBatch(self):
    return self.__is_batch
  def   initiate( self ):
    return self
  def setName( self ):
    cls = self.__class__
    name = [ cls.__module__, cls.__name__, simplifyValue( self.build_path ), bool(self.relative_build_paths) ]
    if self.NAME_ATTRS:
      for attr_name in self.NAME_ATTRS:
        value = getattr( self, attr_name )
        value = simplifyValue( value )
        name.append( value )
    self.name = simpleObjectSignature( name )
  def   setSignature( self ):
    sign = []
    if self.SIGNATURE_ATTRS:
      for attr_name in self.SIGNATURE_ATTRS:
        value = getattr( self, attr_name )
        value = simplifyValue( value )
        sign.append( value )
    self.signature = simpleObjectSignature( sign )
  def   isActual( self, target_entities ):
    """
    Checks that target entities are up to date. It called only if all other checks were successful.
    It can't be used to check remote resources.
    :param target_entities: Previous target entities
    :return: True if is up to date otherwise False
    """
    return True
  def   clear( self, target_entities, side_effect_entities ):
    for entity in target_entities:
      entity.remove()
    for entity in side_effect_entities:
      entity.remove()
  def   depends( self, cwd, source_entities ):
    """
    Could be used to dynamically generate dependency nodes 
    Returns list of dependency nodes or None
    """
    return None
  def   replace( self, cwd, source_entities ):
    """
    Could be used to dynamically replace sources
    Returns list of nodes/entities or None (if sources are not changed)
    """
    return None
  def   split( self, source_entities ):
    """
    Could be used to dynamically split building sources to several nodes
    Returns list of groups of source entities or None
    """
    return None
  def   splitSingle( self, source_entities ):
    """
    Implementation of split for splitting one-by-one 
    """
    return source_entities
  def   splitBatch( self, source_entities ):
    """
    Implementation of split for splitting to batch groups of batch size  
    """
    return groupItems( source_entities, self.batch_groups, self.batch_size )
  def   splitBatchByBuildDir( self, source_entities ):
    """
    Implementation of split for grouping sources by output  
    """
    num_groups = self.batch_groups
    group_size = self.batch_size
    if self.relative_build_paths:
      groups = groupPathsByDir( source_entities, num_groups, group_size, pathGetter = operator.methodcaller('get') )
    else:
      groups = groupItems( source_entities, num_groups, group_size )
    return groups
  def   getWeight( self, source_entities ):
    return len(source_entities)
  def   build( self, source_entities, targets ):
    """
    Builds a node
    Returns a build output string or None
    """
    raise NotImplementedError( "Abstract method. It should be implemented in a child class." )
  def   buildBatch( self, source_entities, targets ):
    """
    Builds a node
    Returns a build output string or None
    """
    raise NotImplementedError( "Abstract method. It should be implemented in a child class." )
  def   getTargetEntities( self, source_entities ):
    """
    If it's possible returns target entities of the node, otherwise None 
    """
    return None
  def   getTraceName(self, source_entities, brief ):
    return self.__class__.__name__
  def   getTraceSources( self, source_entities, brief ):
    return source_entities
  def   getTraceTargets( self, target_entities, brief ):
    return target_entities
  def   getTrace( self, source_entities = None, target_entities = None, brief = False ):
    try:
      name = self.getTraceName( source_entities, brief )
    except Exception:
      name = ''
    try:
      sources = self.getTraceSources( source_entities, brief )
    except Exception:
      sources = None
    try:
      if (target_entities is None) and source_entities:
        target_entities = self.getTargetEntities( source_entities )
      targets = self.getTraceTargets( target_entities, brief )
    except Exception:
      targets = None
    return _getTraceStr( name, sources, targets, brief )
  def   getBuildDir( self ):
    _makeBuildPath( self.build_dir )
    return self.build_dir
  def   getBuildPath( self ):
    _makeBuildPath( self.build_path )
    return self.build_path
  def getTargetFilePath(self, target, ext = None, prefix = None ):
    target_dir, name = _splitFileName( target, prefix = prefix, ext = ext )
    if target_dir.startswith( (os.path.curdir, os.path.pardir )):
      target_dir = os.path.abspath( target_dir )
    elif not os.path.isabs( target_dir ):
      target_dir = os.path.abspath( os.path.join( self.build_path, target_dir ) ) 
    _makeBuildPath( target_dir )
    target = os.path.join( target_dir, name )
    return target
  def getTargetDirPath(self, target_dir ):
    target_dir, name = os.path.split( target_dir )
    if not name:
      target_dir, name = os.path.split( target_dir )
    elif not target_dir and name in (os.path.curdir, os.path.pardir):
      target_dir = name
      name = ''
    if target_dir.startswith( (os.path.curdir, os.path.pardir) ):
      target_dir = os.path.abspath( target_dir )
    elif not os.path.isabs( target_dir ):
      target_dir = os.path.abspath( os.path.join( self.build_path, target_dir ) ) 
    target_dir = os.path.join( target_dir, name )
    _makeBuildPath( target_dir )
    return target_dir
  def   getTargetFromSourceFilePath( self, file_path, ext = None, prefix = None, suffix = None, replace_ext = True ):
    build_path = self.build_path
    dirname, filename = _splitFileName( file_path, ext = ext, prefix = prefix, suffix = suffix, replace_ext = replace_ext )
    if self.relative_build_paths:
      build_path = relativeJoin( build_path, dirname )
    _makeBuildPath( build_path )
    build_path = os.path.join( build_path, filename )
    return build_path
  def   getTargetsFromSourceFilePaths( self, file_paths, ext = None, prefix = None, suffix = None, replace_ext = True ):
    build_path = self.build_path
    dirnames, filenames = _splitFileNames( file_paths, ext = ext, prefix = prefix, suffix = suffix, replace_ext = replace_ext )
    if self.relative_build_paths:
      dirnames = relativeJoinList( build_path, dirnames )
      _makeBuildPaths( dirnames )
      build_paths = [ os.path.join( dirname, filename ) for dirname, filename in zip( dirnames, filenames ) ]
    else:
      _makeBuildPath( build_path )
      build_paths = [ os.path.join( build_path, filename ) for filename in filenames ]
    return build_paths
  def   getFileEntityType( self ):
    return self.file_entity_type 
  def   makeSimpleEntity(self, entity, tags = None ):
    if isinstance( entity, EntityBase):
      return entity
    if isinstance( entity, FilePath ):
      return self.file_entity_type( name = entity, tags = tags )
    return SimpleEntity( entity )
  makeEntity = makeSimpleEntity
  def   makeFileEntity( self, entity, tags = None ):
    if isinstance( entity, EntityBase ):
      return entity
    return self.file_entity_type( name = entity, tags = tags )
  def   makeFileEntities( self, entities, tags = None ):
    make_entity = self.makeFileEntity
    return tuple( make_entity( entity, tags = tags ) for entity in toSequence( entities ) )
  def   makeEntities( self, entities, tags = None ):
    make_entity = self.makeEntity
    return tuple( make_entity( entity, tags = tags ) for entity in toSequence(entities) )
  def   execCmd(self, cmd, cwd = None, env = None, file_flag = None, stdin = None ):
    result = self.execCmdResult( cmd, cwd = cwd, env = env, file_flag = file_flag, stdin = stdin )
    if result.failed():
      raise result
    return result.output
  def   execCmdResult(self, cmd, cwd = None, env = None, file_flag = None, stdin = None ):
    if env is None:
      env = self.env
    if cwd is None:
      cwd = self.getBuildPath()
    result = executeCommand( cmd, cwd = cwd, env = env, file_flag = file_flag, stdin = stdin )
    eventExecCmd( cmd, cwd, env )
    return result
class FileBuilder (Builder):
  makeEntity = Builder.makeFileEntity
@eventWarning
def   eventBuildTargetTwice( settings, entity, node1 ):
  logWarning("Target '%s' is built twice. The last time built by: '%s' " %
             ( entity.name, node1.getBuildStr( settings.brief )) )
@eventError
def   eventFailedNode( settings, node, error ):
  msg = node.getBuildStr( settings.brief )
  msg += '\n\n%s\n' % (error,)
  logError( msg )
@eventStatus
def   eventNodeBuilding( settings, node ):
  pass
@eventStatus
def   eventNodeBuildingFinished( settings, node, builder_output, progress ):
  msg = node.getBuildStr( settings.brief )
  if settings.with_output and builder_output:
    msg += '\n'
    if builder_output:
      msg += builder_output
      msg += '\n'
  msg = "(%s) %s" % (progress, msg)
  logInfo( msg )
@eventStatus
def   eventNodeBuildingFailed( settings, node, error ):
  pass
@eventStatus
def   eventNodeRemoved( settings, node, progress ):
  msg = node.getBuildStr( settings.brief )
  if msg:
    logInfo( "(%s) Removed: %s" % (progress, msg) )
class   ErrorNodeDependencyCyclic( Exception ):
  def   __init__( self, node, deps ):
    msg = "Node '%s' (%s) has a cyclic dependency: %s" % (node, node.getBuildStr(True), deps )
    super(ErrorNodeDependencyCyclic, self).__init__( msg )
class   ErrorNodeUnknown(Exception):
  def   __init__( self, node ):
    msg = "Unknown node '%s'" % (node, )
    super(ErrorNodeUnknown, self).__init__( msg )
class   ErrorNodeSignatureDifferent(Exception):
  def   __init__( self, node ):
    msg = "Two similar nodes have different signatures (sources, builder parameters or dependencies): %s" % (node.getBuildStr( brief = False ), )
    super(ErrorNodeSignatureDifferent, self).__init__( msg )
class   ErrorNodeDependencyUnknown(Exception):
  def   __init__( self, node, dep_node ):
    msg = "Unable to add dependency to node '%s' from node '%s'" % (node, dep_node)
    super(ErrorNodeDependencyUnknown, self).__init__( msg )
class   InternalErrorRemoveNonTailNode( Exception ):
  def   __init__( self, node ):
    msg = "Removing non-tail node: %s" % (node,)
    super(InternalErrorRemoveNonTailNode, self).__init__( msg )
class   InternalErrorRemoveUnknownTailNode(Exception):
  def   __init__( self, node ):
    msg = "Remove unknown tail node: : %s" % (node,)
    super(InternalErrorRemoveUnknownTailNode, self).__init__( msg )
class _NodesTree (object):
  __slots__ =   (
    'node2deps',
    'dep2nodes',
    'tail_nodes',
  )
  def   __init__( self ):
    self.node2deps = {}
    self.dep2nodes = {}
    self.tail_nodes = set()
  def   __len__(self):
    return len(self.node2deps)
  def   getNodes(self):
    return frozenset( self.node2deps )
  def   __hasCycle( self, node, new_deps ):
    if node in new_deps:
      return True
    deps = set(new_deps)
    node2deps = self.node2deps
    while deps:
      dep = deps.pop()
      dep_deps = node2deps[dep]
      if node in dep_deps:
        return True
      deps |= dep_deps
    return False
  def   _depends( self, node, deps ):
    node2deps = self.node2deps
    dep2nodes = self.dep2nodes
    try:
      current_node_deps = node2deps[ node ]
      deps = set( dep for dep in deps if not dep.isBuilt() )
      new_deps = deps - current_node_deps
      if not new_deps:
        return
      if self.__hasCycle( node, new_deps ):
        raise ErrorNodeDependencyCyclic( node, new_deps )
      self.tail_nodes.discard( node )
      current_node_deps.update( new_deps )
      for dep in new_deps:
        dep2nodes[ dep ].add( node )
    except KeyError as dep_node:
      raise ErrorNodeDependencyUnknown( node, dep_node.args[0] )
  def   add( self, nodes ):
      for node in nodes:
        if node not in self.node2deps:
          self.node2deps[ node ] = set()
          self.dep2nodes[ node ] = set()
          self.tail_nodes.add( node )
          node_srcnodes = node.getSourceNodes()
          node_depnodes = node.getDepNodes()
          self.add( node_srcnodes )       # recursively add sources and depends
          self.add( node_depnodes )       # TODO: It would be better to rewrite this code to avoid the recursion
          self._depends( node, node_srcnodes )
          self._depends( node, node_depnodes )
  def   depends( self, node, deps ):
    self.add( deps )
    self._depends( node, deps )
  def   removeTail( self, node ):
    node2deps = self.node2deps
    try:
      deps = node2deps.pop(node)
      if deps:
        raise InternalErrorRemoveNonTailNode( node )
    except KeyError as node:
      raise InternalErrorRemoveUnknownTailNode( node.args[0] )
    tail_nodes = self.tail_nodes
    for dep in self.dep2nodes.pop( node ):
      d = node2deps[ dep ]
      d.remove( node )
      if not d:
        tail_nodes.add( dep )
  def   filterUnknownDeps(self, deps ):
    return [ dep for dep in deps if dep in self.node2deps ]
  def   popTails( self ):
    tails = self.tail_nodes
    self.tail_nodes = set()
    return tails
  def   __getAllNodes(self, nodes ):
    nodes = set(nodes)
    all_nodes = set( nodes )
    node2deps = self.node2deps
    while nodes:
      node = nodes.pop()
      try:
        deps = node2deps[ node ] - all_nodes
      except KeyError as node:
        raise ErrorNodeUnknown( node.args[0] )
      all_nodes.update( deps )
      nodes.update( deps )
    return all_nodes
  def   shrinkTo(self, nodes ):
    node2deps = self.node2deps
    dep2nodes = self.dep2nodes
    ignore_nodes = set(node2deps) - self.__getAllNodes( nodes )
    self.tail_nodes -= ignore_nodes
    for node in ignore_nodes:
      del node2deps[ node ]
      del dep2nodes[ node ]
    for dep_nodes in dep2nodes.values():
      dep_nodes.difference_update( ignore_nodes ) 
  def   selfTest( self ):
    if set(self.node2deps) != set(self.dep2nodes):
      raise AssertionError("Not all deps are added")
    all_dep_nodes = set()
    for node in self.dep2nodes:
      if node not in self.node2deps:
        raise AssertionError("Missed node: %s" % (node,) )
      node_deps = self.node2deps[node]
      if node_deps:
        if node in self.tail_nodes:
          raise AssertionError("Invalid tail node: %s"  % (node,) )
      all_dep_nodes |= node_deps
      for dep in node_deps:
        if node not in self.dep2nodes[dep]:
          raise AssertionError("node not in self.dep2nodes[dep]: dep: %s, node: %s"  % (dep, node) )
    if all_dep_nodes - set(self.dep2nodes):
      raise AssertionError("Not all deps are added")
class  _VFiles( object ):
  __slots__ =   (
    'names',
    'handles',
    'use_sqlite',
    'force_lock',
  )
  def   __init__( self, use_sqlite = False, force_lock = False ):
    self.handles = {}
    self.names = {}
    self.use_sqlite = use_sqlite
    self.force_lock = force_lock
  def   __iter__(self):
    raise TypeError()
  def   __getitem__( self, builder ):
    builder_name = builder.name
    try:
      vfilename = self.names[ builder_name ]
    except KeyError:
      vfilename = os.path.join( builder.getBuildDir(), '.aql.db' )
      self.names[ builder_name ] = vfilename
    try:
      return self.handles[ vfilename ]
    except KeyError:
      vfile = EntitiesFile( vfilename, use_sqlite = self.use_sqlite, force = self.force_lock )
      self.handles[ vfilename ] = vfile
      return vfile
  def   close(self):
    for vfile in self.handles.values():
      vfile.close()
    self.handles.clear()
    self.names.clear()
  def   __enter__(self):
    return self
  def   __exit__(self, exc_type, exc_value, backtrace):
    self.close()
def   _buildNode( node ):
  eventNodeBuilding( node )
  out = node.build()
  if out:
    try:
      out = out.strip()
    except Exception:
      pass
  return out
def   _getModuleNodes( node, module_cache, node_cache ):
  try:
    return module_cache[ node ]
  except KeyError:
    pass
  result = set( (node,) )
  try:
    src_nodes = node_cache[ node ]
  except KeyError:
    node_cache[ node ] = src_nodes = frozenset(node.getSourceNodes())
  for src in src_nodes:
    result.update( _getModuleNodes( src, module_cache, node_cache ) )
  module_cache[ node ] = result
  return result
def   _getLeafNodes( nodes, exclude_nodes, node_cache ):
  leafs = set()
  for node in nodes:
    if node_cache[node].issubset( exclude_nodes ):
      leafs.add( node )
  return leafs
class _NodeLocker( object ):
  __slots__ = (
    'node2deps',
    'dep2nodes',
    'locked_nodes',
    'unlocked_nodes',
  )
  def   __init__( self ):
    self.node2deps = {}
    self.dep2nodes = {}
    self.locked_nodes = {}
    self.unlocked_nodes = []
  def   syncModules( self, nodes, module_cache = None, node_cache = None ):
    if module_cache is None:
      module_cache = {}
    if node_cache is None:
      node_cache = {}
    for node1, node2 in itertools.product( nodes, nodes ):
      if node1 is not node2:
        self.__addModules( node1, node2, module_cache, node_cache )
  def   __addModules( self, node1, node2, module_cache, node_cache ):
    node1_sources = _getModuleNodes( node1, module_cache, node_cache )
    node2_sources = _getModuleNodes( node2, module_cache, node_cache )
    common = node1_sources & node2_sources
    node1_sources -= common
    node2_sources -= common
    leafs1 = _getLeafNodes( node1_sources, common, node_cache )
    leafs2 = _getLeafNodes( node2_sources, common, node_cache )
    for leaf in leafs1:
      self.__add( leaf, node2_sources )
    for leaf in leafs2:
      self.__add( leaf, node1_sources )
  def   sync( self, nodes ):
    for node in nodes:
      node_deps = self.__add( node, nodes )
      node_deps.remove( node )
  def __add( self, node, deps ):
    try:
      node_set = self.node2deps[ node ]
    except KeyError:
      node_set = set()
      self.node2deps[ node ] = node_set
    node_set.update( deps )
    for dep in deps:
      if dep is not node:
        try:
          dep_set = self.dep2nodes[ dep ]
        except KeyError:
          dep_set = set()
          self.dep2nodes[ dep ] = dep_set
        dep_set.add( node )
    return node_set
  def   lock( self, node ):
    deps = self.node2deps.get( node, None )
    if not deps:
      return True
    locked_nodes = self.locked_nodes
    for dep in deps:
      if dep in locked_nodes:
        locked_nodes[dep].add( node )
        return False
    self.locked_nodes[node] = set()
    return True
  def   unlock( self, node ):
    deps = self.node2deps.pop( node, () )
    nodes = self.dep2nodes.pop( node, () )
    if not deps and not nodes:
      return
    for dep in deps:
      self.dep2nodes[ dep ].remove( node )
    for dep in nodes:
      self.node2deps[ dep ].remove( node )
    unlocked_nodes = self.locked_nodes.pop( node, None)
    if not unlocked_nodes:
      return
    self.unlocked_nodes.extend( unlocked_nodes )
  def   popUnlocked(self):
    unlocked_nodes = self.unlocked_nodes
    self.unlocked_nodes = []
    return unlocked_nodes
  def   selfTest( self ):
    for node, deps in self.node2deps.items():
      if node in deps:
        raise AssertionError("Node depends from itself: %s"  % (node,) )
      for dep in deps:
        if node not in self.dep2nodes[ dep ]:
          raise AssertionError("Dependency '%s' doesn't have node '%s'"  % (dep, node,) )
    for node, deps in self.locked_nodes.items():
      for dep in deps:
        if node not in self.node2deps[dep]:
          raise AssertionError("Locked node %s does't actually depend from node %s"  % (dep, node) )
        if dep in self.unlocked_nodes:
          raise AssertionError("Locked node %s is actually locked"  % (dep,) )
    for node in self.unlocked_nodes:
      if node not in self.node2deps:
        raise AssertionError("Unknown unlocked node %s"  % (node,) )
class _NodesBuilder (object):
  __slots__ =   (
    'vfiles',
    'build_manager',
    'task_manager',
    'building_nodes',
  )
  def   __init__( self, build_manager, jobs = 0, keep_going = False, with_backtrace = True, use_sqlite = False, force_lock = False ):
    self.vfiles         = _VFiles( use_sqlite = use_sqlite, force_lock = force_lock )
    self.building_nodes = {}
    self.build_manager  = build_manager
    self.task_manager   = TaskManager( num_threads = jobs, stop_on_fail = not keep_going, with_backtrace = with_backtrace )
  def   __enter__(self):
    return self
  def   __exit__(self, exc_type, exc_value, backtrace):
    self.close()
  def   _addBuildingNode( self, node ):
    conflicting_nodes = []
    building_nodes = self.building_nodes
    node_names = {}
    for name, signature in node.getNamesAndSignatures():
      other = building_nodes.get( name, None )
      if other is None:
        node_names[ name ] = (node, signature)
        continue
      other_node, other_signature = other
      if other_signature != signature:
        raise ErrorNodeSignatureDifferent( node )
      conflicting_nodes.append( other_node )
    if conflicting_nodes:
      node.recheckActual()
      self.build_manager.depends( node, conflicting_nodes )
      return False
    building_nodes.update( node_names )
    return True
  def   _removeBuildingNode( self, node ):
    building_nodes = self.building_nodes
    for name in node.getNames():
      del building_nodes[ name ]
  def   isBuilding(self):
    return bool(self.building_nodes)
  def   build( self, nodes ):
    build_manager = self.build_manager
    explain = build_manager.explain
    vfiles = self.vfiles
    addTask = self.task_manager.addTask
    tasks_check_period = 10
    added_tasks = 0
    changed = False
    for node in nodes:
      if not build_manager.lockNode( node ):
        continue
      node.initiate()
      vfile = vfiles[ node.builder ]
      prebuit_nodes = node.prebuild()
      if prebuit_nodes:
        build_manager.depends( node, prebuit_nodes )
        changed = True
        continue
      split_nodes =  node.buildSplit( vfile, explain )
      if split_nodes:
        build_manager.depends( node, split_nodes )
        changed = True
        continue
      actual = node.checkActual( vfile, explain )
      force_rebuild = build_manager.checkForceRebuild( node )
      if actual and not force_rebuild:
        build_manager.actualNode( node )
        changed = True
        continue
      if not self._addBuildingNode( node ):
        continue
      addTask( -node.getWeight(), node, _buildNode, node )
      added_tasks += 1
      if added_tasks == tasks_check_period:
        changed = self._getFinishedNodes( block = False ) or changed
        added_tasks = 0
    return self._getFinishedNodes( block = not changed )
  def   _getFinishedNodes( self, block = True ):
    finished_tasks = self.task_manager.finishedTasks( block = block )
    vfiles = self.vfiles
    build_manager = self.build_manager
    for task in finished_tasks:
      node = task.task_id
      error = task.error
      self._removeBuildingNode( node )
      vfile = vfiles[ node.builder ]
      if error is None:
        node.save( vfile )
        build_manager.completedNode( node, task.result )
      else:
        node.saveFailed( vfile )
        build_manager.failedNode( node, error )
    return finished_tasks or not block
  def   clear( self, nodes ):
    vfiles = self.vfiles
    build_manager = self.build_manager
    remove_entities = {}
    for node in nodes:
      node.initiate()
      prebuit_nodes = node.prebuild()
      if prebuit_nodes:
        build_manager.depends( node, prebuit_nodes )
        continue
      vfile = vfiles[ node.builder ]
      node_entities = node.clear( vfile )
      remove_entities.setdefault( vfile, [] ).extend( node_entities )
      build_manager.removedNode( node )
    for vfile, entities in remove_entities.items():
      vfile.removeNodeEntities( entities )
  def   close( self ):
    try:
      self.task_manager.stop()
      self._getFinishedNodes( block = False )
    finally:
      self.vfiles.close()
class BuildManager (object):
  __slots__ = (
    '_nodes',
    '_built_targets',
    '_failed_nodes',
    '_built_node_names',
    '_node_locker',
    '_module_cache',
    '_node_cache',
    'completed',
    'actual',
    'explain',
  )
  def   __init__(self):
    self._nodes = _NodesTree()
    self._node_locker = None
    self.__reset()
  def   __reset(self, build_always = False, explain = False ):
    self._built_targets = {}
    self._failed_nodes = {}
    self._module_cache = {}
    self._node_cache = {}
    self._built_node_names = set() if build_always else None
    self.completed = 0
    self.actual = 0
    self.explain = explain
  def   add( self, nodes ):
    self._nodes.add( nodes )
  def   depends( self, node, deps ):
    self._nodes.depends( node, deps )
  def   moduleDepends( self, node, deps ):
    module_cache = self._module_cache
    node_cache = self._node_cache
    module_nodes = _getModuleNodes( node, module_cache, node_cache )
    for dep in deps:
      dep_nodes = _getModuleNodes( dep, module_cache, node_cache )
      common = module_nodes & dep_nodes
      only_module_nodes = module_nodes - common 
      leafs = _getLeafNodes( only_module_nodes, common, node_cache )
      for leaf in leafs:
        self._nodes.depends( leaf, (dep,) )
  def   sync( self, nodes, deep = False ):
    node_locker = self._node_locker
    if node_locker is None:
      self._node_locker = node_locker = _NodeLocker()
    if deep:
      node_locker.syncModules( nodes, self._module_cache, self._node_cache )
    else:
      node_locker.sync( nodes )
  def   lockNode( self, node ):
    node_locker = self._node_locker
    if node_locker is None:
      return True
    return node_locker.lock( node )
  def   unlockNode( self, node ):
    node_locker = self._node_locker
    if node_locker is not None:
      node_locker.unlock( node )
  def   __len__(self):
    return len(self._nodes)
  def   selfTest( self ):
    self._nodes.selfTest()
    if self._node_locker is not None:
      self._node_locker.selfTest()
  def   getNextNodes( self ):
    tails = self._nodes.popTails()
    if not tails:
      node_locker = self._node_locker
      if node_locker is not None:
        return node_locker.popUnlocked()
    return tails
  def   checkForceRebuild( self, node ):
    built_names = self._built_node_names
    if built_names is None:
      return False
    names = frozenset( node.getNames() )
    result = not names.issubset( built_names )
    built_names.update( names )
    return result
  def   actualNode( self, node ):
    self.unlockNode( node )
    self._nodes.removeTail( node )
    self.actual += 1
    node.shrink()
  def   completedNode( self, node, builder_output ):
    self._checkAlreadyBuilt( node )
    self.unlockNode( node )
    self._nodes.removeTail( node )
    self.completed += 1
    eventNodeBuildingFinished( node, builder_output, self.getProgressStr() )
    node.shrink()
  def   failedNode( self, node, error ):
    self.unlockNode( node )
    self._failed_nodes[ node ] = error
    eventNodeBuildingFailed( node, error )
  def   removedNode( self, node ):
    self._nodes.removeTail( node )
    self.completed += 1
    eventNodeRemoved( node, self.getProgressStr() )
    node.shrink()
  def   getProgressStr(self):
    done = self.completed + self.actual
    total = len(self._nodes) + done
    processed = done + len(self._failed_nodes)
    progress = "%s/%s" % (processed, total)
    return progress
  def   close( self ):
    self._nodes = _NodesTree()
  def   _checkAlreadyBuilt( self, node ):
    entities = node.getTargetEntities()
    built_targets = self._built_targets
    for entity in entities:
      entity_sign = entity.signature
      other_entity_sign = built_targets.setdefault( entity.id, entity_sign )
      if other_entity_sign != entity_sign:
        eventBuildTargetTwice( entity, node )
  def   shrink( self, nodes ):
    if not nodes:
      return
    self._nodes.shrinkTo( nodes )
  def   getNodes(self):
    return self._nodes.getNodes()
  def   build( self, jobs, keep_going, nodes = None, build_always = False, explain = False, with_backtrace = True, use_sqlite = False, force_lock = False):
    self.__reset( build_always = build_always, explain = explain )
    self.shrink( nodes )
    with _NodesBuilder( self, jobs, keep_going, with_backtrace, use_sqlite = use_sqlite, force_lock = force_lock ) as nodes_builder:
      while True:
        tails = self.getNextNodes()
        if not tails and not nodes_builder.isBuilding():
          break
        if not nodes_builder.build( tails ):
          break
    return self.isOk()
  def   isOk(self):
    return not bool( self._failed_nodes )
  def   failsCount(self):
    return len( self._failed_nodes )
  def   printFails(self ):
    for node, error in self._failed_nodes.items():
      eventFailedNode( node, error )
  def   printBuildState(self):
    logInfo("Failed nodes: %s" % len(self._failed_nodes) )
    logInfo("Completed nodes: %s" % self.completed )
    logInfo("Actual nodes: %s" % self.actual )
  def   clear( self, nodes = None, use_sqlite = False, force_lock = False ):
    self.__reset()
    self.shrink( nodes )
    with _NodesBuilder( self, use_sqlite = use_sqlite, force_lock = force_lock ) as nodes_builder:
      while True:
        tails = self.getNextNodes()
        if not tails:
          break
        nodes_builder.clear( tails )
class   ErrorDistCommandInvalid( Exception ):
  def   __init__( self, command ):
    msg = "distutils command '%s' is not supported" % (command,)
    super(ErrorDistCommandInvalid, self).__init__(msg)
def   _getMethodFullName( m ):
  full_name = []
  mod = getattr( m, '__module__', None )
  if mod:
    full_name.append( mod )
  name = getattr( m, '__qualname__', None )
  if name:
    full_name.append( name )
  else:
    cls = getattr( m, 'im_class', None )
    if cls is not None:
      cls_name = getattr( cls, '__name__', None )
      if cls_name:
        full_name.append( cls_name )
    name = getattr( m, '__name__', None )
    if name:
      full_name.append( name )
  return '.'.join( full_name )
class ExecuteCommandBuilder (Builder):
  NAME_ATTRS = ('targets','cwd')
  def   __init__(self, options, target = None, target_flag = None, cwd = None ):
    self.targets = [ self.getTargetFilePath( target ) for target in toSequence(target) ]
    self.target_flag = target_flag
    if cwd:
      cwd = self.getTargetDirPath( cwd )
    self.cwd = cwd 
  def   _getCmdTargets( self ):
    targets = self.targets
    prefix = self.target_flag
    if not prefix:
      return tuple(targets)
    prefix = prefix.lstrip()
    if not prefix:
      return tuple(targets)
    rprefix = prefix.rstrip()
    if prefix != rprefix:
      return tuple( itertools.chain( *((rprefix, target) for target in targets )) )
    return tuple( "%s%s" % (prefix, target) for target in targets ) 
  def   build( self, source_entities, targets ):
    cmd = tuple( src.get() for src in source_entities)
    cmd_targets = self._getCmdTargets()
    if cmd_targets:
      cmd += cmd_targets
    out = self.execCmd( cmd, cwd = self.cwd )
    targets.addFiles( self.targets )
    return out
  def   getTargetEntities( self, source_entities ):
    return self.targets
  def   getTraceName(self, source_entities, brief ):
    try:
      return source_entities[0]
    except Exception:
      return self.__class__.__name__
  def   getTraceSources( self, source_entities, brief ):
    return source_entities[1:]
class   ExecuteMethodBuilder (Builder):
  NAME_ATTRS = ('method_name',)
  SIGNATURE_ATTRS = ('args','kw')
  def __init__(self, options, method, args, kw, single, make_files, clear_targets ):
    self.method_name = _getMethodFullName( method )
    self.method = method
    self.args = args if args else []
    self.kw = kw if kw else {}
    if not clear_targets:
      self.clear = lambda target_entities, side_effect_entities: None
    if single:
      self.split = self.splitSingle
    if make_files:
      self.makeEntity = self.makeFileEntity
  def build( self, source_entities, targets ):
    return self.method( self, source_entities, targets, *self.args, **self.kw )
  def   getTraceName( self, source_entities, brief ):
    name = self.method_name
    if not brief:
      args = ''
      if self.args:
        args = ','.join( self.args )
      if self.kw:
        if args:
          args += ','
        args += ','.join( "%s=%s" % (k,v) for k,v in self.kw.items() )
      if args:
       return "%s(%s)" % (name, args)
    return name
class CopyFilesBuilder (FileBuilder):
  NAME_ATTRS = ['target']
  def   __init__(self, options, target ):
    self.target = self.getTargetDirPath( target )
    self.split = self.splitBatch
  def   buildBatch( self, source_entities, targets ):
    target = self.target
    for src_entity in source_entities:
      src = src_entity.get()
      dst = os.path.join( target, os.path.basename( src ) )
      shutil.copyfile( src, dst )
      shutil.copymode( src, dst )
      targets[src_entity].add( dst )
  def   getTraceName( self, source_entities, brief ):
    return "Copy files"
  def   getTargetEntities( self, source_entities ):
    src = source_entities[0].get()
    return ( os.path.join( self.target, os.path.basename(src) ), )
class CopyFileAsBuilder (FileBuilder):
  NAME_ATTRS = ['target']
  def   __init__(self, options, target ):
    self.target = self.getTargetFilePath( target )
  def   build( self, source_entities, targets ):
    source = source_entities[0].get()
    target = self.target
    shutil.copyfile( source, target )
    shutil.copymode( source, target )
    targets.add( target )
  def   getTraceName(self, source_entities, brief ):
    return "Copy file"
  def   getTargetEntities( self, source_entities ):
    return self.target
class TarFilesBuilder (FileBuilder):
  NAME_ATTRS = ['target']
  SIGNATURE_ATTRS = ['rename', 'basedir']
  def   __init__(self, options, target, mode, rename, basedir, ext ):
    if not mode:
      mode = "w:bz2"
    if not ext:
      if mode == "w:bz2":
        ext = ".tar.bz2"
      elif mode == "w:gz":
        ext = ".tar.gz"
      elif mode == "w":
        ext = ".tar"
    self.target = self.getTargetFilePath( target, ext )
    self.mode = mode
    self.rename = rename if rename else tuple()
    self.basedir = os.path.normcase(os.path.normpath(basedir)) if basedir else None
  def __getArcname( self, file_path ):
    for arc_name, path in self.rename:
      if file_path == path:
        return arc_name
    basedir = self.basedir
    if basedir:
      if file_path.startswith( basedir ):
        return file_path[ len(basedir) : ]
    return os.path.basename( file_path )
  def   __addFile( self, arch, filepath ):
    arcname = self.__getArcname( filepath )
    arch.add( filepath, arcname )
  @staticmethod
  def   __addEntity( arch, entity ):
    arcname = entity.name
    data = entity.get()
    if isUnicode( data ):
      data = encodeStr( data )
    tinfo = tarfile.TarInfo(arcname)
    tinfo.size = len(data)
    arch.addfile( tinfo, io.BytesIO(data) )
  def   build( self, source_entities, targets ):
    target = self.target
    arch = tarfile.open( name = self.target, mode = self.mode )
    try:
      for entity in source_entities:
        if isinstance( entity, FileEntityBase ):
          self.__addFile( arch, entity.get() )
        else:
          self.__addEntity( arch, entity )
    finally:
      arch.close()
    targets.add( target )
  def   getTraceName(self, source_entities, brief ):
    return "Create Tar"
  def   getTargetEntities( self, source_entities ):
    return self.target
class ZipFilesBuilder (FileBuilder):
  NAME_ATTRS = ['target']
  SIGNATURE_ATTRS = ['rename', 'basedir']
  def   __init__(self, options, target, rename, basedir, ext ):
    if ext is None:
      ext = ".zip"
    self.target = self.getTargetFilePath( target, ext = ext )
    self.rename = rename if rename else tuple()
    self.basedir = os.path.normcase(os.path.normpath(basedir)) if basedir else None
  def   __openArch( self, large = False ):
    try:
      return zipfile.ZipFile( self.target, "w", zipfile.ZIP_DEFLATED, large )
    except RuntimeError:
      pass
    return zipfile.ZipFile( self.target, "w", zipfile.ZIP_STORED, large )
  def __getArcname( self, file_path ):
    for arc_name, path in self.rename:
      if file_path == path:
        return arc_name
    basedir = self.basedir
    if basedir:
      if file_path.startswith( basedir ):
        return file_path[ len(basedir) : ]
    return os.path.basename( file_path )
  def   __addFiles( self, arch, source_entities ):
    for entity in source_entities:
      if isinstance( entity, FileEntityBase ):
        filepath = entity.get()
        arcname = self.__getArcname( filepath )
        arch.write( filepath, arcname )
      else:
        arcname = entity.name
        data = entity.get()
        if isUnicode( data ):
          data = encodeStr( data )
        arch.writestr( arcname, data )
  def   build( self, source_entities, targets ):
    target = self.target
    arch = self.__openArch()
    try:
      self.__addFiles( arch, source_entities )
    except zipfile.LargeZipFile:
      arch.close()
      arch = None
      arch = self.__openArch( large = True )
      self.__addFiles( arch, source_entities )
    finally:
      if arch is not None:
        arch.close()
    targets.add( target )
  def   getTraceName(self, source_entities, brief ):
    return "Create Zip"
  def   getTargetEntities( self, source_entities ):
    return self.target
class WriteFileBuilder (Builder):
  NAME_ATTRS = ['target']
  def   __init__(self, options, target, binary = False, encoding = None ):
    self.binary = binary
    self.encoding = encoding
    self.target = self.getTargetFilePath( target )
  def   build( self, source_entities, targets ):
    target = self.target
    with openFile( target, write = True, binary = self.binary, encoding = self.encoding ) as f:
      f.truncate()
      for src in source_entities:
        src = src.get()
        if self.binary:
          if isUnicode( src ):
            src = encodeStr( src, self.encoding )
        else:
          if isinstance( src, (bytearray, bytes) ):
            src = decodeBytes( src, self.encoding )
        f.write( src )
    targets.addFiles( target )
  def   getTraceName(self, source_entities, brief ):
    return "Writing content"
  def   getTargetEntities( self, source_entities ):
    return self.target
class DistBuilder (FileBuilder):
  NAME_ATTRS = ('target', 'command', 'formats')
  SIGNATURE_ATTRS = ('script_args', )
  def   __init__(self, options, command, args, target ):
    target = self.getTargetDirPath( target )
    script_args = [ command ]
    if command.startswith('bdist'):
      temp_dir = self.getBuildPath()
      script_args += [ '--bdist-base', temp_dir ]
    elif command != 'sdist':
      raise ErrorDistCommandInvalid( command )
    formats = set()
    if args:
      if isString( args ):
        args = args.split()
      else:
        args = toSequence( args )
      script_args += args
      for arg in args:
        if command.startswith('bdist'):
          if arg.startswith( '--formats=' ):
            v = arg[len('--formats='):].split(',')
            formats.update( v )
          elif arg.startswith( '--plat-name=' ):
            v = arg[len('--plat-name='):]
            formats.add( v )
    script_args += [ '--dist-dir', target ]
    self.command = command
    self.target = target
    self.script_args = script_args
    self.formats = formats
  def   getTraceName(self, source_entities, brief ):
    return "distutils %s" % ' '.join(self.script_args)
  def   build( self, source_entities, targets ):
    script = source_entities[0].get()
    cmd = [ sys.executable, script ]
    cmd += self.script_args
    script_dir = os.path.dirname( script )
    out = self.execCmd( cmd, script_dir )
    return out
class   InstallDistBuilder (FileBuilder):
  NAME_ATTRS = ('user',)
  def   __init__(self, options, user ):
    self.user = user
  def   getTraceName(self, source_entities, brief ):
    return "distutils install"
  def   build( self, source_entities, targets ):
    script = source_entities[0].get()
    cmd = [ sys.executable, script, "install" ]
    if self.user:
      cmd.append( "--user" )
    script_dir = os.path.dirname( script )
    out = self.execCmd( cmd, script_dir )
    return out
class BuiltinTool( Tool ):
  def   ExecuteCommand( self, options, target = None, target_flag = None, cwd = None ):
    return ExecuteCommandBuilder( options, target = target, target_flag = target_flag, cwd = cwd )
  Command = ExecuteCommand
  def   ExecuteMethod( self, options, method, args = None, kw = None, single = True, make_files = True, clear_targets = True):
    return ExecuteMethodBuilder( options, method = method, args = args, kw = kw, single = single, make_files = make_files, clear_targets = clear_targets )
  Method = ExecuteMethod
  def   CopyFiles(self, options, target ):
    return CopyFilesBuilder( options, target )
  def   CopyFileAs(self, options, target ):
    return CopyFileAsBuilder( options, target )
  def   WriteFile(self, options, target, binary = False, encoding = None ):
    return WriteFileBuilder( options, target, binary = binary, encoding = encoding )
  def   CreateDist( self, options, target, command, args = None ):
    return DistBuilder( options, target = target, command = command, args = args )
  def   InstallDist( self, options, user = True ):
    return InstallDistBuilder( options, user = user )
  def   CreateZip(self, options, target, rename = None, basedir = None, ext = None ):
    return ZipFilesBuilder( options, target = target, rename = rename, basedir = basedir, ext = ext )
  def   CreateTar(self, options, target, mode = None, rename = None, basedir = None, ext = None ):
    return TarFilesBuilder( options, target = target, mode = mode, rename = rename, basedir = basedir, ext = ext )
class   ErrorProjectInvalidMethod( AqlException ):
  def   __init__( self, method ):
    msg = "Invalid project method: '%s'" % (method,)
    super(type(self), self).__init__( msg )
class   ErrorProjectUnknownTarget( AqlException ):
  def   __init__( self, target ):
    msg = "Unknown build target: '%s'" % (target,)
    super(type(self), self).__init__( msg )
class   ErrorProjectBuilderMethodWithKW( AqlException ):
  def   __init__( self, method ):
    msg = "Keyword arguments are not allowed in builder method: '%s'" % (method,)
    super(type(self), self).__init__( msg )
class   ErrorProjectBuilderMethodUnbound( AqlException ):
  def   __init__( self, method ):
    msg = "Unbound builder method: '%s'" % (method,)
    super(type(self), self).__init__( msg )
class   ErrorProjectBuilderMethodFewArguments( AqlException ):
  def   __init__( self, method ):
    msg = "Too few arguments in builder method: '%s'" % (method,)
    super(type(self), self).__init__( msg )
class   ErrorProjectBuilderMethodInvalidOptions( AqlException ):
  def   __init__( self, value ):
    msg = "Type of 'options' argument must be Options, instead of : '%s'(%s)" % (type(value), value)
    super(type(self), self).__init__( msg )
def   _getUserConfigDir():
  return os.path.join( os.path.expanduser('~'), '.config' )
def   _getSitePackagesDirs():
  try:
    return site.getsitepackages()
  except Exception:
    pass
  local_path = os.path.normcase( os.path.expanduser('~') )
  paths = []
  for path in sys.path:
    path = os.path.normcase( path )
    if path.endswith('-packages') and not path.startswith( local_path ):
      paths.append( path )
  try:
    from distutils.sysconfig import get_python_lib
    lib_path = get_python_lib()
    if lib_path not in paths:
      paths.append( lib_path )
  except Exception:
    pass
  return paths
def   _getAqualidInstallDir():
  try:
    import aql
    return os.path.dirname( aql.__file__ )
  except Exception:
    return None
def   _getDefaultToolsPath( info = getAqlInfo() ):
  aql_module_name = info.module
  tool_dirs = _getSitePackagesDirs()
  tool_dirs += ( site.USER_SITE, _getUserConfigDir() )
  tool_dirs = [ os.path.join( path, aql_module_name ) for path in tool_dirs]
  aql_dir = _getAqualidInstallDir()
  if aql_dir:
    tool_dirs.insert( -2, aql_dir ) # insert before the local tools
  tool_dirs = [ os.path.join( path, 'tools') for path in tool_dirs ]
  return tool_dirs
def   _readConfig( config_file, cli_config, options, tools_path ):
  cli_config.readConfig( config_file, { 'options': options })
  if cli_config.tools_path:
    tools_path.extend( cli_config.tools_path )
    cli_config.tools_path = None
class ProjectConfig( object ):
  __slots__ = ('directory', 'makefile', 'targets', 'options', 'arguments',
               'verbose', 'silent', 'no_output', 'jobs', 'keep_going', 'search_up', 'tools_path', 'no_tool_errors',
               'build_always', 'clean', 'list_options', 'list_tool_options', 'list_targets',
               'debug_profile', 'debug_profile_top', 'debug_memory', 'debug_explain', 'debug_backtrace',
               'debug_exec',
               'use_sqlite', 'force_lock',
               'show_version',
  )
  def   __init__( self, args = None ):
    CLI_USAGE = "usage: %prog [FLAGS] [[TARGET] [OPTION=VALUE] ...]"
    Paths = ValueListType( UniqueList, FilePath )
    Strings = ValueListType( UniqueList, str )
    CLI_OPTIONS = (
      CLIOption( "-C", "--directory",         "directory",          FilePath,   '',           "Change directory before reading the make files.", 'FILE PATH'),
      CLIOption( "-f", "--makefile",          "makefile",           FilePath,   'make.aql',   "Path to a make file.", 'FILE PATH'),
      CLIOption( "-l", "--list-options",      "list_options",       bool,       False,        "List current options and exit." ),
      CLIOption( "-L", "--list-tool-options", "list_tool_options",  Strings,    [],           "List tool options and exit.", "TOOL_NAME" ),
      CLIOption( "-t", "--list-targets",      "list_targets",       bool,       False,        "List all available targets and exit." ),
      CLIOption( "-c", "--config",            "config",             FilePath,   None,         "The configuration file used to read CLI arguments." ),
      CLIOption( "-B", "--always",            "build_always",       bool,       False,        "Unconditionally build all targets." ),
      CLIOption( "-R", "--clean",             "clean",              bool,       False,        "Cleans targets." ),
      CLIOption( "-u", "--up",                "search_up",          bool,       False,        "Search up directory tree for a make file." ),
      CLIOption( "-e", "--no-tool-errors",    "no_tool_errors",     bool,       False,        "Stop on any error during initialization of tools." ),
      CLIOption( "-I", "--tools-path",        "tools_path",         Paths,      [],           "Path to tools and setup scripts.", 'FILE PATH, ...'),
      CLIOption( "-k", "--keep-going",        "keep_going",         bool,       False,        "Keep going when some targets can't be built." ),
      CLIOption( "-j", "--jobs",              "jobs",               int,        None,         "Number of parallel jobs to process targets.", 'NUMBER' ),
      CLIOption( "-v", "--verbose",           "verbose",            bool,       False,        "Verbose mode." ),
      CLIOption( "-s", "--silent",            "silent",             bool,       False,        "Don't print any messages except warnings and errors." ),
      CLIOption( None, "--no-output",         "no_output",          bool,       False,        "Don't print builder's output messages." ),
      CLIOption( None, "--debug-memory",      "debug_memory",       bool,       False,        "Display memory usage." ),
      CLIOption( "-P", "--debug-profile",     "debug_profile",      FilePath,   None,         "Run under profiler and save the results in the specified file.", 'FILE PATH' ),
      CLIOption( "-T", "--debug-profile-top", "debug_profile_top",  int,        30,           "Show the specified number of top functions from profiler report.", 'FILE PATH' ),
      CLIOption( None, "--debug-explain",     "debug_explain",      bool,       False,        "Show the reasons why targets are being rebuilt" ),
      CLIOption( None, "--debug-exec",        "debug_exec",         bool,       False,        "Full trace of all executed commands." ),
      CLIOption( "--bt", "--debug-backtrace", "debug_backtrace",    bool,       False,        "Show call stack back traces for errors." ),
      CLIOption( None, "--force-lock",        "force_lock",         bool,       False,        "Forces to lock AQL DB file." ),
      CLIOption( None, "--use-sqlite",        "use_sqlite",         bool,       False,        "Use SQLite DB." ),
      CLIOption( "-V", "--version",           "version",            bool,       False,        "Show version and exit." ),
    )
    cli_config = CLIConfig( CLI_USAGE, CLI_OPTIONS, args )
    options = builtinOptions()
    tools_path = _getDefaultToolsPath()
    cli_tools_path = cli_config.tools_path
    cli_config.tools_path = None
    user_config = os.path.join( _getUserConfigDir(), 'default.cfg' )
    if os.path.isfile( user_config ):
      _readConfig( user_config, cli_config, options, tools_path )
    config = cli_config.config
    if config:
      _readConfig( config, cli_config, options, tools_path )
    if cli_tools_path:
      tools_path.extend( cli_tools_path )
    arguments = {}
    ignore_options = set( ProjectConfig.__slots__ )
    ignore_options.add( 'config' )
    for name,value in cli_config.items():
      if (name not in ignore_options) and (value is not None):
        arguments[ name ] = value
    options.update( arguments )
    self.options            = options
    self.arguments          = arguments
    self.directory          = os.path.abspath( cli_config.directory )
    self.makefile           = cli_config.makefile
    self.search_up          = cli_config.search_up
    self.tools_path         = tools_path
    self.no_tool_errors     = cli_config.no_tool_errors
    self.targets            = cli_config.targets
    self.verbose            = cli_config.verbose
    self.silent             = cli_config.silent
    self.show_version       = cli_config.version
    self.no_output          = cli_config.no_output
    self.keep_going         = cli_config.keep_going
    self.build_always       = cli_config.build_always
    self.clean              = cli_config.clean
    self.list_options       = cli_config.list_options
    self.list_tool_options  = cli_config.list_tool_options
    self.list_targets       = cli_config.list_targets
    self.jobs               = cli_config.jobs
    self.force_lock         = cli_config.force_lock
    self.use_sqlite         = cli_config.use_sqlite
    self.debug_profile      = cli_config.debug_profile
    self.debug_profile_top  = cli_config.debug_profile_top
    self.debug_memory       = cli_config.debug_memory
    self.debug_explain      = cli_config.debug_explain
    self.debug_backtrace    = cli_config.debug_backtrace
    self.debug_exec         = cli_config.debug_exec
class BuilderWrapper( object ):
  __slots__ = ( 'project', 'options', 'method', 'arg_names' )
  def   __init__( self, method, project, options ):
    self.arg_names  = self.__checkBuilderMethod( method )
    self.method     = method
    self.project    = project
    self.options    = options
  @staticmethod
  def   __checkBuilderMethod( method ):
    if not hasattr(method, '__call__'):
      raise ErrorProjectInvalidMethod( method )
    f_args, f_varargs, f_kw, f_defaults = getFunctionArgs( method )
    if f_kw:
      raise ErrorProjectBuilderMethodWithKW( method )
    min_args = 1  # at least one argument: options
    if isinstance( method, types.MethodType ):
      if method.__self__ is None:
        raise ErrorProjectBuilderMethodUnbound( method )
    if len(f_args) < min_args:
      raise ErrorProjectBuilderMethodFewArguments( method )
    return frozenset( f_args )
  def   __getOptionsAndArgs( self, kw ):
    args_kw = {}
    sources = []
    deps = []
    options = kw.pop("options", None )
    if options is not None:
      if not isinstance( options, Options ):
        raise ErrorProjectBuilderMethodInvalidOptions( options )
    else:
      options = self.options
    options = options.override()
    for name, value in kw.items():
      if name in ['sources', 'source']:
        sources += toSequence( value )
      else:
        for v in toSequence( value ):
          if isinstance( v, (Node, NodeFilter, EntityBase) ):
            deps.append( v )
        if name in self.arg_names:
          args_kw[ name ] = value
        else:
          options.appendValue( name, value, iUpdateValue )
    return options, deps, sources, args_kw
  def   __call__( self, *args, **kw ):
    options, deps, sources, args_kw = self.__getOptionsAndArgs( kw )
    sources += args
    sources = flattenList( sources )
    builder = self.method( options, **args_kw )
    node = Node( builder, sources )
    node.depends( deps )
    self.project.AddNodes( (node,) )
    return node
class ToolWrapper( object ):
  def   __init__( self, tool, project, options ):
    self.project = project
    self.options = options
    self.tool = tool
  def   __getattr__( self, attr ):
    method = getattr( self.tool, attr )
    if attr.startswith('_') or not isinstance( method, types.MethodType ):
      return method
    builder = BuilderWrapper( method, self.project, self.options )
    setattr( self, attr, builder )
    return builder
class ProjectTools( object ):
  def   __init__( self, project ):
    self.project = project
    self.tools_cache = {}
    tools = getToolsManager()
    tools.loadTools( self.project.config.tools_path )
    self.tools = tools
  def   _getToolsOptions(self):
    tools_options = {}
    for name, tool in self.tools_cache.items():
      tool = next(iter(tool.values()))
      tools_options.setdefault( tool.options, []).append( name )
    return tools_options
  def   _getToolNames(self):
    return sorted( self.tools_cache )
  def   __addTool( self, tool_name, options ):
    options_ref = options.getHashRef()
    try:
      return self.tools_cache[ tool_name ][options_ref]
    except KeyError:
      pass
    project = self.project
    tool, tool_names, tool_options = self.tools.getTool( tool_name, options, project.config.no_tool_errors )
    tool = ToolWrapper( tool, project, tool_options )
    attrs = self.__dict__
    for name in tool_names:
      attrs.setdefault( name, tool )
      self.tools_cache.setdefault( name, {} )[ options_ref ] = tool
    return tool
  def   __getattr__( self, name ):
    options = self.project.options
    tool = BuiltinTool( options )
    tool_method = getattr( tool, name, None )
    if tool_method and isinstance( tool_method, (types.FunctionType, types.MethodType) ):
      return BuilderWrapper( tool_method, self.project, options )
    return self.__addTool( name, options )
  def __getitem__( self, name ):
    return getattr( self, name )
  def   Tools( self, *tool_names, **kw ):
    options = kw.pop( 'options', None )
    tools_path = kw.pop('tools_path', None )
    if tools_path:
      self.tools.loadTools( tools_path )
    if options is None:
      options = self.project.options
    if kw:
      options = options.override()
      options.update( kw )
    tools = [ self.__addTool( tool_name, options ) for tool_name in tool_names ]
    return tools
  def   Tool( self, tool_name, **kw ):
    return self.Tools( tool_name, **kw )[0]
  def   AddTool( self, tool_class, tool_names = tuple() ):
    self.tools.addTool( tool_class, tool_names )
    return self.__addTool( tool_class, self.project.options )
def   _textTargets( targets ):
  text = ["","  Targets:", "==================", ""]
  max_name = ""
  for names, is_built, description in targets:
    max_name = max( max_name, *names, key = len )
  name_format = "{is_built} {name:<%s}" % len(max_name)
  for names, is_built, description in targets:
    if len(names) > 1 and text[-1]:
      text.append('')
    is_built_mark = "*" if is_built else " "
    for name in names:
      text.append( name_format.format( name = name, is_built = is_built_mark ))
    text[-1] += ' :  ' + description
    if len(names) > 1:
      text.append('')
  text.append('')
  return text
class Project( object ):
  def   __init__( self, config ):
    self.targets = config.targets
    self.options = config.options
    self.arguments = config.arguments
    self.config = config
    self.scripts_cache = {}
    self.configs_cache = {}
    self.aliases = {}
    self.alias_descriptions = {}
    self.defaults = []
    self.build_manager = BuildManager()
    self.tools = ProjectTools( self )
  def   __getattr__( self, attr ):
    if attr == 'script_locals':
      self.script_locals = self.__getSciptLocals()
      return self.script_locals
    raise AttributeError("No attribute '%s'" % (attr,) )
  def   __getSciptLocals( self ):
    script_locals = {
      'options'   : self.options,
      'tools'     : self.tools,
      'Tool'      : self.tools.Tool,
      'Tools'     : self.tools.Tools,
      'AddTool'   : self.tools.AddTool,
      'LoadTools' : self.tools.tools.loadTools,
      'FindFiles' : findFiles
    }
    for name in dir(self):
      if name.startswith('_'):
        continue
      member = getattr( self, name )
      if isinstance( member, types.MethodType ):
        script_locals.setdefault( name, member )
    return script_locals
  def   GetProject(self):
    return self
  def   GetBuildTargets(self):
    return self.targets
  def   File(self, filepath, options = None ):
    if options is None:
      options = self.options
    file_type = FileTimestampEntity if options.file_signature == 'timestamp' else FileChecksumEntity
    return file_type( filepath )
  def   Dir( self, filepath ):
    return DirEntity( filepath )
  def   Entity( self, data, name = None ):
    return SimpleEntity( data = data, name = name )
  def   Config( self, config, options = None ):
    config = os.path.normcase( os.path.abspath( config ) )
    if options is None:
      options = self.options
    options_ref = options.getHashRef()
    options_set = self.configs_cache.setdefault( config, set() )
    if options_ref in options_set:
      return
    config_locals = { 'options': options }
    with Chdir( os.path.dirname( config ) ):
      result = execFile( config, config_locals )
    for arg in self.arguments:
      try:
        del result[ arg ]
      except KeyError:
        pass
    tools_path = result.pop( 'tools_path', None )
    if tools_path:
      self.tools.tools.loadTools( tools_path )
    options.update( result )
    options_set.add( options_ref )
  def   Script( self, script ):
    script = os.path.normcase( os.path.abspath( script ) )
    scripts_cache = self.scripts_cache
    script_result = scripts_cache.get( script, None )
    if script_result is not None:
      return script_result
    with Chdir( os.path.dirname( script ) ):
      script_result = execFile( script, self.script_locals )
    scripts_cache[ script ] = script_result
    return script_result
  def   AddNodes( self, nodes ):
    self.build_manager.add( nodes )
  def   SetBuildDir( self, build_dir ):
    build_dir = os.path.abspath( expandFilePath( build_dir ) )
    if self.options.build_dir != build_dir:
      self.options.build_dir = build_dir
  def   Depends( self, nodes, dependencies ):
    dependencies = tuple(toSequence( dependencies ))
    for node in toSequence( nodes ):
      node.depends( dependencies )
      self.build_manager.depends( node, node.dep_nodes )
  def   Requires( self, nodes, dependencies ):
    dependencies = tuple( dep for dep in toSequence( dependencies ) if isinstance( dep, Node ) )
    depends = self.build_manager.depends
    for node in toSequence( nodes ):
      depends( node, dependencies )
  def   RequireModules( self, nodes, dependencies ):
    dependencies = tuple( dep for dep in toSequence( dependencies ) if isinstance( dep, Node ) )
    moduleDepends = self.build_manager.moduleDepends
    for node in toSequence( nodes ):
      moduleDepends( node, dependencies )
  def   Sync( self, *nodes ):
    nodes = flattenList( nodes )
    nodes = tuple( node for node in nodes if isinstance( node, Node ) )
    self.build_manager.sync( nodes )
  def   Alias( self, alias, nodes, description = None ):
    for alias, node in itertools.product( toSequence( alias ), toSequence( nodes ) ):
      self.aliases.setdefault( alias, set()).add( node )
      if description:
        self.alias_descriptions[ alias ] = description
  def   Default( self, nodes ):
    for node in toSequence( nodes ):
      self.defaults.append( node )
  def   AlwaysBuild( self, nodes ):
    null_value = NullEntity()
    for node in toSequence( nodes ):
      node.depends( null_value )
  def   _addAliasNodes(self, target_nodes, aliases ):
    try:
      for alias in aliases:
        target_nodes.update( self.aliases[ alias ] )
    except KeyError as ex:
      raise ErrorProjectUnknownTarget( ex.args[0] )
  def   _addDefaultNodes( self, target_nodes ):
    for node in self.defaults:
      if isinstance( node, Node ):
        target_nodes.add( node )
      else:
        self._addAliasNodes( target_nodes, (node,) )
  def   _getBuildNodes( self ):
    target_nodes = set()
    self._addAliasNodes( target_nodes, self.targets )
    if not target_nodes:
      self._addDefaultNodes( target_nodes )
    if not target_nodes:
      target_nodes = None
    return target_nodes
  def   Build( self, jobs = None ):
    config = self.config
    if jobs is None:
      jobs = config.jobs
    if not jobs:
      jobs = 0
    else:
      jobs = int(jobs)
    if not jobs:
      jobs = cpuCount()
    if jobs < 0:
      jobs = 1
    elif jobs > 32:
      jobs = 32
    if not self.options.batch_groups.isSet():
      self.options.batch_groups = jobs
    build_nodes = self._getBuildNodes()
    keep_going     = config.keep_going,
    build_always   = config.build_always
    explain        = config.debug_explain
    with_backtrace = config.debug_backtrace
    force_lock     = config.force_lock
    use_sqlite     = config.use_sqlite
    is_ok = self.build_manager.build( jobs = jobs, keep_going = bool(keep_going), nodes = build_nodes,
                                      build_always = build_always, explain = explain,
                                      with_backtrace = with_backtrace,
                                      use_sqlite = use_sqlite, force_lock = force_lock )
    return is_ok
  def Clear( self ):
    build_nodes = self._getBuildNodes()
    force_lock     = self.config.force_lock
    use_sqlite     = self.config.use_sqlite
    self.build_manager.clear( nodes = build_nodes, use_sqlite = use_sqlite, force_lock = force_lock )
  def ListTargets( self ):
    targets = []
    node2alias = {}
    for alias, nodes in self.aliases.items():
      key = frozenset(nodes)
      target_info = node2alias.setdefault( key, [[],""])
      target_info[0].append( alias )
      description = self.alias_descriptions.get( alias, None )
      if description:
        if len(target_info[1]) < len(description):
          target_info[1] = description
    build_nodes = self._getBuildNodes()
    self.build_manager.shrink( build_nodes )
    build_nodes = self.build_manager.getNodes()
    for nodes, aliases_and_description in node2alias.items():
      aliases, description = aliases_and_description
      aliases.sort( key = str.lower )
      max_alias = max( aliases, key = len )
      aliases.remove( max_alias )
      aliases.insert( 0, max_alias )
      is_built = (build_nodes is None) or nodes.issubset( build_nodes )
      targets.append( (tuple(aliases), is_built, description) )
    targets.sort( key = lambda aliases: aliases[0][0].lower() )
    return _textTargets(targets)
  def   ListOptions( self, brief = False ):
    result = self.options.helpText( "Builtin options:", brief = brief )
    result.append("")
    tool_names = self.tools._getToolNames()
    if tool_names:
      result.append("Available options of tools: %s" % (', '.join(tool_names)) )
    if result[-1]:
      result.append("")
    return result
  def   ListToolsOptions( self, tools, brief = False ):
    tools = set( toSequence( tools ) )
    result = []
    for tools_options, names in self.tools._getToolsOptions().items():
      names_set = tools & set(names)
      if names_set:
        tools -= names_set
        options_name = "Options of tool: %s" % (', '.join( names ) )
        result += tools_options.helpText( options_name, brief = brief)
    if result and result[-1]:
      result.append("")
    return result
  def   DirName( self, node ):
    return NodeDirNameFilter( node )
  def   BaseName( self, node ):
    return NodeBaseNameFilter( node )
@eventStatus
def   eventReadingScripts( settings ):
  logInfo("Reading scripts..." )
@eventStatus
def   eventReadingScriptsDone( settings, elapsed ):
  logInfo("Reading scripts finished (%s)" % elapsed)
@eventError
def   eventAqlError( settings, error ):
  logError( error )
@eventStatus
def   eventBuilding( settings ):
  logInfo("Building targets...")
@eventStatus
def   eventBuildingDone( settings, success, elapsed ):
  status = "finished" if success else "failed"
  logInfo("Building targets %s (%s)" % (status, elapsed))
@eventStatus
def   eventBuildSummary( settings, elapsed ):
  logInfo("Total time: %s" % elapsed)
def   _findMakeScript( script ):
  if os.path.isabs( script ):
    return script
  cwd = splitPath( os.path.abspath('.') )
  path_sep = os.path.sep
  while cwd:
    script_path = path_sep.join( cwd ) + path_sep + script
    if os.path.isfile( script_path ):
      return os.path.normpath( script_path )
    cwd.pop()
  return script
def   _startMemoryTracing():
  try:
    import tracemalloc
  except ImportError:
    return
  tracemalloc.start()
def   _stopMemoryTracing():
  try:
    import tracemalloc
  except ImportError:
    return
  snapshot = tracemalloc.take_snapshot()
  _logMemoryTop( snapshot )
  tracemalloc.stop()
def _logMemoryTop( snapshot, group_by = 'lineno', limit = 30 ):
  try:
    import tracemalloc
    import linecache
  except ImportError:
    return
  snapshot = snapshot.filter_traces((
      tracemalloc.Filter(False, "<frozen importlib._bootstrap>"),
      tracemalloc.Filter(False, "<unknown>"),
  ))
  top_stats = snapshot.statistics( group_by )
  logInfo("Top %s lines" % limit)
  for index, stat in enumerate(top_stats[:limit], 1):
      frame = stat.traceback[0]
      filename = os.sep.join(frame.filename.split(os.sep)[-2:])
      logInfo("#%s: %s:%s: %.1f KiB"
            % (index, filename, frame.lineno, stat.size / 1024))
      line = linecache.getline(frame.filename, frame.lineno).strip()
      if line:
          logInfo('    %s' % line)
  other = top_stats[limit:]
  if other:
      size = sum(stat.size for stat in other)
      logInfo("%s other: %.1f KiB" % (len(other), size / 1024))
  total = sum(stat.size for stat in top_stats)
  logInfo("Total allocated size: %.1f KiB" % (total / 1024))
def _printMemoryStatus():
  _stopMemoryTracing()
  mem_usage = memoryUsage()
  num_objects = len(gc.get_objects())
  obj_mem_usage = sum( sys.getsizeof(obj) for obj in gc.get_objects() )
  logInfo("GC objects: %s, size: %.1f KiB, heap memory usage: %s Kb" % (num_objects, obj_mem_usage / 1024, mem_usage))
def   _setBuildDir( options, makefile ):
    build_dir = options.build_dir.get()
    if os.path.isabs( build_dir ):
      return
    makefile_dir = os.path.abspath( os.path.dirname( makefile ) )
    options.build_dir = os.path.join( makefile_dir, build_dir )
def   _main( prj_cfg ):
  with Chrono() as total_elapsed:
    ev_settings = EventSettings( brief = not prj_cfg.verbose,
                                 with_output = not prj_cfg.no_output,
                                 trace_exec = prj_cfg.debug_exec )
    setEventSettings( ev_settings )
    with Chdir( prj_cfg.directory ):
      if prj_cfg.debug_memory:
        _startMemoryTracing()
      makefile = expandFilePath( prj_cfg.makefile )
      if prj_cfg.search_up:
        makefile = _findMakeScript( makefile )
      _setBuildDir( prj_cfg.options, makefile )
      prj = Project( prj_cfg )
      eventReadingScripts()
      with Chrono() as elapsed:
        prj.Script( makefile )
      eventReadingScriptsDone( elapsed )
      success = True
      if prj_cfg.clean:
        prj.Clear()
      elif prj_cfg.list_targets:
        text = prj.ListTargets()
        logInfo( '\n'.join( text ) )
      elif prj_cfg.list_options or prj_cfg.list_tool_options:
        text = []
        if prj_cfg.list_options:
          text += prj.ListOptions( brief = not prj_cfg.verbose )
        if prj_cfg.list_tool_options:
          text += prj.ListToolsOptions( prj_cfg.list_tool_options, brief = not prj_cfg.verbose )
        logInfo( '\n'.join( text ) )
      else:
        eventBuilding()
        with elapsed:
          success = prj.Build()
        eventBuildingDone( success, elapsed )
        if not success:
          prj.build_manager.printFails()
      if prj_cfg.debug_memory:
        _printMemoryStatus()
  eventBuildSummary( total_elapsed )
  status = int(not success)
  return status
def _patchSysModules():
    aql_module = sys.modules.get( 'aql', None )
    if aql_module is not None:
      sys.modules.setdefault( getAqlInfo().module, aql_module )
    else:
      aql_module = sys.modules.get( getAqlInfo().module, None )
      if aql_module is not None:
        sys.modules.setdefault( 'aql', aql_module )
def   main():
  with_backtrace = True
  try:
    _patchSysModules()
    prj_cfg = ProjectConfig()
    with_backtrace = prj_cfg.debug_backtrace
    debug_profile = prj_cfg.debug_profile
    if prj_cfg.show_version:
      logInfo( dumpAqlInfo() )
      return 0
    if prj_cfg.silent:
      setLogLevel( LOG_WARNING )
    if not debug_profile:
      status = _main( prj_cfg )
    else:
      profiler = cProfile.Profile()
      status = profiler.runcall( _main, prj_cfg )
      profiler.dump_stats( debug_profile )
      p = pstats.Stats( debug_profile )
      p.strip_dirs()
      p.sort_stats('cumulative')
      p.print_stats( prj_cfg.debug_profile_top )
  except (Exception, KeyboardInterrupt) as ex:
    if with_backtrace:
      err = traceback.format_exc()
    else:
      if isinstance(ex, KeyboardInterrupt):
        err = "Keyboard Interrupt"
      else:
        err = toUnicode(ex)
    eventAqlError( err )
    status = 1
  return status


_AQL_VERSION_INFO.date = "2015-04-08"
if __name__ == '__main__':
  aql_module_globals = globals().copy()
  aql_module_name = "aql"
  aql_module = imp.new_module( aql_module_name )
  aql_module_globals.update( aql_module.__dict__ )
  aql_module.__dict__.update( aql_module_globals )
  sys.modules[ aql_module_name ] = aql_module

  sys.exit( main() )
